SystemOrganization addCategory: #Ecco!
SystemOrganization addCategory: #'Ecco-Algorithms'!
SystemOrganization addCategory: #'Ecco-Projects'!
SystemOrganization addCategory: #'Ecco-Ripples'!
SystemOrganization addCategory: #'Ecco-Tests'!
SystemOrganization addCategory: #'Ecco-Tools'!
SystemOrganization addCategory: #'Ecco-Transitions'!
SystemOrganization addCategory: #'Ecco-Web'!

!Bag methodsFor: '*ecco' stamp: 'RomainRobbes 8/16/2010 11:21'!
onceDo: aBlock 
	"Refer to the comment in Collection|do:."

	contents associationsDo: [:assoc | aBlock value: assoc key]! !

!MCPatch class methodsFor: '*Ecco' stamp: 'RomainRobbes 8/12/2010 15:35'!
empty
	^ self operations: #()! !

!String methodsFor: '*ecco' stamp: 'RomainRobbes 8/16/2010 11:26'!
isClassName
	^ self first isUppercase! !

!String methodsFor: '*ecco' stamp: 'RomainRobbes 8/18/2010 22:31'!
provided
	| rg |
	rg := EcoReferenceGatherer new.
	rg processSource: self .
	^ Array with: rg selector! !

!String methodsFor: '*ecco' stamp: 'RomainRobbes 8/18/2010 22:31'!
required
	| rg |
	rg := EcoReferenceGatherer new.
	rg processSource: self .
	^ rg selectors, rg classes! !

!PositionableStream methodsFor: '*Ecco' stamp: 'RomainRobbes 1/12/2010 09:47'!
readAnnouncing: announcement 
	"This is special for reading expressions from text that has been formatted 
	with exclamation delimitors. The expressions are read and passed to the 
	Compiler. Answer the result of compilation.  Put up a progress report with
     the given announcement as the title."

	| val chunk |
	announcement 
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: self size
		during: 
			[:bar | 
			[self atEnd] whileFalse: 
					[bar value: self position.
					self skipSeparators.
					
					[val := (self peekFor: $!!) 
								ifTrue: [(Compiler evaluate: self nextChunk logged: false) scanFrom: self]
								ifFalse: 
									[chunk := self nextChunk.
									self checkForPreamble: chunk.
									Compiler evaluate: chunk logged: true]] 
							on: InMidstOfFileinNotification
							do: [:ex | ex resume: true].
					self skipStyleChunk].
			self close].
	"Note:  The main purpose of this banner is to flush the changes file."
	SmalltalkImage current logChange: '----End fileIn of ' , self name , '----'.
	self flag: #ThisMethodShouldNotBeThere.	"sd"
	Smalltalk forgetDoIts.
	^val! !

!BlockClosure methodsFor: '*ecco' stamp: 'RomainRobbes 8/15/2010 15:31'!
resultAndMinutes
	| initialMilliseconds r |
	initialMilliseconds := Time millisecondClockValue.
	r := self value.
	^ r -> ((Time millisecondsSince: initialMilliseconds) / 60000.0)! !

!MCModification methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:21'!
fillChange: aChange
	|ch |
	ch :=  (EcoChange miniChangeFrom: obsoletion  and: modification).
	aChange incorporate: ch! !

!MCModification methodsFor: '*Ecco' stamp: 'RomainRobbes 8/8/2010 19:57'!
isRelevantFor: items
	^ (EcoChange miniChangeFrom: obsoletion  and: modification) isRelevantFor: items ! !

!MCModification methodsFor: '*Ecco' stamp: 'RomainRobbes 8/18/2010 21:59'!
isRelevantForRemoval: rItems andAddition: aItems 
	^ (EcoChange miniChangeFrom: obsoletion  and: modification) isRelevantForRemoval: rItems andAddition: aItems ! !

!Collection methodsFor: '*ecco' stamp: 'RomainRobbes 8/10/2010 19:43'!
distanceWith: other
	(self isEmpty or: [other isEmpty]) ifTrue: [^ 0].
	^ (self intersection: other) size * 2.0 / (self size + other size)! !

!Collection methodsFor: '*ecco' stamp: 'RomainRobbes 8/15/2010 12:40'!
oneWayDistanceWith: other
	(self isEmpty or: [other isEmpty]) ifTrue: [^ 0].
	^ (self intersection: other) size asFloat / (self size min: other size)! !

!MCClassDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:24'!
provided
	^ Array with: name! !

!MCClassDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:26'!
required
	^ superclassName ifNil: [#()] ifNotNilDo: [:s | Array with: s]! !

!MCClassDefinition methodsFor: '*Ecco-override' stamp: 'RomainRobbes 8/12/2010 08:56'!
sortedVariables
	"sort variables for comparison purposes"

	| sorted |
	variables ifNil: [^ #()].
	sorted := variables select: [:var | var isOrderDependend].
	sorted addAll: ((variables reject: [:var | var isOrderDependend])
		asSortedCollection: [:a :b | a name <= b name]).
	^sorted! !

!MCDirectoryRepository methodsFor: '*Ecco' stamp: 'MirceaLungu 12/15/2009 20:31'!
flushCache
	super flushCache.
	readerCache := nil.! !

!MCDirectoryRepository methodsFor: '*Ecco' stamp: 'MirceaLungu 8/5/2010 16:39'!
versionReaderForFileNamed: aString
	readerCache ifNil: [readerCache := Dictionary new].
	^ readerCache at: aString ifAbsent:
		[self resizeCache: readerCache.
		super versionReaderForFileNamed: aString do:
			[:r |
			r ifNotNil: [readerCache at: aString put: r]]].! !

PSMCChangeWrapper subclass: #EcoWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tools'!

!EcoWrapper methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 01:58'!
asString 
	^ item asString ! !

!EcoWrapper methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:16'!
contents
	^ (model filter: item operations) collect: [:e | e patchWrapper model: self model]! !

!EcoWrapper methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:07'!
operation
	^ nil! !

!MCVersion methodsFor: '*ecco-silently' stamp: ''!
addToCache
	MCCacheRepository default storeVersion: self! !

!MCVersion methodsFor: '*ecco-silently' stamp: ''!
isCacheable
	^ true! !

!MCVersion methodsFor: '*ecco' stamp: 'RomainRobbes 8/6/2010 11:33'!
timeStamp 
	"taking care of a few bogus files with busted dates"
	| ts |
	ts := self info date notNil & self info time notNil ifTrue: [self info timeStamp].
	ts ifNil: [ts := TimeStamp current - 4000 days].
	(ts between: TimeStamp current - 3000 days and: TimeStamp current) ifTrue: [^ ts].
	^ (self snapshot definitions detectMax: [:e |
		e isMethodDefinition ifTrue: [e fullTimeStamp] ifFalse: [e fullTimeStamp - 10000 days] 
		]) fullTimeStamp
	! !

!MCDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/8/2010 19:38'!
isRelevantFor: items
	^ false! !

!MCDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/12/2010 08:55'!
provided 
	^ #()! !

!MCDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/12/2010 08:55'!
required 
	^ #()! !

!MCOrganizationDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:23'!
provided
	^ #()! !

!MCOrganizationDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:23'!
required
	^ #()! !

PSMCPatchMorph subclass: #EcoPatchBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tools'!

!EcoPatchBrowser class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 01:32'!
browsePatch: p
	(self forPatch: p) newWindow openInWorld! !

!EcoPatchBrowser class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 01:34'!
browsePatch: p title: t
	(self forPatch: p) openInWindowLabeled: t! !

!EcoPatchBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:16'!
filter: operations
	^ operations! !

EcoPatchBrowser subclass: #EcoRippleBrowser
	instanceVariableNames: 'ripple patchType filter pt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tools'!

!EcoRippleBrowser class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 01:40'!
openRipple: r
	^ (self ripple: r) openInWindowLabeled: r printString ! !

!EcoRippleBrowser class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 01:39'!
ripple: r
	^ self new ripple: r! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:09'!
all: op
	^ true! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:31'!
always
	^ true! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:27'!
always: op
	^ true! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:13'!
changes
	"Answer the changes tree roots."

	|changes classes|
	self model ifNil: [^#()].
	^ self currentPatch collect: [:e | e wrapper model: self]
			! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 14:05'!
changesMenu: m
	"Answer the changes menu."

	|menu|
	menu := self newMenu
		addTitle: 'Changes'
		icon: MenuIcons smallCopyIcon.		
	menu
		addToggle: 'projects first' translated
		target: self
		selector: #toggleProjects
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'transitions first' translated
		target: self
		selector: #toggleTrans
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'operation filter ... ' translated
		target: self
		selector: #selectFilter
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'ripple graph' translated
		target: self
		selector: #rippleGraph
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'global ripple graph' translated
		target: self
		selector: #globalRippleGraph
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'ripple and projects' translated
		target: self
		selector: #rippleAndProjects
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'inspect ripple' translated
		target: self
		selector: #inspectRipple
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'spawn ripple' translated
		target: self
		selector: #spawn
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'spawn relevant ripple' translated
		target: self
		selector: #spawnRelevant
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'select ripple' translated
		target: self
		selector: #select
		getStateSelector: nil
		enablementSelector: #always.
	menu
		addToggle: 'reject ripple' translated
		target: self
		selector: #reject
		getStateSelector: nil
		enablementSelector: #always.
	^menu! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:12'!
currentPatch
	^ self perform: self patchType ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:54'!
currentRipple
	| r |
	r := self selectedTexts collect: [:e | e ifNil:[#()] ifNotNil: [{e}]].
	(r allSatisfy: [:e | e isEmpty]) ifTrue: [
		r := self selectionIsMethodChange ifTrue: [self selectedSelector] ifFalse: [^ ripple].
		r := {r} => {}
		] ifFalse: [ r := r first => r second].
	r ecosystem: ripple ecosystem.
	r originator: self selectedProject.
	^ r! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:28'!
filter
	^ filter ifNil: [#always:]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:21'!
filter: operations
	operations ifEmpty: [^ operations].
	^ (operations first isKindOf: MCPatchOperation) ifTrue: [self filterMC: operations] ifFalse: [self filterEco: operations]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:21'!
filterEco: operations
	^ operations! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:28'!
filterMC: operations
	^ operations select: [:e | self perform: self filter with: e]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:26'!
foo
	^ #(asdf kjdfhg sdf) atRandom! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 07:12'!
globalRippleGraph
	self currentRipple originator: nil; showRipple ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:45'!
inspectRipple
	^ self currentRipple inspect! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:10'!
onlyAdditions: op
	^ op isAddition! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:10'!
onlyModifications: op
	^ op isModification ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:10'!
onlyRemovals: op
	^ op isRemoval ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:11'!
patch
	^ self model patch! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:07'!
patchByProject
	^ ((pt ifNil: [model patch]) groupedBy: [:e | e item project]) associations collect: [:e | (EcoProjectPatch on: e key) operations: e value; yourself ]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:35'!
patchType
	^ patchType ifNil: [#patch]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:07'!
patchType: patch
	
	^ patchType := patch ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:52'!
reject
	EcoRipple rejected add: self currentRipple! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:01'!
relevant: op
	
	^ op isRelevantForRemoval: ripple from andAddition: ripple to! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:03'!
relevantPatch
	^ pt ifNil: [pt := self model patch collect: [:e | e operations: (e operations select: [:o | self relevant: o])] displayingProgress: 'filtering ...']! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:03'!
ripple: r
	ripple := r.
	self model: ripple.
	self fromDescription: ripple removalString. 
	self toDescription: ripple additionString. ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 14:08'!
rippleAndProjects
	self currentRipple showOnATimeline ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 14:07'!
rippleGraph
	self currentRipple showRipple  ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:51'!
select
	EcoRipple selected add: self currentRipple! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:11'!
selectFilter
	| l i |
	l :=  #(all: onlyAdditions: onlyModifications: onlyRemovals:).
	i := UIManager default chooseFrom: l title: 'choose a filter'.
	i = 0 ifFalse: [filter := l at: i].
	self updateTree ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:52'!
selectedProject
	^ self selectedTransition item project ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:54'!
selectedSelector
	^ self selectedChange definition selector! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:38'!
selectedTexts
	^ {self diffMorph srcMorph. self diffMorph dstMorph} collect: [:e | e textMorph editor selectedSelector]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:50'!
selectedTransition
	^ self patch detect: [:e | e operations anySatisfy: [:o | o = self selectedChange]] ifNone: [nil]! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 04:44'!
spawn
	self currentRipple browse! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 06:09'!
spawnRelevant
	self currentRipple browseRelevantPatch ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:33'!
toggleProjects
	patchType := #patchByProject.
	self updateTree! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:34'!
toggleTrans
	patchType := nil.
	self updateTree ! !

!EcoRippleBrowser methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:33'!
updateTree 
	self changed: #changes! !

!Array methodsFor: '*ecco' stamp: 'RomainRobbes 8/13/2010 09:59'!
=> otherArray

	^ EcoRipple new from: self; to: otherArray; yourself! !

!MCAddition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:13'!
fillChange: aChange
	definition provided do: [:e | aChange defAddProvided: e].
	definition required do: [:e | aChange defAddRequired: e].! !

!MCAddition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/8/2010 19:39'!
isRelevantFor: items
	^ definition isRelevantFor: items ! !

!MCAddition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/18/2010 21:58'!
isRelevantForRemoval: rItems andAddition: aItems
	^ definition isRelevantFor: aItems "and: [(definition isRelevantFor: rItems) not]"! !

!MCAncestry methodsFor: '*ecco' stamp: 'RomainRobbes 12/7/2009 08:05'!
trashAncestry
	ancestors := nil.
	stepChildren := nil! !

RBProgramNodeVisitor subclass: #EcoMethodClassRefReader
	instanceVariableNames: 'blob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoMethodClassRefReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 17:01'!
acceptVariableNode: aNode
	aNode name first isUppercase ifTrue: [blob addRequired: aNode name asSymbol].
	! !

!EcoMethodClassRefReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 16:38'!
blob: blb
	blob := blb ! !

RBProgramNodeVisitor subclass: #EcoMethodReader
	instanceVariableNames: 'blob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoMethodReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/3/2009 18:32'!
acceptMessageNode: aNode
	super acceptMessageNode: aNode.
	blob addRequired: aNode selector! !

!EcoMethodReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/3/2009 18:29'!
blob: blb
	blob := blb! !

RBProgramNodeVisitor subclass: #EcoReferenceGatherer
	instanceVariableNames: 'entity classes selectors selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:23'!
acceptMessageNode: aNode
	super acceptMessageNode: aNode.
	selectors add: aNode selector! !

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:23'!
acceptVariableNode: aNode
	aNode name first isUppercase ifTrue: [classes add: aNode name asSymbol].
	! !

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:24'!
classes
	^ classes! !

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:24'!
initialize 
	classes := OrderedCollection new.
	selectors  := OrderedCollection new.! !

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 22:29'!
processSource: aString
	| tree |
	[tree := RBParser parseMethod: aString.
	selector := tree selector.
	self visitNode: tree.] 
		on: Error 
		do: [:e | "Transcript cr; show: 'parse error for: '; show: aString"].! !

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 22:29'!
selector
	^ selector! !

!EcoReferenceGatherer methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:24'!
selectors 
	^ selectors ! !

!MCMethodDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/18/2010 21:27'!
isRelevantFor: items
	(items includes: selector) ifTrue: [^true]. 
	^ self referencedAll anySatisfy: [:e | items includes: e]! !

!MCMethodDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:09'!
provided
	^ Array with: self selector ! !

!MCMethodDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/8/2010 19:31'!
referencedAll
	| rg |
	rg := EcoReferenceGatherer new.
	rg processSource: self source.
	^ rg selectors, rg classes! !

!MCMethodDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/8/2010 19:26'!
referencedClasses
	
	| rg |
	rg := EcoReferenceGatherer new.
	rg processSource: self source.
	^ rg classes! !

!MCMethodDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/8/2010 19:26'!
referencedSelectors
	| rg |
	rg := EcoReferenceGatherer new.
	rg processSource: self source.
	^ rg selectors! !

!MCMethodDefinition methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:07'!
required
	^ self referencedAll ! !

!MCRemoval methodsFor: '*Ecco' stamp: 'RomainRobbes 8/11/2010 18:04'!
fillChange: aChange 
	definition provided do: [:e | aChange defRemoveProvided: e].
	definition required do: [:e | aChange defRemoveRequired: e].
	! !

!MCRemoval methodsFor: '*Ecco' stamp: 'MirceaLungu 8/16/2010 19:29'!
isRelevantFor: items
	^ definition isRelevantFor: items! !

!MCRemoval methodsFor: '*Ecco' stamp: 'RomainRobbes 8/19/2010 04:14'!
isRelevantForRemoval: rItems andAddition: aItems
	^ (definition isRelevantFor: rItems) "and: [(definition isRelevantFor: aItems) not]"! !

!MCMczReader methodsFor: '*Ecco' stamp: 'RomainRobbes 8/5/2010 17:48'!
resetStream
	zip := nil.
	stream := StandardFileStream readOnlyFileNamed:  stream name.
	^ stream! !

TestCase subclass: #EcoBagTest
	instanceVariableNames: 'b1 b2 ch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tests'!

!EcoBagTest methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/8/2010 18:01'!
setUp
	b1 := EcoBag new.
	b1 addProvided: #foo; addProvided: #foo; addProvided: #bar.
	b1 addRequired: #bax; addRequired: #bax.
	b2 := EcoBag new.
	b2 addProvided: #foo; addProvided: #bar; addProvided: #bar.
	b2 addRequired: #baz; addRequired: #baz.
	ch := EcoChange new.! !

!EcoBagTest methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/8/2010 18:17'!
testApply
	| b3 |
	ch := b1 to: b2.
	b3 := ch applyOn: b1.
	self assert: b2 allRequired = b3 allRequired.
	self assert: b2 allProvided = b3 allProvided! !

!EcoBagTest methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/8/2010 18:16'!
testChange
	ch := b1 to: b2.
	self assert: (ch removesProvided: #foo).
	self assert: (ch addsProvided: #bar).
	self assert: (ch removesRequired: #bax).
	self assert: (ch addsRequired: #baz).! !

!EcoBagTest methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/18/2010 23:05'!
testChangeRelevance
	
	self assert: ((EcoChange miniChangeFrom: 'foo ^bar bar bar' and: 'foo ^bar baz baz')
	isRelevantForRemoval: #() andAddition: #(baz)).
	self assert: ((EcoChange miniChangeFrom: 'foo ^bar bar bar' and: 'foo ^bar baz baz')
	isRelevantForRemoval: #(bar) andAddition: #()).
	self assert: ((EcoChange miniChangeFrom: 'foo ^bar bar bar' and: 'foo ^bar baz baz')
	isRelevantForRemoval: #(bar) andAddition: #(baz)).
	self deny: ((EcoChange miniChangeFrom: 'foo ^bar bar bar' and: 'foo ^bar baz baz')
	isRelevantForRemoval: #(baz) andAddition: #(bar)).
	self deny: ((EcoChange miniChangeFrom: 'foo ^bar bar bar' and: 'foo ^bar baz baz')
	isRelevantForRemoval: #(baz) andAddition: #()).! !

!EcoBagTest methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/9/2010 12:05'!
testOpposite
	| b3 ch2 |
	ch := b1 to: b2.
	ch2 := ch opposite.
	b3 := (ch applyOn: (ch2 applyOn: (ch applyOn: b1))).
	self assert: b2 allRequired = b3 allRequired.
	self assert: b2 allProvided = b3 allProvided! !

TestCase subclass: #EcoSimilarityTest
	instanceVariableNames: 'blobs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tests'!

!EcoSimilarityTest methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/10/2009 18:47'!
constructMobsFrom: listOfBlobs
	| mobs |
	mobs := OrderedCollection new.
	listOfBlobs do: [:blob|
		mobs do: [:mob|
				(0.33 < (mob similarityWith: blob) > 0.95) ifTrue: [
						mob add: blob.	
					]
			]
		].! !

!EcoSimilarityTest methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/10/2009 15:27'!
initializeBlobsWith: someBlobs
	blobs := someBlobs reject: [:e | e printString beginsWith:  'Seaside']! !

!EcoSimilarityTest methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/10/2009 17:26'!
splitDic: aDic
	| percents split |
	percents := #(0.80 0.85 0.90 0.95 1).
	split := Dictionary new.
	percents do: [:e|
		split at: e put: OrderedCollection new.
		].
	aDic keysAndValuesDo: [:pair :sim |
		(split at: (percents detect: [:e | sim <= e])) add: (pair ->
		 (sim asFloat roundTo: 0.01)).
		].
	split removeKey: 0.80.
	^ split! !

!EcoSimilarityTest methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/10/2009 15:16'!
testSimilarity
	| similarityIndex |
	similarityIndex := Dictionary new.
	'similarizing' displayProgressAt: Sensor cursorPoint from: 0 to: blobs size during: [:bar | 
	1 to: blobs size do: [:i|
			bar value: i.
			i + 1 to: blobs size do: [:j|
					| a b sim |
					a := blobs at: i.
					b := blobs at: j.
					sim := a similarityWith: b. 
					(sim > 0.66) ifTrue: [ 
					similarityIndex at: (a -> b) put: sim].
				]
		]].
	((similarityIndex keys asSortedCollection: [:a :b |
			(similarityIndex at: a) < (similarityIndex at: b)
		]) collect: [:e| e key printString , '- > ', e value printString, ' (',
		 ((similarityIndex at: e) asFloat roundTo: 0.01) printString, ')']) inspect.
	
	! !

TestCase subclass: #EcoStatistics
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tests'!

!EcoStatistics methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 1/13/2010 15:28'!
testClassCount
	| rr sq310blobs universeBlobs rez totalBase baseDir |
	
	baseDir := '/Users/mircea/research/writing/articles/10-msr/_other/'.
	
	rr := DataStream fileNamed: baseDir, 'squeak310-ds-class-and-methods.blobs'.
	sq310blobs := rr next.
	rr close.
	
	universeBlobs := EcoBlob readBlobs:  baseDir, 'universeClsMeth.blobs'.
	Transcript clear.
	totalBase := sq310blobs inject: 0 into: [:sum :e| sum + e provided size + e both size].
	Transcript show: 'Base , ', totalBase asString; cr.
	
	((universeBlobs collect: [:e| e -> (e both size + e provided size)]) asSortedCollection: [:a :b| a value > b value])
		do: [:e|
			Transcript show: e key printString , ' , ', e value asString; cr.]
	
	
! !

TestCase subclass: #EcoTest
	instanceVariableNames: 'a b c d e f'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tests'!

!EcoTest methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 9/10/2009 10:48'!
setUp
	a := EcoBlob on: Object.
	b := EcoBlob on: Morph.
	c := EcoBlob on: BorderedMorph.
	d := EcoBlob on: EcoBlob.
	e := EcoBlob on: Bag.
	f := EcoBlob on: Collection! !

!EcoTest methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 9/10/2009 11:05'!
testBuilding
	self inspect! !

!EcoTest methodsFor: 'as yet unclassified' stamp: 'MirceaLung 8/5/2010 15:01'!
testLoad
	| reader |
	reader := EcoLocalDirMczReader new.
	reader repoList: #('/Users/mircea/Research/ea/MCZ/test2').
	reader noSnapshot. 
	reader readAll .
	reader blobs inspect.! !

!EcoTest methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 9/10/2009 11:20'!
testMerge
	| morphs collections |
	morphs := b + c.
	collections := e + f.
	(Array with: morphs with: collections with: morphs + collections) inspect ! !

Object subclass: #EcoBlob
	instanceVariableNames: 'provided required both entity blobEntities mob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

EcoBlob subclass: #EcoBag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoBag class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:56'!
miniBag: mcdef
	^ self new miniBagFrom: mcdef! !

!EcoBag methodsFor: 'changes' stamp: 'MirceaLungu 8/19/2010 18:42'!
addChange: aChange
	aChange applyOn: self.! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:52'!
addProvided: p
	provided add: p.
	(required includes: p) ifTrue: [both add: p]! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:53'!
addRequired: p
	required add: p.
	(provided includes: p) ifTrue: [both add: p]! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:53'!
allProvided 
	^ provided! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:53'!
allRequired 
	^ required ! !

!EcoBag methodsFor: 'changes' stamp: 'RomainRobbes 8/8/2010 18:24'!
from: bag2
	^ bag2 to: self! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:48'!
initialize
	blobEntities := Set new.
	required := Bag new.
	provided := Bag new.
	both := Set new.
	! !

!EcoBag methodsFor: 'changes' stamp: 'RomainRobbes 8/11/2010 18:20'!
miniBagFrom: source
	source required do: [:e | self addRequired: e].
	source provided do: [:e | self addProvided: e]! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:54'!
onlyProvided
	^ provided reject: [:e | both includes: e]! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:54'!
onlyRequired
	^ required reject: [:e | both includes: e]! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:57'!
provided 
	^ self onlyProvided ! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:51'!
removeProvided: p
	provided remove: p ifAbsent: [^ self].
	(provided includes: p) ifFalse: [
		both remove: p ifAbsent: []
		].! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:52'!
removeRequired: p
	required remove: p ifAbsent: [^ self].
	(required includes: p) ifFalse: [
		both remove: p ifAbsent: []
		].! !

!EcoBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 17:57'!
required  
	^ self onlyRequired! !

!EcoBag methodsFor: 'changes' stamp: 'RomainRobbes 8/8/2010 18:11'!
to: bag2
	^ EcoChange new 
			provided: self allProvided nowProvides: bag2 allProvided;
			required: self allRequired nowRequires: bag2 allRequired.	! !

EcoBag subclass: #EcoClassBag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoClassBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 17:38'!
onMCDef: def

	def isMethodDefinition ifTrue: [
		self addRequired: def className. 
		(EcoClassDetector new source: def source) tokens do: [:e | self addRequired: e].
		].
	def isClassDefinition ifTrue: [self addProvided: def className. 
		(def isKindOf: MCTraitDefinition) ifFalse: [
			(def isKindOf: MCClassTraitDefinition) ifFalse: [
			def superclassName ifNotNilDo: [: n | self addRequired: n]]]].
	! !

!EcoClassBag methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/10/2010 16:11'!
reader
	^ EcoMethodClassRefReader ! !

!EcoBlob class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 9/10/2009 10:47'!
on: entity
	^ self new onClass: entity ! !

!EcoBlob class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/9/2010 17:52'!
readBlobs: fileName
	| f |
	f := FileStream fileNamed: fileName.
	^ (f fileInObjectAndCode install arrayOfRoots first)! !

!EcoBlob methodsFor: 'merging' stamp: 'RomainRobbes 8/4/2010 15:16'!
+ blob
	| bigblob |
	((self isKindOf: EcoClassMethodBlob) not and: [blob isKindOf: EcoClassMethodBlob]) ifTrue: [^ blob + self].
	bigblob := self class new.
	self addIn: bigblob.
	blob addIn: bigblob.
	^ bigblob! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 9/10/2009 11:15'!
addEntity: aClass
	blobEntities add: aClass ! !

!EcoBlob methodsFor: 'merging' stamp: 'RomainRobbes 9/10/2009 11:17'!
addIn: blob
	blobEntities do: [:e | blob addEntity: e].
	required do: [:e | blob addRequired: e].
	provided do: [:e | blob addProvided: e].
	both do: [:e | blob addProvided: e; addRequired: e]! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 9/10/2009 11:02'!
addProvided: message
	
	(required includes: message) 
			ifTrue: [required remove: message. both add: message] 
			ifFalse: [(both includes: message) ifFalse: [provided add: message.]]! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 9/10/2009 11:19'!
addRequired: message
	
	(provided includes: message) 
			ifTrue: [provided remove: message. both add: message] 
			ifFalse: [(both includes: message) ifFalse: [required add: message]]! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/9/2009 16:58'!
allProvided
	^ (Set new) addAll: provided; addAll: both; yourself! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/10/2010 14:47'!
allRequired
	^ (Set new) addAll: required; addAll: both; yourself! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/9/2009 17:22'!
asString
	^ 'blob'! !

!EcoBlob methodsFor: 'initialize-release' stamp: 'RomainRobbes 1/13/2010 15:43'!
blobEntities 
	^ blobEntities ! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 1/13/2010 13:31'!
both 	
	^both! !

!EcoBlob methodsFor: 'initialize-release' stamp: 'MirceaLungu 1/9/2010 23:20'!
flushEntities
	blobEntities := Set new.! !

!EcoBlob methodsFor: 'initialize-release' stamp: 'RomainRobbes 1/13/2010 15:43'!
fromBlob: e
	required := e required.
	provided := e provided.
	both := e both.
	mob := e mob.
	blobEntities := e blobEntities.! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/10/2009 19:13'!
hasMob
	^ mob notNil! !

!EcoBlob methodsFor: 'initialize-release' stamp: 'RomainRobbes 9/10/2009 11:15'!
initialize
	blobEntities := Set new.
	required := Set new.
	provided := Set new.
	both := Set new.
	! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/10/2010 16:27'!
maxPossibleSimilarityWith: aBlob
	| bothProv bothReq bps brs |
	Transcript show: 'random'.
	bothProv := self provided size min: aBlob provided size.
	bps := (self provided size + aBlob provided size) max: 1.
	bothReq := self required size min: aBlob  required size.
	brs := (self required  size + aBlob required  size) max: 1.
	^ ((bothProv  / bps) +
				 (bothReq / brs)).! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/12/2010 20:16'!
methodBlob
	^ EcoBlob new! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/12/2010 20:16'!
methodBlob: mblb
	! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/10/2010 16:37'!
methodReader
	^ EcoMethodReader ! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/11/2009 12:18'!
mob
	^ mob ifNil: [mob := EcoMob new addBlob: self]! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/10/2009 19:23'!
mob: m
	mob := m! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/14/2009 17:20'!
nameMatches: aString
"	^self package includesSubString: aString"
"	^self package asLowercase includesSubString: aString asLowercase"
"	^self package asLowercase beginsWith: aString asLowercase"
	| pak str |
	pak := (self package findTokens: '- ') collect: [:e | e asLowercase].
	str := (aString findTokens: '- ._') collect: [:e | e asLowercase].
	^str allSatisfy: [:s | pak includes: s]! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/13/2010 21:42'!
numEntities
	^ self required size + self provided size + self both size! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 9/10/2009 11:15'!
onClass: aClass
	self addEntity: aClass.
	aClass methodDict keysAndValuesDo: [:a :b | 
		self onMethod: a body: b].
	! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 12/3/2009 18:20'!
onMCDef: def
	def isMethodDefinition ifTrue: [self onMethod: def selector source: def source]! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 9/10/2009 10:54'!
onMethod: name body: body 
	self addProvided: name.
	body messagesDo: [:e | self addRequired: e].! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 8/10/2010 16:26'!
onMethod: name source: source 
	| tree visitor |
	self addProvided: name.
	[tree := RBParser parseMethod: source.
	visitor := self reader new.
	visitor blob: self.
	visitor visitNode: tree.] 
		on: Error 
		do: [:e | "Transcript cr; show: 'parse error for: '; show: name"].! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/14/2009 11:01'!
package
	^ (blobEntities detect: [:e | e isString not]) name! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/14/2009 11:07'!
packageURI
	^ self project, self package
	! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/10/2009 17:28'!
printOn: aStream
	aStream nextPutAll: self printString.! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/12/2010 15:10'!
printString
	| info |
	info := blobEntities detect: [:e | e isKindOf: MCVersionInfo ] ifNone: [^ 
		blobEntities ifNotEmpty: [blobEntities atRandom] ifEmpty: ['unnamed blob']].
	^info name! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 8/4/2010 12:48'!
processSnapshot: aMCSnapshot
	aMCSnapshot definitions do: [:def | self onMCDef: def]! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/13/2009 21:40'!
project
	^ blobEntities detect: [:e | e isString] ifNone: ['unknown project']! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/9/2009 16:58'!
provided
	^ provided! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/9/2009 16:41'!
provides: e
	^(provided includes: e) or: [both includes: e]! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/9/2009 16:52'!
providesUnique: method
	^ false! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 1/13/2010 16:47'!
reader
	^ EcoMethodReader ! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/9/2009 16:36'!
required
	^ required ! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/14/2009 10:54'!
requires: selector
	^ (required includes: selector) or: [ both includes: selector ]! !

!EcoBlob methodsFor: 'adding' stamp: 'MirceaLungu 12/10/2009 14:36'!
similarityWith: aBlob
	| bothProv bothReq bps brs |
	((self maxPossibleSimilarityWith: aBlob) < 0.66) ifTrue: [^0].
	bothProv := self provided intersection: aBlob provided.
	bps := (self provided size + aBlob provided size) max: 1.
	bothReq := self required intersection: aBlob required.
	brs := (self required  size + aBlob required  size) max: 1.
	^ ((bothProv  size / bps) +
				 (bothReq size / brs)).! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 12/4/2009 11:34'!
switchFromVersionToVersionInfo
	| versions infos |
	versions := blobEntities select: [:e | e isKindOf: MCVersion].
	infos := versions collect: [:e | e info].
	blobEntities := blobEntities difference: versions.
	blobEntities addAll: infos! !

!EcoBlob methodsFor: 'adding' stamp: 'RomainRobbes 12/7/2009 08:05'!
trashAncestors
	(blobEntities select: [:e | e isKindOf: MCVersionInfo]) do: [:e | e trashAncestry]! !

EcoBlob subclass: #EcoClassBlob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:18'!
addProvidedClass: aClass 
	self addProvided: aClass theNonMetaClass name! !

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:18'!
addRequiredClass: aClass 
	self addRequired: aClass theNonMetaClass name! !

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:18'!
onClass: aClass
	super onClass: aClass.
	self addProvidedClass: aClass.
	aClass isTrait ifTrue: [^self].
	aClass superclass ifNotNil: [
	self addRequiredClass: aClass superclass ]! !

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/7/2010 11:14'!
onMCDef: def
	super onMCDef: def.
	def isMethodDefinition ifTrue: [self addRequired: def className. ].
	def isClassDefinition ifTrue: [self addProvided: def className. 
		(def isKindOf: MCTraitDefinition) ifFalse: [
			(def isKindOf: MCClassTraitDefinition) ifFalse: [
			def superclassName ifNotNilDo: [: n | self addRequired: n]]]].
	! !

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:20'!
onMethod: m body: b

	(b allLiterals select: [:e | e isKindOf: Association])
		do: [:e | e key ifNil: [e value isBehavior ifTrue: [self addRequiredClass: e value]] ifNotNil: [self addRequired: e key]]
	! !

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/5/2010 16:34'!
onMethod: name source: source 
	| tree visitor |
	[tree := RBParser parseMethod: source.
	visitor := self reader new.
	visitor blob: self.
	visitor visitNode: tree.]
		on: Error 
		do: [:e | Transcript cr; show: 'parse error for: '; show: name].! !

!EcoClassBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/5/2010 16:05'!
reader
	^ EcoMethodClassRefReader ! !

EcoBlob subclass: #EcoClassMethodBlob
	instanceVariableNames: 'methodBlob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:16'!
+ aBlob
	| blb mblb |
	(aBlob isKindOf: EcoClassMethodBlob) ifFalse: [
		blb := self class new.
		mblb := self methodBlob + aBlob.
		blb methodBlob: mblb.
		^ blb.
		].
	blb := super + aBlob.
	mblb := self methodBlob + aBlob methodBlob.
	blb methodBlob: mblb.
	^ blb! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:50'!
addEntity: e
	super addEntity: e.
	self methodBlob addEntity: e.! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 16:23'!
addProvidedClass: aClass 
	self addProvided: aClass theNonMetaClass name! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 16:53'!
addRequiredClass: aClass 
	self addRequired: aClass theNonMetaClass name! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:51'!
flushEntities 
	super flushEntities.
	self methodBlob flushEntities ! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:18'!
initialize 
	super initialize.
	methodBlob := EcoBlob new.! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:54'!
methodBlob
	
	^ methodBlob ifNil: [EcoBlob new]! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 20:16'!
methodBlob: mblb
	methodBlob := mblb ! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 21:43'!
numEntities 
	^ super numEntities -> self methodBlob numEntities ! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:50'!
onClass: aClass
	self methodBlob onClass: aClass.
	super onClass: aClass.
	self addProvidedClass: aClass.
	aClass isTrait ifTrue: [^self].
	aClass superclass ifNotNil: [
	self addRequiredClass: aClass superclass ]! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:50'!
onMCDef: def
	self methodBlob onMCDef: def.
	super onMCDef: def.
	def isMethodDefinition ifTrue: [self addRequired: def className. ].
	def isClassDefinition ifTrue: [self addProvided: def className. 
		(def isKindOf: MCTraitDefinition) ifFalse: [
			(def isKindOf: MCClassTraitDefinition) ifFalse: [
			self addRequired: def superclassName]]].
	! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:50'!
onMethod: m body: b
	self methodBlob onMethod: m body: b. 
	(b allLiterals select: [:e | e isKindOf: Association])
		do: [:e | e key ifNil: [e value isBehavior ifTrue: [self addRequiredClass: e value]] ifNotNil: [self addRequired: e key]]
	! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:56'!
onMethod: name source: source 
	| tree visitor |
	self methodBlob onMethod: name source: source.
	[tree := RBParser parseMethod: source.
	visitor := self reader new.
	visitor blob: self.
	visitor visitNode: tree.] 
		on: Error 
		do: [:e | Transcript cr; show: 'parse error for: '; show: name].! !

!EcoClassMethodBlob methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 16:50'!
reader
	^ EcoMethodClassRefReader ! !

Object subclass: #EcoBot
	instanceVariableNames: 'doc'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tools'!

EcoBot class
	instanceVariableNames: 'recentUrls'!

EcoBot class
	instanceVariableNames: 'recentUrls'!

!EcoBot class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:19'!
download
	recentUrls := self new getFeed: 'http://squeaksource.com/feed.rss'; downloadAll ! !

!EcoBot class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:44'!
go
	[self watch: 3600] forkAt: Processor userBackgroundPriority ! !

!EcoBot class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:13'!
isDownloaded: file
	^ self recentUrls includes: file! !

!EcoBot class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:07'!
recentUrls 
	^ recentUrls ifNil: [recentUrls := Set new]! !

!EcoBot class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:44'!
sleep: delay
	Transcript show: 'EcoBot sleeping!! zzz.....'; cr.
	(Delay forSeconds: delay) wait.
	Transcript show: 'EcoBot woke up!!'; cr.
	self watch: delay
	! !

!EcoBot class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:33'!
watch: delay
	[self download] 
		on: Error 
		do: [:e | Transcript show: 'EcoBot encountered the following error:' cr; show: e; cr.].
	self sleep: delay! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:02'!
baseDirectory 
	(FileDirectory default directoryExists: 'ecco')
		ifFalse: [FileDirectory default createDirectory: 'ecco'].
	^ FileDirectory default directoryNamed: 'ecco'! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:01'!
directory
	(self baseDirectory directoryExists: self directoryName)
		ifFalse: [self baseDirectory createDirectory: self directoryName].
	^ self baseDirectory directoryNamed: self directoryName  ! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 18:51'!
directoryName
	^ Date today yyyymmdd asString! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:13'!
downloadAll
	^ (self itemList select: [:e | e tag = 'item'])
		collect: [:item | self writeFile: (self itemUrl: item)] 
		displayingProgress: 'downloading files ...'! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 18:57'!
filename: url
	^ (url reversed copyUpTo: $/) reversed! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 15:35'!
getFeed: url
	doc := XMLDOMParser parse: (HTTPSocket httpGet: url).
	^ doc ! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 18:49'!
itemDate: item
	|  pubDate |
	pubDate := (self nodes detect: [:e | e tag = 'pubDate']). 
	^ pubDate nodes first asString! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 18:42'!
itemList
	^ doc nodes first nodes first nodes! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:11'!
itemUrl: item
	| enclosure |
	enclosure := (item nodes detect: [:e | e tag = 'enclosure']). 
	^ enclosure attributes at: 'url'! !

!EcoBot methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/20/2010 19:34'!
writeFile: url
	| response stream |
	(self class isDownloaded: url) ifTrue: [^ url].
	Transcript show: 'downloading ', url; cr.
	response := [ HTTPSocket httpGet: url ]
		on: Error
		do: [ :err | ].
	response isString ifTrue: [ ^ self error: 'could not get the file'].
	stream := self directory 
		forceNewFileNamed: (self filename: url).
	[ stream binary; nextPutAll: (response binary; contents) ]
		ensure: [ stream close ].
	^ url! !

Object subclass: #EcoChange
	instanceVariableNames: 'removeProvided addProvided removeRequired addRequired entities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoChange class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 20:00'!
miniChangeFrom: m1 and: m2
	
	^ (EcoBag miniBag: m1) to: (EcoBag miniBag: m2)! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/11/2010 18:40'!
addEntity: aSymbol
	aSymbol ifNotNil: [entities add: aSymbol]! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:04'!
addProvided 
	^ addProvided ! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:04'!
addRequired 
	^ addRequired ! !

!EcoChange methodsFor: 'accessing' stamp: 'MirceaLungu 8/16/2010 18:11'!
addRequiredOnly
	"methods that are added and they are only required (not provided)"
	^ self addRequired difference: self addProvided.! !

!EcoChange methodsFor: 'executing' stamp: 'MirceaLungu 8/19/2010 18:59'!
addToChange: aChange
	
	removeProvided do: [:e | aChange defRemoveProvided: e].
	removeRequired do: [:e | aChange defRemoveRequired: e].
	addProvided do: [:e | aChange defAddProvided: e].
	addRequired do: [:e | aChange defAddRequired: e].
	^ aChange! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 11:32'!
addedClassesDo: aBlock
	self addProvided onceDo: [:plus | plus isClassName ifTrue: [aBlock value: plus]] ! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/8/2010 18:15'!
addsProvided: item
	^ addProvided includes: item ! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/8/2010 18:15'!
addsRequired: item
	^ addRequired includes: item ! !

!EcoChange methodsFor: 'executing' stamp: 'RomainRobbes 8/8/2010 18:20'!
applyOn: aBag
	removeProvided do: [:e | aBag removeProvided: e].
	removeRequired do: [:e | aBag removeRequired: e].
	addProvided do: [:e | aBag addProvided: e].
	addRequired do: [:e | aBag addRequired: e].
	^ aBag! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 08:26'!
changeSize
	^ {self addProvided. self removeProvided. self addRequired. self removeRequired.} sum: #size! !

!EcoChange methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 19:22'!
convertToCurrentVersion: aDictionary refStream: aSmartRefStream 
	"nothing to do here"! !

!EcoChange methodsFor: 'monticello' stamp: 'RomainRobbes 8/11/2010 18:30'!
defAddProvided: symbol
	(removeProvided includes: symbol) 
			ifTrue: [removeProvided remove: symbol]
			ifFalse: [addProvided add: symbol]! !

!EcoChange methodsFor: 'monticello' stamp: 'RomainRobbes 8/11/2010 18:30'!
defAddRequired: symbol
		(removeRequired includes: symbol) 
			ifTrue: [removeRequired remove: symbol]
			ifFalse: [addRequired add: symbol]! !

!EcoChange methodsFor: 'monticello' stamp: 'RomainRobbes 8/11/2010 18:31'!
defRemoveProvided: symbol
		(addProvided includes: symbol) 
			ifTrue: [addProvided remove: symbol]
			ifFalse: [removeProvided add: symbol]! !

!EcoChange methodsFor: 'monticello' stamp: 'RomainRobbes 8/11/2010 18:31'!
defRemoveRequired: symbol
		(addRequired includes: symbol) 
			ifTrue: [addRequired remove: symbol]
			ifFalse: [removeRequired add: symbol]! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 08:22'!
entities
	^ entities ! !

!EcoChange methodsFor: 'monticello' stamp: 'RomainRobbes 8/11/2010 18:23'!
incorporate: aChange
	aChange addProvided do: [:e | self defAddProvided: e].
	aChange addRequired do: [:e | self defAddRequired: e].
	aChange removeRequired do: [:e | self defRemoveRequired: e].
	aChange removeProvided do: [:e | self defRemoveProvided: e]! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/11/2010 18:38'!
initialize 
	addProvided := Bag new.
	removeProvided := Bag new.
	addRequired := Bag new.
	removeRequired := Bag new.
	entities := Set new! !

!EcoChange methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 12:03'!
initializeFromOpposite: oppo
	addRequired := oppo removeRequired.
	removeRequired := oppo addRequired.
	addProvided := oppo removeProvided.
	removeProvided := oppo addProvided! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 22:34'!
isRelevantFor: items
	^ {addProvided. addRequired. removeRequired. removeProvided} anySatisfy: [:e | 
		e anySatisfy: [:f | items includes: f]]! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 23:02'!
isRelevantForAdds: items
	items ifEmpty: [^ true].
	^ {addProvided. addRequired.} anySatisfy: [:e | e anySatisfy: [:f | items includes: f]]! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 23:03'!
isRelevantForRemoval: rItems andAddition: aItems 
	
	^(self isRelevantForRemoves: rItems) and: [self isRelevantForAdds: aItems]! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 23:02'!
isRelevantForRemoves: items
	items ifEmpty: [^ true].
	^ {removeProvided. removeRequired.} anySatisfy: [:e | e anySatisfy: [:f | items includes: f]]! !

!EcoChange methodsFor: 'accessing' stamp: 'MirceaLungu 8/16/2010 19:06'!
newlyRequired
	^ self addRequiredOnly! !

!EcoChange methodsFor: 'accessing' stamp: 'MirceaLungu 8/16/2010 18:20'!
notRequiredAnymore
	"methods that used to be required but are not anymore "
	^ self removeRequired ! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 23:49'!
numOfAddProvided: ent
	^ self addProvided  occurrencesOf: ent! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 23:50'!
numOfAddRequired: ent
	^ self addRequired occurrencesOf: ent! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 03:57'!
numOfRemoveProvided: ent
	^ self removeProvided occurrencesOf: ent! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 23:49'!
numOfRemoveRequired: ent
	^ self removeRequired occurrencesOf: ent! !

!EcoChange methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 12:01'!
opposite
	| ch |
	ch := self class new.
	ch initializeFromOpposite: self.
	^ ch! !

!EcoChange methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 18:39'!
printOn: aStream
	{addProvided. '+ prov'. removeProvided. '- prov'. 
	addRequired. '+ req'. removeRequired. '- req'.} pairsDo: [:bag :str |
		bag ifNotEmpty: [
			aStream nextPutAll: str.
			bag do: [:e | aStream space. e printOn: aStream].
			aStream cr]]! !

!EcoChange methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 18:13'!
provided: b1 nowProvides: b2
	
	removeProvided := b1 copy.
	addProvided := b2 copy.
	b1 do: [:e | addProvided remove: e ifAbsent: []].
	b2 do: [:e | removeProvided remove: e ifAbsent: []]! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:04'!
removeProvided 
	^ removeProvided ! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:04'!
removeRequired 
	^ removeRequired ! !

!EcoChange methodsFor: 'accessing' stamp: 'MirceaLungu 8/16/2010 18:13'!
removeRequiredOnly
	"methods that used to be required but are not anymore "
	^ self removeRequired difference: self addProvided ! !

!EcoChange methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 11:32'!
removedClassesDo: aBlock
	self removeProvided onceDo: [:minus | minus isClassName ifTrue: [aBlock value: minus]] ! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/8/2010 18:15'!
removesProvided: item
	^ removeProvided includes: item ! !

!EcoChange methodsFor: 'testing' stamp: 'RomainRobbes 8/8/2010 18:15'!
removesRequired: item
	^ removeRequired includes: item ! !

!EcoChange methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 18:14'!
required: b1 nowRequires: b2
	
	removeRequired := b1 copy.
	addRequired := b2 copy.
	b1 do: [:e | addRequired remove: e ifAbsent: []].
	b2 do: [:e | removeRequired remove: e ifAbsent: []]! !

Object subclass: #EcoClassDetector
	instanceVariableNames: 'source tokens stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoClassDetector methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 14:32'!
closeToken
	self hasToken ifTrue: [tokens add: stream contents asSymbol. stream := nil]! !

!EcoClassDetector methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 14:32'!
hasToken
	^ stream notNil! !

!EcoClassDetector methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 14:23'!
source: s
	source := s! !

!EcoClassDetector methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 14:26'!
startToken
	stream := WriteStream on: ''.! !

!EcoClassDetector methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 17:38'!
tokens
	| sc tok |
	tokens := OrderedCollection  new: 10.
	sc := RBScanner on: (ReadStream on: source).
	[sc atEnd] whileFalse: [
		tok := sc next.
		(tok isIdentifier and: [tok value first isUppercase]) ifTrue: [tokens add: tok value]
		].
	^ tokens! !

Object subclass: #EcoDecision
	instanceVariableNames: 'selector arguments description entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

EcoDecision class
	instanceVariableNames: 'failWithError current'!

EcoDecision class
	instanceVariableNames: 'failWithError current'!

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 14:50'!
block: block
	^ self new
			selector: #value: ;
			entity: block;
			description: 'execute a block on the ecosystem'! !

!EcoDecision class methodsFor: 'current' stamp: 'RomainRobbes 8/16/2010 14:00'!
current
	^ current! !

!EcoDecision class methodsFor: 'current' stamp: 'RomainRobbes 8/16/2010 14:00'!
current: d
	current := d! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 07:58'!
erase: project
	^ self new 
		selector: #eraseProject:;
		arguments: (Array with: project name);
		description: 'erased project ', project name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 17:04'!
failWithError 
	^ failWithError ifNil: [failWithError := false]! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 17:04'!
failWithError: bool
	failWithError := bool! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:36'!
ignoreNew: projects
	^ self new 
		selector: #prioritizeOld:ignoreNew:;
		arguments: (projects collect: [:e | e name]);
		description: 'prioritize older project ', projects first name, ' over newer project ', projects second name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 08:04'!
ignoreOld: projects
	^ self new 
		selector: #ignoreOld:prioritizeNew:;
		arguments: (projects collect: [:e | e name]);
		description: 'ignore older project ', projects first name, ' to prioritize newer project ', projects second name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 22:10'!
incorporateNew: projects
	^ self new 
		selector: #incorporateOldProject:inNewer:;
		arguments: (projects collect: [:e | e name]) reversed;
		description: 'incorporated newer project ', projects second name, ' in older project ', projects first name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:24'!
incorporateOld: projects
	^ self new 
		selector: #incorporateOldProject:inNewer:;
		arguments: (projects collect: [:e | e name]);
		description: 'incorporated older project ', projects first name, ' in newer project ', projects second name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 21:18'!
killVersion: numAndProject
	^ self new 
		selector: #killVersions:ofProject:;
		arguments: (numAndProject collect: [:e | e isNumber ifTrue: [e] ifFalse: [e name]]);
		description: 'remove ', numAndProject first asString, ' versions from project ', numAndProject  second name, ' methods'
		! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 16:41'!
merge: projects
	^ self new 
		selector: #mergeProject:in:;
		arguments: (projects collect: [:e | e name]);
		description: 'merge project ', projects first name, ' in project ', projects second name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 15:00'!
mergeSplit: projects
	^ self new 
		selector: #mergeSplit:from:;
		arguments: (projects collect: [:e | e name]);
		description: 'merged project ', projects first name, 'split from project ', projects second name! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:02'!
methodRename: projects
	^ self new 
		selector: #methodRenameProject:to:;
		arguments: (projects collect: [:e | e name]);
		description: 'renamed project ', projects first name, ' to project ', projects second name, ' methods'! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:02'!
methodSplit: projects
	^ self new 
		selector: #methodSplit:from:;
		arguments: (projects collect: [:e | e name]);
		description: 'merged project ', projects first name, 'split from project ', projects second name, ' methods'! !

!EcoDecision class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 14:58'!
rename: projects
	^ self new 
		selector: #renameProject:to:;
		arguments: (projects collect: [:e | e name]);
		description: 'renamed project ', projects first name, ' to project ', projects second name! !

!EcoDecision methodsFor: 'applying' stamp: 'RomainRobbes 8/6/2010 16:38'!
applyOn: ecosys
	| ent |
	entity ifNil: [self applyOn: ecosys in: ecosys]
		ifNotNil: [
			ent := ecosys itemNamed: entity.
			ent ifNil: [self fail].
			self applyOn: ent in: ecosys]! !

!EcoDecision methodsFor: 'applying' stamp: 'RomainRobbes 8/16/2010 21:29'!
applyOn: anEntity in: ecosys 
	| args |
	self class current: self.
	args := arguments collect: [:e | e isNumber ifTrue: [e] ifFalse: [anEntity itemNamed: e]].
	(args anySatisfy: [:e | e isNil]) ifTrue: [^ self fail].
	[anEntity perform: selector withArguments: args] on: Error do: [^ self fail].
	ecosys recordDecision: self ! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:35'!
arguments
	^ arguments! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:35'!
arguments: anObject
	arguments := anObject! !

!EcoDecision methodsFor: 'reconsidering' stamp: 'RomainRobbes 8/17/2010 09:56'!
beIgnoreNew

	self selector: #prioritizeOld:ignoreNew: ;
		description: 'prioritize older project ', self firstProj name, ' ignore newer project ', self secondProj name! !

!EcoDecision methodsFor: 'reconsidering' stamp: 'RomainRobbes 8/17/2010 09:53'!
beIgnoreOld

	self selector: #ignoreOld:prioritizeNew: ;
		description: 'ignore older project ', self firstProj name, ' to prioritize newer project ', self secondProj name! !

!EcoDecision methodsFor: 'reconsidering' stamp: 'RomainRobbes 8/16/2010 18:32'!
beIncorporateOld

	self selector: #incorporateOldProject:inNewer:;
		description: 'incorporated older project ', self firstProj name, ' in newer project ', self secondProj name! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 11:18'!
concerns: name
	^ arguments anySatisfy: [:a | a beginsWith: name]! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 21:29'!
date
	selector = #killVersions:ofProject: ifTrue: [
		"must be executed first"
		^ TimeStamp current - 10000 days].
	^ self firstProj startDate max: self secondProj startDate! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:07'!
deIndexFirstProj
	self firstProj deIndexIn: self getEcosystem index! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:11'!
deIndexLastArgIn: eco
	selector = #'incorporateOldProject:inNewer:' ifTrue: [^ self deIndexFirstProj].
	selector = #'ignoreOld:prioritizeNew'  ifTrue: [^ self deIndexFirstProj].
	self deIndexSecondProj! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:11'!
deIndexSecondProj
	self secondProj deIndexIn: self getEcosystem index! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:36'!
description
	^ description! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:36'!
description: anObject
	description := anObject! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/17/2010 10:34'!
dup
	^ self dupRecordIn: self getEcosystem.
	! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 16:35'!
dupRecordIn: ecosys
	^ EcoDuplicationRecord new  intializeFrom: (nil -> (Array with: (ecosys itemNamed: arguments first) with: (ecosys itemNamed: arguments second)))! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 16:40'!
ecosystem: anEcoSystem 
	self shouldBeImplemented! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 14:50'!
entity: e
	entity := e! !

!EcoDecision methodsFor: 'applying' stamp: 'RomainRobbes 8/9/2010 17:03'!
fail
	| descr |
	descr :=  'could not apply: 
	', description.
	self class failWithError ifFalse: [^self inform: descr].
	self error: descr.! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:06'!
firstProj
	^ self getEcosystem itemNamed: arguments first! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 16:42'!
getEcosystem
	^ EcoSystem current! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:48'!
printOn: aStream
	aStream nextPutAll: description! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:07'!
reIndexFirstProj
	self secondProj reIndexIn: self getEcosystem index! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:08'!
reIndexSecondProj
	self secondProj reIndexIn: self getEcosystem index! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 19:07'!
secondProj
	^ self getEcosystem itemNamed: arguments second! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:35'!
selector
	^ selector! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:35'!
selector: anObject
	selector := anObject! !

!EcoDecision methodsFor: 'accessing' stamp: 'RomainRobbes 8/17/2010 10:34'!
support
	| dup |
	dup := self dupRecordIn: self getEcosystem.
	^ dup bestStats -> dup classes! !

Object subclass: #EcoDependency
	instanceVariableNames: 'client provider dependencies index status weight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

EcoDependency subclass: #EcoCopyDependency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoCopyDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/17/2010 11:11'!
isCopyDep
	^ true! !

!EcoDependency class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 17:20'!
from: client to: provider
	^ (self new) client: client; provider: provider; yourself! !

!EcoDependency class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 13:45'!
from: client to: provider in: index
	^ (self new) client: client; provider: provider; index: index; compute; yourself! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 1/9/2010 22:26'!
association
	^ client -> provider! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/12/2010 14:58'!
associationString
	
	^ client printString -> provider printString asString ! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 15:41'!
checkWith: reference
	status = 'IGNORED: ' ifFalse: [
	(reference includes: self associationString) 
		ifTrue: [status := 'RIGHT: ']
		ifFalse: [status := 'WRONG: ']]! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:42'!
checkWithMissed
	status = '' ifTrue: [status := 'MISSED: ']! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:43'!
checkWithMissed: r
	status = '' ifTrue: [(r includes: self) ifTrue: [status := 'MISSED: ']]! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 22:52'!
classAndMethodDependencies
	^ (client required intersection: provider allProvided) addAll: (client methodBlob required intersection: provider methodBlob allProvided)! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 16:31'!
client
	^ client ! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 16:30'!
client: cl
	client := cl ! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/10/2010 14:49'!
compute
	self computeUnique! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 8/14/2010 19:26'!
computeGreedy
	self halt.
	(client required select: [:e | provider provides: e]) do: [:e |
		dependencies add: e.
		client required remove: e]! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 17:42'!
computeUnique
	(client required select: [:e | index blob: provider providesUnique: e]) do: [:e |
		dependencies add: e.
		"client required remove: e"]! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/12/2010 15:57'!
dependencies
	^ dependencies ! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 14:18'!
depsWithCount 
	^ self satisfiedDependencies collect: [:e | e -> (index numberOfProvidersOf: e)]! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/13/2010 23:53'!
extraSatisfiedDependencies
	^ client both intersection: provider allProvided! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 14:22'!
frequencyOfDependencies 
	^ self satisfiedDependencies asArray collect: [:e | index numberOfProvidersOf: e]! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 21:46'!
furtherCheckWith: reference
	self isRight ifFalse: [
	(reference includes: self associationString) 
		ifTrue: [status := 'RIGHT: ']
		ifFalse: [status := 'WRONG: ']]! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 15:18'!
ignoreIfIn: reference
	
	(reference includes: self associationString) 
		ifTrue: [status := 'IGNORED: ']! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 17:31'!
index: idx
	index := idx! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 14:22'!
initialize 
	super initialize.
	dependencies := Set new.
	status := ''! !

!EcoDependency methodsFor: 'testing' stamp: 'RomainRobbes 8/17/2010 11:12'!
isCopyDep 
	^ false! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:44'!
isFN
	^ status = 'MISSED: '! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:43'!
isFP
	^ status = 'WRONG: '! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:45'!
isIG
	^ status = 'IGNORED: '! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/13/2009 21:42'!
isInterProject
	^ (client project = provider project) not! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 14:39'!
isRight
	^ status = 'RIGHT: '! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:43'!
isTP
	^ status = 'RIGHT: '! !

!EcoDependency methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 14:39'!
isWrong
	^ status = 'WRONG: '! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 19:42'!
nonTrivialSatisfiedDependencies
	^ (client required select: [:e | e allButFirst anySatisfy: [:c | c isUppercase]]) intersection: provider allProvided! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/10/2010 14:22'!
printString 
	^ status, client printString, '  -->  ', provider printString, '    ', dependencies asArray printString! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 16:31'!
provider
	^ provider! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 16:31'!
provider: pr 
	provider := pr 
! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 14:39'!
resetStatus 
	status := ''! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 14:17'!
resetWeight
	weight := nil! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/13/2010 23:53'!
satisfiedDependencies
	^ client required intersection: provider allProvided! !

!EcoDependency methodsFor: 'accessing' stamp: 'MirceaLungu 12/9/2009 16:48'!
uncomputeGreedy
	dependencies do: [:e | client required add: e].
	dependencies := Set new! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/14/2010 01:24'!
weightWith: aBlock
	weight ifNil: [weight := aBlock value: self].
	^ weight! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/13/2010 23:51'!
wouldBeSatisfied
	^ client required intersection: provider allProvided! !

!EcoDependency methodsFor: 'accessing' stamp: 'RomainRobbes 1/10/2010 14:47'!
wouldBeSatisfiedBoth
	^ client allRequired intersection: provider allProvided! !

Object subclass: #EcoDependencyAlgorithm
	instanceVariableNames: 'classindex methodindex blobs dataSources p weight threshold dependencies dcache weightName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

EcoDependencyAlgorithm subclass: #EcoAll
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoAll methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 23:55'!
getProvidersForBlob: blob index: idx
	^ idx multipleProvidersForBlob: blob max: 1000! !

EcoDependencyAlgorithm subclass: #EcoClassMethod
	instanceVariableNames: 'classDeps methodDeps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoClassMethod methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/15/2010 02:32'!
classAlgo: cl
	classDeps := cl.
	cl classIndex: classindex.
	cl methodIndex: methodindex ! !

!EcoClassMethod methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/15/2010 02:32'!
methodAlgo: ml
	methodDeps := ml.
	ml classIndex: classindex.
	ml methodIndex: methodindex ! !

!EcoClassMethod methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/15/2010 02:29'!
run
	| d1 d2 |
	d1 := classDeps run.
	d2 := methodDeps run.
	d1 keysAndValuesDo: [:e :d1deps | | d2deps | 
		d2deps := d2 at: e methodBlob ifAbsentPut: [OrderedCollection new.].
		d2deps addAll: (d1deps collect: [:d | EcoDependency from: d client methodBlob to: d provider methodBlob]).
		d2 at: e methodBlob put: d2deps asSet].
	^ d2! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:31'!
b
	^ self new doUseBoth ! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:47'!
bnonTrivial
	^ [:dep | dep nonTrivialSatisfiedDependencies size]! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:47'!
bnumAllDeps
	^ [:dep | dep satisfiedDependencies size + (dep extraSatisfiedDependencies size / 2)]! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:47'!
bnumDeps
	^ [:dep | dep satisfiedDependencies size]! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:46'!
bproportional
	^ [:dep | ((dep frequencyOfDependencies reject: [:e | e <= 0]) collect: [:e | 1.0 / e]) sum]! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:30'!
c 
	^ self new doUseClasses ! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:52'!
forBlobs: blbs
	^ self new blobs: blbs! !

!EcoDependencyAlgorithm class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:31'!
m  
	^ self new doUseMethods ! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 01:20'!
<> anInterval
	^ anInterval collect: [:e | self copy t: e; dependencies: dependencies]! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 20:17'!
>< anInterval
	^ anInterval collect: [:e | self copy p: e; dependencies: OrderedCollection new]! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 22:39'!
bconstant 
	^ [:dep | 1]! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:51'!
blobs: blbs
	blobs := blbs! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:31'!
classIndex: cls
	classindex := cls ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:05'!
correctBlob: b
	self useMethods ifTrue: [^b methodBlob].
	^b! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:06'!
correctIndex
	self useMethods ifTrue: [^methodindex].
	^ classindex! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 14:42'!
dependencies 
	^ dependencies gather: [:e | e value]! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 01:19'!
dependencies: d
	dependencies := d! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:46'!
doUseBoth
	self doUseMethods doUseClasses! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:46'!
doUseClasses
	dataSources add: #class! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:46'!
doUseMethods
	dataSources add: #method! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 01:24'!
filterDependencies: dependencies

	^ dependencies select: [:e | (e weightWith: weight) >= threshold] ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:40'!
forBlobs: bl 
	^ self blobs: bl! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:09'!
getProvidersForBlob: blob
	^ self getProvidersForBlob: (self correctBlob: blob) index: self correctIndex ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 23:08'!
initialize 
	super initialize.
	weight := self bconstant.
	weightName := ''.
	threshold := 0.
	dataSources := OrderedCollection new.
	dependencies := OrderedCollection new.
	dcache := Dictionary new.! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 21:26'!
makeDependencyForProvider: p blob: e

	^ self makeDependencyForProvider: p blob: (self correctBlob: e) index: self correctIndex ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 21:26'!
makeDependencyForProvider: p blob: b index: idx
		^ dcache at: p->b ifAbsentPut: [EcoDependency from: b to: p in: idx ]! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:31'!
methodIndex: mth
	methodindex := mth! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 23:07'!
nonTrivial
	weightName := #nonTrivial.
	weight := self class bnonTrivial! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 23:07'!
numAllDeps
	weightName := #numAllDeps.
	weight := self class bnumAllDeps ! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 23:07'!
numDeps
	weightName := #numDeps.
	weight := self class bnumDeps ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:17'!
p: param
	p := param! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:17'!
param
	^ p ifNil: [''] ifNotNil: [' (p=', p asString, ') ']! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:15'!
param: param
	p := param! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:42'!
printString
	^ (self class name, self param, ' ', self weightName,' ', self threshold, dataSources asArray asString allButFirst)! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 23:06'!
proportional
	weightName := #proportional.
	weight := self class bproportional! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 23:07'!
proportional2
	| mdep w1 w2 |
	weightName := #proportional2.
	weight := [:dep | 
		mdep := EcoDependency from: dep client methodBlob to: dep provider methodBlob in: methodindex.
		w1 := ((dep frequencyOfDependencies reject: [:e | e <= 0]) collect: [:e | 1.0 / e]) sum.
		w2 := ((mdep frequencyOfDependencies reject: [:e | e <= 0]) collect: [:e | 1.0 / e]). 
		w2 := w2 ifEmpty: [0] ifNotEmpty: [w2 sum].
	 w1 + (w2 / 10)]! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/15/2010 02:31'!
run 
	| depdic bl |
	bl := EcoDependencyBenchmark blobs copyWithout: EcoDependencyBenchmark image.
	dependencies ifEmpty: [
	'Computing dependencies ', self printString
		displayProgressAt: Sensor cursorPoint from: 0 to: bl size during: [:bar |
			bl doWithIndex: [:e :i | | providers |
				bar value: i.
				providers := (self getProvidersForBlob: e) copyWithout: EcoDependencyBenchmark image.
				dependencies add: (e -> (providers asSet collect: [:p | self makeDependencyForProvider: p blob: e]))]]].
	depdic := Dictionary new.
	'Filtering dependencies ', self printString
		displayProgressAt: Sensor cursorPoint from: 0 to: dependencies size during: [:bar |
			dependencies doWithIndex: [:assoc :i |
				bar value: i. 
				depdic at: assoc key put: (self filterDependencies: assoc value).
				]
			].
	^ depdic ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 00:05'!
t: th
	threshold := th! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 00:45'!
threshold
	^ threshold ifNil: [''] ifNotNil: [' (t=', threshold asString, ') ']! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:45'!
useBoth
	^ self useClasses & self useMethods ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:45'!
useClasses
	^ dataSources includes: #class ! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:46'!
useMethods
	^ dataSources includes: #method! !

!EcoDependencyAlgorithm methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 11:27'!
weight: dependency
	^ dependency weightWith: weight ! !

!EcoDependencyAlgorithm methodsFor: 'weights' stamp: 'RomainRobbes 1/14/2010 23:06'!
weightName
	^ weightName! !

EcoDependencyAlgorithm subclass: #EcoMethodSeveralProviders
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoMethodSeveralProviders methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:41'!
initialize 
	super initialize.
	n := 1! !

!EcoMethodSeveralProviders methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:41'!
n: nn
	n := nn! !

!EcoMethodSeveralProviders methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:43'!
run
	| depdic providers |
	depdic := Dictionary new.
	'computing dependencies: ', n asString displayProgressAt: Sensor cursorPoint  from: 0  to: blobs size during: [:bar | 
	
	blobs doWithIndex: [:e :i | bar value: i. 
		providers := methodindex multipleProvidersForBlob: e methodBlob max: n.
		depdic at: e put: (providers asSet collect: [:pr | EcoDependency from: e to: pr in: methodindex ])]
		].
	 .
	^ depdic
	! !

EcoDependencyAlgorithm subclass: #EcoMethodSeveralUniqueProviders
	instanceVariableNames: 'n'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoMethodSeveralUniqueProviders methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:58'!
initialize 
	super initialize.
	n := 1! !

!EcoMethodSeveralUniqueProviders methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:58'!
n: nn
	n := nn! !

!EcoMethodSeveralUniqueProviders methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 18:11'!
run
	| depdic providers dependencies |
	depdic := Dictionary new.
	'computing dependencies: ', n asString displayProgressAt: Sensor cursorPoint  from: 0  to: blobs size during: [:bar | 
	
	blobs doWithIndex: [:e :i | bar value: i. 
		providers := methodindex uniqueProvidersForBlob: e methodBlob.
		dependencies := providers asSet collect: [:pr | EcoDependency from: e methodBlob to: pr in: methodindex ].
		dependencies := dependencies select: [:d | d dependencies size > n].
		depdic at: e put: dependencies].
		].
	 .
	^ depdic
	! !

EcoDependencyAlgorithm subclass: #EcoMethodUniqueProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoMethodUniqueProvider methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:38'!
run
	^ methodindex computeDependencies! !

EcoDependencyAlgorithm subclass: #EcoMultiple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoMultiple methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:23'!
getProvidersForBlob: blob index: idx
	^ idx multipleProvidersForBlob: blob max: p! !

EcoDependencyAlgorithm subclass: #EcoMultipleUnique
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoMultipleUnique methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:29'!
filterDependencies: dep
	^ dep select: [:e | e dependencies size >= p]! !

!EcoMultipleUnique methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:29'!
getProvidersForBlob: blob index: idx
	^ idx uniqueProvidersForBlob: blob! !

EcoDependencyAlgorithm subclass: #EcoTwoSteps
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoTwoSteps methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 21:26'!
getProvidersForBlob: blob index: idx
	| bestDep |
	^ ((blob required collect: [:e | | provs dep |
		provs := (idx providersFor: e).
		provs size > 5 ifTrue: [provs := #()].
		dep := (provs ifNotEmpty: [provs collect: [:prov | self makeDependencyForProvider: prov blob: blob index: idx]] ifEmpty: [#()]) detectMax: [:d | self weight: d].
		dep ifNil: [dep := EcoDependency new].
		dep]) reject: [:e | e provider isNil]) collect: [:dep | dep provider]! !

EcoDependencyAlgorithm subclass: #EcoUnique
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoUnique methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 19:05'!
getProvidersForBlob: blob index: idx
	^ idx uniqueProvidersForBlob: blob! !

EcoDependencyAlgorithm subclass: #EcoUniqueProvider
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Algorithms'!

!EcoUniqueProvider methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 13:45'!
run
	^ classindex computeDependencies! !

Object subclass: #EcoDependencyBenchmark
	instanceVariableNames: 'blobs reference dependencies imageBlob algorithm'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

EcoDependencyBenchmark class
	instanceVariableNames: 'classIndex image blobs methodIndex'!

EcoDependencyBenchmark class
	instanceVariableNames: 'classIndex image blobs methodIndex'!

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:08'!
blobFile
	^ '/Users/romain/Projects/RL-msr2010/_other/universe-classesAndMethods.blobs'! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:20'!
blobs
	^ blobs ! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:22'!
classIndex 
	^ classIndex ! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 1/9/2010 22:22'!
forBlobs: blobs
	^ self new blobs: blobs! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:07'!
forBlobs: blobFile image: imageFile
	| rr blobs image bench |
	rr := DataStream fileNamed: imageFile.
	blobs := EcoBlob readBlobs: blobFile.
	image := rr next.
	rr close.
	bench := self new blobs: blobs; image: image.
	^ bench run! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:20'!
image
	^ image! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:08'!
imageFile
	^ '/Users/romain/Projects/RL-msr2010/_other/baseImage-classesAndMethods.blobs' ! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:16'!
imageFromBlobs: imageBlobs 	
	| imageBlob imageMob classBlobs classImageMob classImageBlob methodBlobs methodImageMob methodImageBlob |
	classBlobs := imageBlobs collect: [:e | EcoBlob new fromBlob: e].
	classImageMob := EcoMob new blobs: classBlobs.
	classImageBlob := classImageMob theBigBlob.
	methodBlobs := imageBlobs collect: [:e | e methodBlob].
	methodImageMob := EcoMob new blobs: methodBlobs.
	methodImageBlob := methodImageMob theBigBlob.
	imageBlob := EcoClassMethodBlob new fromBlob: classImageBlob.
	imageBlob methodBlob: methodImageBlob.
	imageBlob mob: nil.
	imageBlob flushEntities.
	^ imageBlob ! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:23'!
methodIndex 
	^ methodIndex! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 14:58'!
new
	| rr bench |
	image ifNil: [
		rr := DataStream fileNamed: self imageFile.
		image := self imageFromBlobs: (rr next).
		rr close.
		blobs := EcoBlob readBlobs: self blobFile.
		blobs add: image.
		classIndex := EcoMethodIndex forBlobs: blobs.
		methodIndex := EcoMethodIndex forBlobs: (blobs collect: [:b | b methodBlob]).
		].
	bench := self basicNew.
	^ bench! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:24'!
reset
	image := nil! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:33'!
run
	| rr bench |
	image ifNil: [
		rr := DataStream fileNamed: self imageFile.
		image := self imageFromBlobs: (rr next).
		rr close.
		blobs := EcoBlob readBlobs: self blobFile.
		blobs add: image.
		classIndex := EcoMethodIndex forBlobs: blobs.
		methodIndex := EcoMethodIndex forBlobs: (blobs collect: [:b | b methodBlob]).
		].
	bench := self new.
	^ bench run! !

!EcoDependencyBenchmark class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 11:31'!
run: algo
	^ self new run: algo! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 19:39'!
actualMissingDependencies
	^ {
		'ProcessSpecific-kph.11'->'Seaside2.8a1-lr.522'. 
		'Tamaris-apl.61'->'OB-Standard-dc.310'. 
		'Tamaris-apl.61'->'OmniBrowser-cwp.393'. 
		'Tamaris-apl.61'->'OB-Morphic-tween.40'. 
		'TraitsOmniBrowser-dc.39'->'OB-Standard-dc.310'.
		'TraitsOmniBrowser-dc.39'->'OmniBrowser-cwp.393'.
		'Balloon3D-Pooh-ar.3'->'Balloon3D-Math-ar.2' .
		'Balloon3D-Import-ar.3'->'Balloon3D-Math-ar.2'.
		'Balloon3D-Packaging-ar.6'->'Balloon3D-WonderlandConstants-ar.2'.	
		'Balloon3D-VRML-ar.2'->'Balloon3D-Math-ar.2'.
		'Mondrian-dr.40'->'OB-Standard-dc.310'.
		'Balloon3D-Tutorial-ar.4'->'Balloon3D-Math-ar.2'.
		'Balloon3D-Kernel-ar.6'->'Graphics-External-ar.1'.
		'Balloon3D-Kernel-ar.6'->'Balloon3D-Math-ar.2'.
		'Balloon3D-Kernel-ar.6'->'Balloon3D-Plugins-ar.2'.
		'Balloon3D-Wonderland-ar.4'->'Balloon3D-Math-ar.2'.
		'Balloon3D-Morphic-ar.3'->'Balloon3D-Math-ar.2'.
		'ImageForDevelopers-dc.134'->'ShoutWorkspace.1-tween.2' .
		'ImageForDevelopers-dc.134'->'OB-Standard-dc.310'.
		'ImageForDevelopers-dc.134'->'ScriptManager-tbn.6'.
		 'ImageForDevelopers-dc.134'->'OmniBrowser-cwp.393' .
	}! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 23:12'!
algorithms 
	algorithm ifNotNilDo: [:a | ^ a].
	"^ {EcoUniqueProvider. EcoMethodUniqueProvider}"
	^ ({EcoMultipleUnique c p: 4. EcoMultipleUnique c p: 3. EcoMultipleUnique c p: 2. EcoUnique c. EcoMultiple c p: 2.  EcoMultiple c p: 3.  EcoMultiple c p: 4.  EcoAll c. EcoTwoSteps c} gather: [:e |
		{#yourself -> (0 to: 0). #numDeps -> (1 to: 10). #numAllDeps -> (1 to: 10). #nonTrivial -> (1 to: 10).  #proportional -> (0.25 to: 2 by: 0.25). #proportional -> (2.5 to: 10 by: 0.5).  #proportional2 -> (0.25 to: 2 by: 0.25). #proportional2 -> (2.5 to: 10 by: 0.5)} gather: [:as |
			 (e perform: as key) <> as value 
			]])
	, 
	({EcoMultipleUnique m p: 4. EcoMultipleUnique m p: 3. EcoMultipleUnique m p: 2. EcoUnique m. EcoMultiple m p: 2.  EcoMultiple m p: 3.  EcoMultiple m p: 4.  EcoAll m. EcoTwoSteps m}  gather: [:e |
		{#yourself -> (0 to: 0). #numDeps -> (1 to: 10). #numAllDeps -> (1 to: 10). #nonTrivial -> (1 to: 10).  #proportional -> (0.25 to: 2 by: 0.25). #proportional -> (2.5 to: 10 by: 0.5)} gather: [:as |
			 (e perform: as key) <> as value 
			]])
	"^ (EcoAll m numAllDeps <> (0.5 to: 10 by: 0.5)) ,
	{EcoUnique c}
	
	^ {EcoUnique c. EcoUnique m. EcoMultiple m p: 1.
	EcoMultiple m p: 2. EcoMultipleUnique m p: 3}"! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 14:44'!
blobNamed: name
	^ self blobs detect: [:e | e printString = name ] ifNone: [nil]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:25'!
blobs
	^self class blobs! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 1/9/2010 22:24'!
blobs: anObject
	blobs := anObject! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 18:05'!
correctBlobs 
	(self blobNamed: 'VMMaker-tpr.58') ifNotNilDo: [:e |
		e flushEntities; addEntity: 'VMMaker-3.8b6']! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 1/9/2010 22:25'!
dependencies
	^ dependencies ifNil: [ self run ]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 14:13'!
dependenciesAssocs
	^ self dependencies collect: [:e | e association]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 14:37'!
dependenciesAssocsStr
	^ self dependencies collect: [:e | e associationString]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 18:21'!
detailedResults
	| details r tp fp fn ig |
	details := Dictionary new.
	r := self reference.
	self processDependencies.
	self dependencies do: [:e | e checkWith: r].
	
	tp := (self dependencies select: [:e | e isTP]).
	fp := (self dependencies select: [:e | e isFP]).
	fn := self falseNegatives.
	ig := (self dependencies select: [:e | e isIG]).
	details at: #TP put: tp.
	details at: #FP put: fp.
	details at: #FN put: fn.
	details at: #IG put: ig.
	details at: #precision put: ((tp size / (tp size + fp size)) asFloat roundTo: 0.01).
	details at: #recall put: ((tp size / (tp size + fn size))  asFloat roundTo: 0.01).
	^ details! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:37'!
detailedResultsFor: depz
	| details r tp fp fn ig deps precision recall fmeasure |
	details := Dictionary new.
	depz do: [:e | e resetStatus].
	r := self reference.
	deps := self processDependencies: depz.
	deps do: [:e | e checkWith: r].
	
	tp := (deps select: [:e | e isTP]).
	fp := (deps select: [:e | e isFP]).
	fn := self falseNegatives: deps.
	ig := (deps select: [:e | e isIG]).
 "	details at: #TP put: tp.
	details at: #FP put: fp.
	details at: #FN put: fn.
	details at: #IG put: ig. "
	tp size = 0 ifTrue: [precision := 0. recall := 0. fmeasure := 0] 
		ifFalse: [
		precision := (tp size / (tp size + fp size)) asFloat roundTo: 0.01.
		recall := (tp size / (tp size + fn size))  asFloat roundTo: 0.01.
		fmeasure := ((2 * precision * recall) / (precision + recall)) asFloat roundTo: 0.01.
		].
	details at: #precision put: precision.
	details at: #recall put: recall.
	details at: #fmeasure put: fmeasure.
"	details at: #allDeps put: depz."
"	details at: #bench put: self."
	^ details! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 18:20'!
falseNegatives 
	^ (((self reference difference: self dependenciesAssocsStr) difference: self undetectableDependencies) collect: [:e | EcoDependency from: (self blobNamed: e key) to: (self blobNamed: e value)]) reject: [:e | e client isNil | e provider isNil]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:42'!
falseNegatives: deps 
	^ (((self reference difference: (deps collect: [:d | d associationString])) difference: self undetectableDependencies) collect: [:e | EcoDependency from: (self blobNamed: e key) to: (self blobNamed: e value)]) reject: [:e | e client isNil | e provider isNil]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 1/9/2010 22:22'!
forBlobs: blobs
	^ self new blobs: blobs! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:16'!
image: imageBlobs
	| imageMob classBlobs classImageMob classImageBlob methodBlobs methodImageMob methodImageBlob |
	classBlobs := imageBlobs collect: [:e | EcoBlob new fromBlob: e].
	classImageMob := EcoMob new blobs: classBlobs.
	classImageBlob := classImageMob theBigBlob.
	methodBlobs := imageBlobs collect: [:e | e methodBlob].
	methodImageMob := EcoMob new blobs: methodBlobs.
	methodImageBlob := methodImageMob theBigBlob.
	imageBlob := EcoClassMethodBlob new fromBlob: classImageBlob.
	imageBlob methodBlob: methodImageBlob.
	imageBlob mob: nil.
	self blobs add: imageBlob.
	imageBlob flushEntities ! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 15:40'!
indirectReferences

	| d s1 s2 flat |
	d := Dictionary new.
	self reference do: [:e | d at: e key put: Set new.
		d at: e value put: Set new].
	self reference do: [:e |
		(d at: e key) add: e value.
		].
	[
	s1 := d size.
	d copy keysAndValuesDo: [:cl :provs |
		provs do: [:pr | (d at: cl) addAll: (d at: pr)]
		].
	s2 := d size.
	] doWhileFalse: [s1 = s2].
	flat := OrderedCollection new.
	d keysAndValuesDo: [:k :v | flat addAll: (v collect: [:e | k -> e])].
	^ flat difference: self reference.! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:25'!
initialize 
	algorithm := EcoUniqueProvider! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:19'!
newReference1: array
	(array at: 1 put: ('Universes-ls.41.mcz'->'XML-Parser-mir.9.mcz'); at: 2 put: ('Rio-Grande-kph.22.mcz'->'Rio-Kernel-kph.71.mcz'); at: 3 put: ('Rio-Grande-kph.22.mcz'->'Null-kph.8.mcz'); at: 4 put: ('NewCompiler-ms.280.mcz'->'AST-ms.154.mcz'); at: 5 put: ('NewCompiler-ms.280.mcz'->'NewParser-ms.5.mcz'); at: 6 put: ('CommandShellV4-2-2.sar'->'OSProcessV4-3-6.sar'); at: 7 put: ('PlotKit-0.9.1-mb.27.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 8 put: ('SmaCCDev-lr.18.mcz'->'SmaCC-lr.13.mcz'); at: 9 put: ('SmaCCDev-lr.18.mcz'->'RefactoringEngine-dc.39.mcz'); at: 10 put: ('Pier-Math-lr.2.mcz'->'Pier-Seaside-lr.231.mcz'); at: 11 put: ('Pier-TagCloud-lr.5.mcz'->'Pier-Seaside-lr.231.mcz'); at: 12 put: ('AutomaticMethodCategorizerServices-DF.2.mcz'->'AutomaticMethodCategorizer-DF.24.mcz'); at: 13 put: ('InstallerInstallLogging.st'->'Installer-Core-kph.130.mcz'); at: 14 put: ('ImageForDevelopers-dc.134.mcz'->''); at: 15 put: ('OB-Standard-dc.310.mcz'->'OmniBrowser-cwp.393.mcz'); at: 16 put: ('OSProcessIO-SR.14.mcz'->'OSProcessV4-3-6.sar'); at: 17 put: ('ToolBuilder-MVC-dtl.12.mcz'->'ToolBuilder-Kernel-mvdg.20.mcz'); at: 18 put: ('Roe-avi.42.mcz'->'PostgresV2-yj.5.mcz'); at: 19 put: ('Mysql-alnr.12.mcz'->'Cryptography.cs.gz'); at: 20 put: ('Pier-Model-lr.191.mcz'->'Magritte-Model-lr.300.mcz'); at: 21 put: ('HTML-Parser.st'->'Network-HTML-md.4.mcz'); at: 22 put: ('HTML-Parser.st'->'XML-Parser-mir.9.mcz'); at: 23 put: ('EventInterceptorMorph-JW.1.cs.gz'->'SendTreeExplorer-JW.1.cs.gz'); at: 24 put: ('ProcessSpecific-Logging-kph.1.mcz'->'ProcessSpecific-kph.11.mcz'); at: 25 put: ('ProcessSpecific-Logging-kph.1.mcz'->'SimpleLog-gk.4.mcz'); at: 26 put: ('Pier-OmniBrowser-lr.31.mcz'->'Magritte-Morph-tg.39.mcz'); at: 27 put: ('Pier-OmniBrowser-lr.31.mcz'->'OmniBrowserFixes-dc.25.mcz'); at: 28 put: ('Pier-OmniBrowser-lr.31.mcz'->'Pier-Model-lr.191.mcz'); at: 29 put: ('NewParser-ms.5.mcz'->'SmaCC-lr.13.mcz'); at: 30 put: ('NewParser-ms.5.mcz'->'AST-ms.154.mcz'); at: 31 put: ('KomServices-gc.12.mcz'->'DynamicBindings-gc.7.mcz'); at: 32 put: ('OB-Monticello-dkh.30.mcz'->'OmniBrowser-cwp.393.mcz'); at: 33 put: ('ExternalWebBrowser-noha.8.mcz'->'InstallFFI3.st'); at: 34 put: ('RefactoringEngine-dc.39.mcz'->'AST-ms.154.mcz'); at: 35 put: ('KomHttpServer-gc.30.mcz'->'KomServices-gc.12.mcz'); at: 36 put: ('OBUniverse-dc.35.mcz'->'OmniBrowserFixes-dc.25.mcz'); at: 37 put: ('OBUniverse-dc.35.mcz'->'Universes-ls.41.mcz'); at: 38 put: ('Balloon3D-Tutorial-ar.4.mcz'->'Balloon3D-Morphic-ar.3.mcz'); at: 39 put: ('Magritte-Seaside-lr.248.mcz'->'Scriptaculous-lr.228.mcz'); at: 40 put: ('Magritte-Seaside-lr.248.mcz'->'Magritte-Model-lr.300.mcz'); at: 41 put: ('Magritte-Seaside-lr.248.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 42 put: ('SoapCore20061219.sar'->'XML-Parser-mir.9.mcz'); at: 43 put: ('Pier-Security-lr.102.mcz'->'Pier-Tests-lr.84.mcz'); at: 44 put: ('Pier-Security-lr.102.mcz'->'Pier-Seaside-lr.231.mcz'); at: 45 put: ('Techo-Shout-tbn.4.mcz'->'Shout.3.15-tween.70.mcz'); at: 46 put: ('Pier-LightBox-dc.6.mcz'->'Pier-Seaside-lr.231.mcz'); at: 47 put: ('SSL-rww.3.mcz'->'Cryptography-rww.5.mcz'); at: 48 put: ('Pier-Blog-tg.66.mcz'->'RSRSS2-pmm.9.mcz'); at: 49 put: ('Pier-Blog-tg.66.mcz'->'Pier-Seaside-lr.231.mcz'); at: 50 put: ('Pier-Randomizer-lr.3.mcz'->'Pier-Seaside-lr.231.mcz'); at: 51 put: ('AnnouncementMenu-kb.1.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 52 put: ('AnnouncementMenu-kb.1.mcz'->'AXAnnouncements-ul.31.mcz'); at: 53 put: ('Balloon3D-Morphic-ar.3.mcz'->'Balloon3D-Kernel-ar.6.mcz'); at: 54 put: ('Balloon3D-Wonderland-ar.4.mcz'->'Balloon3D-VRML-ar.2.mcz'); at: 55 put: ('Balloon3D-Wonderland-ar.4.mcz'->'Balloon3D-Pooh-ar.3.mcz'); at: 56 put: ('Balloon3D-Wonderland-ar.4.mcz'->'Balloon3D-Morphic-ar.3.mcz'); at: 57 put: ('Balloon3D-Wonderland-ar.4.mcz'->'Balloon3D-Kernel-ar.6.mcz'); at: 58 put: ('Balloon3D-Wonderland-ar.4.mcz'->'Graphics-Tools-ar.2.mcz'); at: 59 put: ('Balloon3D-Wonderland-ar.4.mcz'->'Balloon3D-WonderlandConstants-ar.2.mcz'); at: 60 put: ('Balloon3D-VRML-ar.2.mcz'->'Balloon3D-Kernel-ar.6.mcz'); at: 61 put: ('ToolBuilder-Morphic-mvdg.22.mcz'->'ToolBuilder-Kernel-mvdg.20.mcz'); at: 62 put: ('Balloon3D-Pooh-ar.3.mcz'->'Balloon3D-Kernel-ar.6.mcz'); at: 63 put: ('Balloon3D-Pooh-ar.3.mcz'->'Graphics-Tools-ar.2.mcz'); at: 64 put: ('Scriptaculous-lr.228.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 65 put: ('Pier-Documents-lr.3.mcz'->'Pier-Seaside-lr.231.mcz'); at: 66 put: ('Logic-DEA.2.mcz'->'SmaCCDev-lr.18.mcz'); at: 67 put: ('Network-IRC%20Bot.st'->'Network-IRC-fc.10.7.6.mcz'); at: 68 put: ('ShoutOmniBrowser-dc.5.mcz'->'Shout.3.15-tween.70.mcz'); at: 69 put: ('ShoutOmniBrowser-dc.5.mcz'->'OmniBrowserFixes-dc.25.mcz'); at: 70 put: ('VMMaker-3.8b6.mcz'->'Speech-md.9.mcz'); at: 71 put: ('VMMaker-3.8b6.mcz'->'InstallFFI3.st'); at: 72 put: ('Glorp-0.4.169.sar'->'PostgresV2-yj.5.mcz'); at: 73 put: ('Balloon3D-Plugins-ar.2.mcz'->'VMMaker-3.8b6.mcz'); at: 74 put: ('Balloon3D-Plugins-ar.2.mcz'->'Balloon3D-Constants-ar.4.mcz'); at: 75 put: ('Pier-Tests-lr.84.mcz'->'Pier-Model-lr.191.mcz'); at: 76 put: ('Pier-Tests-lr.84.mcz'->'Magritte-Tests-lr.131.mcz'); at: 77 put: ('Magritte-Morph-tg.39.mcz'->'Magritte-Model-lr.300.mcz'); at: 78 put: ('ToolBuilder-Tweak-pe.23.mcz'->'ToolBuilder-Kernel-mvdg.20.mcz'); at: 79 put: ('ShoreComponents-3-pk.10.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 80 put: ('ShoreComponents-3-pk.10.mcz'->'Scriptaculous-lr.228.mcz'))! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:19'!
newReference2: array
	(array at: 81 put: ('Network-IRC-fc.10.7.6.mcz'->'InstallFFI3.st'); at: 82 put: ('Network-IRC-fc.10.7.6.mcz'->'ExternalWebBrowser-noha.8.mcz'); at: 83 put: ('OB-Morphic-tween.40.mcz'->'OmniBrowser-cwp.393.mcz'); at: 84 put: ('REPL-mvdg.16.mcz'->'KomServices-gc.12.mcz'); at: 85 put: ('REPL-mvdg.16.mcz'->'DynamicBindings-gc.7.mcz'); at: 86 put: ('RSRSS2-pmm.9.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 87 put: ('ShoutPier-lr.7.mcz'->'Shout.3.15-tween.70.mcz'); at: 88 put: ('ShoutPier-lr.7.mcz'->'Pier-Seaside-lr.231.mcz'); at: 89 put: ('ODBC-dgd.10.cs.gz'->'InstallFFI3.st'); at: 90 put: ('SmallDEVS-061206.sar'->'SIXX20070812.sar'); at: 91 put: ('SmallDEVS-061206.sar'->'XML-Parser-mir.9.mcz'); at: 92 put: ('SmallDEVS-061206.sar'->'ConnectorsFor3.8-187.sar'); at: 93 put: ('DynamicProtocols-dc.67.mcz'->'OB-Standard-dc.310.mcz'); at: 94 put: ('DynamicProtocols-dc.67.mcz'->'ClassSelectorSets-dc.1.mcz'); at: 95 put: ('OB-Refactory-lr.44.mcz'->'OB-Standard-dc.310.mcz'); at: 96 put: ('OB-Refactory-lr.44.mcz'->'RefactoringEngine-dc.39.mcz'); at: 97 put: ('gamesTests-asm.cs'->'Morphic-Games.sar'); at: 98 put: ('TinyWiki-pmm.16.mcz'->'SmaCC-lr.13.mcz'); at: 99 put: ('TinyWiki-pmm.16.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 100 put: ('ECompletion-dc.89.mcz'->'Shout.3.15-tween.70.mcz'); at: 101 put: ('ECompletion-dc.89.mcz'->'RoelTyper-rw.60.mcz'); at: 102 put: ('OB-Tools-lr.13.mcz'->'OB-Standard-dc.310.mcz'); at: 103 put: ('Pier-EditorEnh-lr.9.mcz'->'Pier-Seaside-lr.231.mcz'); at: 104 put: ('SqueakSource-pmm.1069.mcz'->'Announcements-lr.7.mcz'); at: 105 put: ('SqueakSource-pmm.1069.mcz'->'Magritte-Tests-lr.131.mcz'); at: 106 put: ('SqueakSource-pmm.1069.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 107 put: ('SqueakSource-pmm.1069.mcz'->'TinyWiki-pmm.16.mcz'); at: 108 put: ('SqueakSource-pmm.1069.mcz'->'RSRSS2-pmm.9.mcz'); at: 109 put: ('SqueakSource-pmm.1069.mcz'->'XML-Parser-mir.9.mcz'); at: 110 put: ('SqueakSource-pmm.1069.mcz'->'Magritte-Seaside-lr.248.mcz'); at: 111 put: ('OB-Enhancements-dr.33.mcz'->'Mondrian-dr.40.mcz'); at: 112 put: ('OB-Enhancements-dr.33.mcz'->'OB-Morphic-tween.40.mcz'); at: 113 put: ('OB-Enhancements-dr.33.mcz'->'OB-Standard-dc.310.mcz'); at: 114 put: ('OB-Enhancements-dr.33.mcz'->'Announcements-lr.7.mcz'); at: 115 put: ('OB-Enhancements-dr.33.mcz'->'OmniBrowser-cwp.393.mcz'); at: 116 put: ('Rio-Kernel-kph.71.mcz'->'Null-kph.8.mcz'); at: 117 put: ('ECompletionTraits-bar.1.mcz'->'ECompletion-dc.89.mcz'); at: 118 put: ('ECompletionOmniBrowser-dc.4.mcz'->'OmniBrowser-cwp.393.mcz'); at: 119 put: ('ECompletionOmniBrowser-dc.4.mcz'->'ECompletion-dc.89.mcz'); at: 120 put: ('Pier-Seaside-lr.231.mcz'->'Scriptaculous-lr.228.mcz'); at: 121 put: ('Pier-Seaside-lr.231.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 122 put: ('Pier-Seaside-lr.231.mcz'->'Magritte-Seaside-lr.248.mcz'); at: 123 put: ('Pier-Seaside-lr.231.mcz'->'Pier-Model-lr.191.mcz'); at: 124 put: ('ToolBuilder-Examples-cwp.4.mcz'->'ToolBuilder-Kernel-mvdg.20.mcz'); at: 125 put: ('OBProtocolBrowser-DM.19.mcz'->'OB-Standard-dc.310.mcz'); at: 126 put: ('Universes-ls.41.mcz'->'XML-Parser-mir.9.mcz'); at: 127 put: ('Balloon3D-Import-ar.3.mcz'->'Balloon3D-Kernel-ar.6.mcz'); at: 128 put: ('Seaside-Squeak-Adapters-pmm.3.mcz'->'Seaside-Adapters-Core-pmm.2.mcz'); at: 129 put: ('Pier-Commands-RemoveChildren-kph.2.mcz'->'Pier-Model-lr.191.mcz'); at: 130 put: ('NamespaceTools-mvdg.25.mcz'->'Namespaces-mvdg.32.mcz'); at: 131 put: ('NamespaceTools-mvdg.25.mcz'->'PlusTools-mvdg.37.mcz'); at: 132 put: ('OB-TraitsIntegration-dc.32.mcz'->'OmniBrowser-cwp.393.mcz'); at: 133 put: ('OB-TraitsIntegration-dc.32.mcz'->'OB-Standard-dc.310.mcz'); at: 134 put: ('Seaside2.8a1-lr.522.mcz'->'KomHttpServer-gc.30.mcz'); at: 135 put: ('Seaside28Jetsam-kph.51.mcz'->'Seaside2.8a1-lr.522.mcz'); at: 136 put: ('Seaside28Jetsam-kph.51.mcz'->'Kernel-Extensions-kph.10.mcz'); at: 137 put: ('SIXX20070812.sar'->'XML-Parser-mir.9.mcz'); at: 138 put: ('Mondrian-dr.40.mcz'->'Announcements-lr.7.mcz'); at: 139 put: ('FreeType-tween.355.mcz'->'FreeTypePluginInstaller3.sar'); at: 140 put: ('FreeType-tween.355.mcz'->'InstallFFI3.st'); at: 141 put: ('FFI-Examples-ar.1.mcz'->'InstallFFI3.st'); at: 142 put: ('Magritte-Tests-lr.131.mcz'->'Magritte-Model-lr.300.mcz'); at: 143 put: ('Balloon3D-All-ar.18.mcz'->'Graphics-Tools-ar.2.mcz'); at: 144 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Math-ar.2.mcz'); at: 145 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Morphic-ar.3.mcz'); at: 146 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Constants-ar.4.mcz'); at: 147 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Kernel-ar.6.mcz'); at: 148 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Tutorial-ar.4.mcz'); at: 149 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Plugins-ar.2.mcz'); at: 150 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Pooh-ar.3.mcz'); at: 151 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-VRML-ar.2.mcz'); at: 152 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Packaging-ar.6.mcz'); at: 153 put: ('Balloon3D-All-ar.18.mcz'->'VMMaker-3.8b6.mcz'); at: 154 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Wonderland-ar.4.mcz'); at: 155 put: ('Balloon3D-All-ar.18.mcz'->'Balloon3D-Import-ar.3.mcz'); at: 156 put: ('Balloon3D-All-ar.18.mcz'->'Graphics-External-ar.1.mcz'); at: 157 put: ('Comet-lr.24.mcz'->'Scriptaculous-lr.228.mcz'); at: 158 put: ('PlusTools-mvdg.37.mcz'->'ToolBuilder-Examples-cwp.4.mcz'); at: 159 put: ('PlusTools-mvdg.37.mcz'->'ToolBuilder-Morphic-mvdg.22.mcz'); at: 160 put: ('ShoutMonticello.1-tween.2.mcz'->'Shout.3.15-tween.70.mcz'))! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:20'!
newReference3: array
	(array  at: 161 put: ('Pinesoft-ToolBuilder-gvc.3.mcz'->'Pinesoft-Widgets-gvc.275.mcz'); at: 162 put: ('FFI-Tests-ar.2.mcz'->'InstallFFI3.st'); at: 163 put: ('OmniBrowserFixes-dc.25.mcz'->'OmniBrowser-cwp.393.mcz'); at: 164 put: ('OmniBrowserFixes-dc.25.mcz'->'OB-SUnitIntegration-dc.9.mcz'); at: 165 put: ('OmniBrowserFixes-dc.25.mcz'->'OB-Standard-dc.310.mcz'); at: 166 put: ('OmniBrowserFixes-dc.25.mcz'->'OB-Morphic-tween.40.mcz'); at: 167 put: ('OmniBrowserFixes-dc.25.mcz'->'OB-TraitsIntegration-dc.32.mcz'); at: 168 put: ('SSH-rww.12.mcz'->'SSL-rww.3.mcz'); at: 169 put: ('SSH-rww.12.mcz'->'telnet.301.cs'); at: 170 put: ('SSH-rww.12.mcz'->'Cryptography-rww.5.mcz'); at: 171 put: ('ShoutWorkspace.1-tween.2.mcz'->'Shout.3.15-tween.70.mcz'); at: 172 put: ('OB-SUnitIntegration-dc.9.mcz'->'OmniBrowser-cwp.393.mcz'); at: 173 put: ('OB-SUnitIntegration-dc.9.mcz'->'OB-Standard-dc.310.mcz'))! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:13'!
oldReference
	^ {'Universes-ls.41'->'XML-Parser-mir.9' . 'Rio-Grande-kph.22'->'Null-kph.8' . 'Rio-Grande-kph.22'->'Rio-Kernel-kph.71' . 'NewCompiler-ms.280'->'AST-ms.154' . 'NewCompiler-ms.280'->'NewParser-ms.5' . 'PlotKit-0.9.1-mb.27'->'Seaside2.8a1-lr.522' . 'SmaCCDev-lr.18'->'RefactoringEngine-dc.39' . 'SmaCCDev-lr.18'->'SmaCC-lr.13' . 'Pier-Math-lr.2'->'Pier-Seaside-lr.231' . 'Pier-TagCloud-lr.5'->'Pier-Seaside-lr.231' . 'AutomaticMethodCategorizerServices-DF.2'->'AutomaticMethodCategorizer-DF.24' . 'OB-Standard-dc.310'->'OmniBrowser-cwp.393' . 'ToolBuilder-MVC-dtl.12'->'ToolBuilder-Kernel-mvdg.20' . 'Roe-avi.42'->'PostgresV2-yj.5' . 'Pier-Model-lr.191'->'Magritte-Model-lr.300' . 'ProcessSpecific-Logging-kph.1'->'ProcessSpecific-kph.11' . 'ProcessSpecific-Logging-kph.1'->'SimpleLog-gk.4' . 'Pier-OmniBrowser-lr.31'->'OmniBrowserFixes-dc.25' . 'Pier-OmniBrowser-lr.31'->'Pier-Model-lr.191' . 'Pier-OmniBrowser-lr.31'->'Magritte-Morph-tg.39' . 'NewParser-ms.5'->'SmaCC-lr.13' . 'NewParser-ms.5'->'AST-ms.154' . 'KomServices-gc.12'->'DynamicBindings-gc.7' . 'OB-Monticello-dkh.30'->'OmniBrowser-cwp.393' . 'RefactoringEngine-dc.39'->'AST-ms.154' . 'KomHttpServer-gc.30'->'KomServices-gc.12' . 'OBUniverse-dc.35'->'Universes-ls.41' . 'OBUniverse-dc.35'->'OmniBrowserFixes-dc.25' . 'Balloon3D-Tutorial-ar.4'->'Balloon3D-Morphic-ar.3' . 'Magritte-Seaside-lr.248'->'Seaside2.8a1-lr.522' . 'Magritte-Seaside-lr.248'->'Magritte-Model-lr.300' . 'Magritte-Seaside-lr.248'->'Scriptaculous-lr.228' . 'Pier-Security-lr.102'->'Pier-Seaside-lr.231' . 'Pier-Security-lr.102'->'Pier-Tests-lr.84' . 'Techo-Shout-tbn.4'->'Shout.3.15-tween.70' . 'Pier-LightBox-dc.6'->'Pier-Seaside-lr.231' . 'SSL-rww.3'->'Cryptography-rww.5' . 'Pier-Blog-tg.66'->'RSRSS2-pmm.9' . 'Pier-Blog-tg.66'->'Pier-Seaside-lr.231' . 'Pier-Randomizer-lr.3'->'Pier-Seaside-lr.231' . 'AnnouncementMenu-kb.1'->'AXAnnouncements-ul.31' . 'AnnouncementMenu-kb.1'->'Seaside2.8a1-lr.522' . 'Balloon3D-Morphic-ar.3'->'Balloon3D-Kernel-ar.6' . 'Balloon3D-Wonderland-ar.4'->'Balloon3D-Pooh-ar.3' . 'Balloon3D-Wonderland-ar.4'->'Graphics-Tools-ar.2' . 'Balloon3D-Wonderland-ar.4'->'Balloon3D-WonderlandConstants-ar.2' . 'Balloon3D-Wonderland-ar.4'->'Balloon3D-Kernel-ar.6' . 'Balloon3D-Wonderland-ar.4'->'Balloon3D-Morphic-ar.3' . 'Balloon3D-Wonderland-ar.4'->'Balloon3D-VRML-ar.2' . 'Balloon3D-VRML-ar.2'->'Balloon3D-Kernel-ar.6' . 'ToolBuilder-Morphic-mvdg.22'->'ToolBuilder-Kernel-mvdg.20' . 'Balloon3D-Pooh-ar.3'->'Balloon3D-Kernel-ar.6' . 'Balloon3D-Pooh-ar.3'->'Graphics-Tools-ar.2' . 'Scriptaculous-lr.228'->'Seaside2.8a1-lr.522' . 'Pier-Documents-lr.3'->'Pier-Seaside-lr.231' . 'Logic-DEA.2'->'SmaCCDev-lr.18' . 'ShoutOmniBrowser-dc.5'->'Shout.3.15-tween.70' . 'ShoutOmniBrowser-dc.5'->'OmniBrowserFixes-dc.25' . 'VMMaker-3.8b6'->'Speech-md.9' . 'Balloon3D-Plugins-ar.2'->'Balloon3D-Constants-ar.4' . 'Balloon3D-Plugins-ar.2'->'VMMaker-3.8b6' . 'Pier-Tests-lr.84'->'Pier-Model-lr.191' . 'Pier-Tests-lr.84'->'Magritte-Tests-lr.131' . 'Magritte-Morph-tg.39'->'Magritte-Model-lr.300' . 'ToolBuilder-Tweak-pe.23'->'ToolBuilder-Kernel-mvdg.20' . 'ShoreComponents-3-pk.10'->'Seaside2.8a1-lr.522' . 'ShoreComponents-3-pk.10'->'Scriptaculous-lr.228' . 'Network-IRC-fc.10.7.6'->'ExternalWebBrowser-noha.8' . 'OB-Morphic-tween.40'->'OmniBrowser-cwp.393' . 'REPL-mvdg.16'->'KomServices-gc.12' . 'REPL-mvdg.16'->'DynamicBindings-gc.7' . 'RSRSS2-pmm.9'->'Seaside2.8a1-lr.522' . 'ShoutPier-lr.7'->'Shout.3.15-tween.70' . 'ShoutPier-lr.7'->'Pier-Seaside-lr.231' . 'DynamicProtocols-dc.67'->'OB-Standard-dc.310' . 'DynamicProtocols-dc.67'->'ClassSelectorSets-dc.1' . 'OB-Refactory-lr.44'->'OB-Standard-dc.310' . 'OB-Refactory-lr.44'->'RefactoringEngine-dc.39' . 'TinyWiki-pmm.16'->'SmaCC-lr.13' . 'TinyWiki-pmm.16'->'Seaside2.8a1-lr.522' . 'ECompletion-dc.89'->'RoelTyper-rw.60' . 'ECompletion-dc.89'->'Shout.3.15-tween.70' . 'OB-Tools-lr.13'->'OB-Standard-dc.310' . 'Pier-EditorEnh-lr.9'->'Pier-Seaside-lr.231' . 'SqueakSource-pmm.1069'->'RSRSS2-pmm.9' . 'SqueakSource-pmm.1069'->'Seaside2.8a1-lr.522' . 'SqueakSource-pmm.1069'->'Magritte-Seaside-lr.248' . 'SqueakSource-pmm.1069'->'Magritte-Tests-lr.131' . 'SqueakSource-pmm.1069'->'TinyWiki-pmm.16' . 'SqueakSource-pmm.1069'->'XML-Parser-mir.9' . 'SqueakSource-pmm.1069'->'Announcements-lr.7' . 'OB-Enhancements-dr.33'->'Announcements-lr.7' . 'OB-Enhancements-dr.33'->'OB-Standard-dc.310' . 'OB-Enhancements-dr.33'->'OB-Morphic-tween.40' . 'OB-Enhancements-dr.33'->'Mondrian-dr.40' . 'OB-Enhancements-dr.33'->'OmniBrowser-cwp.393' . 'Rio-Kernel-kph.71'->'Null-kph.8' . 'ECompletionTraits-bar.1'->'ECompletion-dc.89' . 'ECompletionOmniBrowser-dc.4'->'ECompletion-dc.89' . 'ECompletionOmniBrowser-dc.4'->'OmniBrowser-cwp.393' . 'Pier-Seaside-lr.231'->'Pier-Model-lr.191' . 'Pier-Seaside-lr.231'->'Seaside2.8a1-lr.522' . 'Pier-Seaside-lr.231'->'Magritte-Seaside-lr.248' . 'Pier-Seaside-lr.231'->'Scriptaculous-lr.228' . 'ToolBuilder-Examples-cwp.4'->'ToolBuilder-Kernel-mvdg.20' . 'OBProtocolBrowser-DM.19'->'OB-Standard-dc.310' . 'Universes-ls.41'->'XML-Parser-mir.9' . 'Balloon3D-Import-ar.3'->'Balloon3D-Kernel-ar.6' . 'Seaside-Squeak-Adapters-pmm.3'->'Seaside-Adapters-Core-pmm.2' . 'Pier-Commands-RemoveChildren-kph.2'->'Pier-Model-lr.191' . 'NamespaceTools-mvdg.25'->'PlusTools-mvdg.37' . 'NamespaceTools-mvdg.25'->'Namespaces-mvdg.32' . 'OB-TraitsIntegration-dc.32'->'OB-Standard-dc.310' . 'OB-TraitsIntegration-dc.32'->'OmniBrowser-cwp.393' . 'Seaside2.8a1-lr.522'->'KomHttpServer-gc.30' . 'Seaside28Jetsam-kph.51'->'Kernel-Extensions-kph.10' . 'Seaside28Jetsam-kph.51'->'Seaside2.8a1-lr.522' . 'Mondrian-dr.40'->'Announcements-lr.7' . 'Magritte-Tests-lr.131'->'Magritte-Model-lr.300' . 'Balloon3D-All-ar.18'->'Balloon3D-Math-ar.2' . 'Balloon3D-All-ar.18'->'Balloon3D-Import-ar.3' . 'Balloon3D-All-ar.18'->'Balloon3D-Tutorial-ar.4' . 'Balloon3D-All-ar.18'->'Balloon3D-Kernel-ar.6' . 'Balloon3D-All-ar.18'->'Balloon3D-Pooh-ar.3' . 'Balloon3D-All-ar.18'->'Graphics-External-ar.1' . 'Balloon3D-All-ar.18'->'Graphics-Tools-ar.2' . 'Balloon3D-All-ar.18'->'Balloon3D-Plugins-ar.2' . 'Balloon3D-All-ar.18'->'Balloon3D-VRML-ar.2' . 'Balloon3D-All-ar.18'->'Balloon3D-Packaging-ar.6' . 'Balloon3D-All-ar.18'->'Balloon3D-Wonderland-ar.4' . 'Balloon3D-All-ar.18'->'Balloon3D-Constants-ar.4' . 'Balloon3D-All-ar.18'->'Balloon3D-Morphic-ar.3' . 'Balloon3D-All-ar.18'->'VMMaker-3.8b6' . 'Comet-lr.24'->'Scriptaculous-lr.228' . 'PlusTools-mvdg.37'->'ToolBuilder-Examples-cwp.4' . 'PlusTools-mvdg.37'->'ToolBuilder-Morphic-mvdg.22' . 'ShoutMonticello.1-tween.2'->'Shout.3.15-tween.70' . 'Pinesoft-ToolBuilder-gvc.3'->'Pinesoft-Widgets-gvc.275' . 'OmniBrowserFixes-dc.25'->'OmniBrowser-cwp.393' . 'OmniBrowserFixes-dc.25'->'OB-SUnitIntegration-dc.9' . 'OmniBrowserFixes-dc.25'->'OB-Standard-dc.310' . 'OmniBrowserFixes-dc.25'->'OB-Morphic-tween.40' . 'OmniBrowserFixes-dc.25'->'OB-TraitsIntegration-dc.32' . 'SSH-rww.12'->'Cryptography-rww.5' . 'SSH-rww.12'->'SSL-rww.3' . 'ShoutWorkspace.1-tween.2'->'Shout.3.15-tween.70' . 'OB-SUnitIntegration-dc.9'->'OmniBrowser-cwp.393' . 'OB-SUnitIntegration-dc.9'->'OB-Standard-dc.310'}! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 18:19'!
processDependencies
	| indir sibls |

	
	self dependencies do: [:e | (e client = imageBlob or: [e provider = imageBlob]) 
		ifTrue: [e ignoreIfIn: (Array with: e associationString )]].
	(#(indirectReferences siblingReferences actualMissingDependencies)
		collect: [:e | self perform: e]) 
		do: [:ignore |
			self dependencies do: [:e | e ignoreIfIn: ignore]].
	^ self dependencies ! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:24'!
processDependencies: deps
	| indir sibls |

	
	deps do: [:e | (e client = self class image or: [e provider = self class image]) 
		ifTrue: [e ignoreIfIn: (Array with: e associationString )]].
	deps do: [:e | (e client = self class image methodBlob or: [e provider = self class image methodBlob]) 
		ifTrue: [e ignoreIfIn: (Array with: e associationString )]].
	(#(indirectReferences siblingReferences actualMissingDependencies)
		collect: [:e | self perform: e]) 
		do: [:ignore |
			 deps do: [:e | e ignoreIfIn: ignore]].
	^ deps! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 22:37'!
reallyDetailedResultsFor: depz
	| details r tp fp fn ig deps precision recall fmeasure |
	details := Dictionary new.
	depz do: [:e | e resetStatus].
	r := self reference.
	deps := self processDependencies: depz.
	deps do: [:e | e checkWith: r].
	
	tp := (deps select: [:e | e isTP]).
	fp := (deps select: [:e | e isFP]).
	fn := self falseNegatives: deps.
	ig := (deps select: [:e | e isIG]).
 	details at: #TP put: tp.
	details at: #FP put: fp.
	details at: #FN put: fn.
	details at: #IG put: ig.
	tp size = 0 ifTrue: [precision := 0. recall := 0. fmeasure := 0] 
		ifFalse: [
		precision := (tp size / (tp size + fp size)) asFloat roundTo: 0.01.
		recall := (tp size / (tp size + fn size))  asFloat roundTo: 0.01.
		fmeasure := ((2 * precision * recall) / (precision + recall)) asFloat roundTo: 0.01.
		].
	details at: #precision put: precision.
	details at: #recall put: recall.
	details at: #fmeasure put: fmeasure.
"	details at: #allDeps put: depz."
"	details at: #bench put: self."
	^ details! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 14:21'!
reference
	| array |
	array := Array new: 173.
	self newReference3: array;
		newReference2: array;
		newReference1: array.
	^ array collect: [:e | (e key copyUpToLast: $. ) -> (e value copyUpToLast: $. )]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 1/9/2010 22:21'!
reference: anObject
	^ reference := anObject! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 21:50'!
referenceInvolving: substring
	^ self reference select: [:e | (e key includesSubstring: substring caseSensitive: false)
		or: [(e value includesSubstring: substring caseSensitive: false)]]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 16:24'!
rejectedDependencies
	^ (self dependenciesAssocs select: [:e | e key = self class image or: [e value = self class image]])
		collect: [:e | e key printString -> e value printString]! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 21:47'!
results
	| inter recall precision deps inter2 precision2 res inter3 |
	deps := self processDependencies.
	
	inter := deps intersection: self reference.
	inter2 := deps intersection: self indirectReferences.
	inter3 := deps intersection: self siblingReferences.
	recall := inter size / self reference size.
	precision := inter size / deps size.
	precision2 := (inter size + inter2 size + inter3 size) / (deps size + inter2 size + inter3 size).
	res := Dictionary new.
	res at: #precision put:(precision asFloat roundTo: 0.01).
	res at: #recall put: (recall asFloat roundTo: 0.01).
	res at: #adjusterPrecision put: (precision2 asFloat roundTo: 0.01).
	^ res ! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 01:34'!
run
	| deps classIndex methodIndex algorithms |
	self correctBlobs.
	
	classIndex := self class classIndex.
	methodIndex := self class methodIndex.
	algorithms := self algorithms collect: [:alg | (alg forBlobs: self class blobs) classIndex: classIndex; methodIndex: methodIndex].
	'Running algorithms '
		displayProgressAt: Sensor cursorPoint from: 0 to: algorithms size during: [:bar |
				
				
	^ algorithms collectWithIndex: [:alg :i | | depz | 
			bar value: i. 
			depz := OrderedCollection new.
			alg run
		 keysAndValuesDo: [:k :v | depz addAll: (v collect: [:e | e])].
		 (self detailedResultsFor: depz) at: #algorithm put: alg; yourself.
		]].! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 11:29'!
run: a
	algorithm := a isCollection ifTrue: [a] ifFalse: [Array with: a].
	^ self run! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 15:41'!
siblingReferences

	| d s1 s2 flat |
	d := Dictionary new.
	self reference do: [:e | d at: e key put: Set new.
		d at: e value put: Set new].
	self reference do: [:e |
		(d at: e value) add: e key.
		].
	
	d copy keysAndValuesDo: [:client :siblings |
		siblings do: [:pr | (d at: pr) addAll: (siblings)]
		].
	
	flat := OrderedCollection new.
	d keysAndValuesDo: [:k :v | flat addAll: ((v reject: [:e | k = e]) collect: [:e | k -> e])].
	^ flat difference: self reference.
! !

!EcoDependencyBenchmark methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 19:47'!
undetectableDependencies
	^ { 'SIXX20070812' ->  'XML-Parser-mir.9'.
		'ExternalWebBrowser-noha.8'->'InstallFFI3'.
		'SoapCore20061219'->'XML-Parser-mir.9'.
		'VMMaker-3.8b6'->'InstallFFI3'.
		 'Network-IRC-fc.10.7.6'->'InstallFFI3'.
		'Network-IRC-fc.10.7.6'->'ExternalWebBrowser-noha.8'.
		'FreeType-tween.355'->'FreeTypePluginInstaller3'.
		'FreeType-tween.355'->'InstallFFI3'.
		'FFI-Examples-ar.1'->'InstallFFI3'.
		 'FFI-Tests-ar.2'->'InstallFFI3'.
		 'Balloon3D-All-ar.18'->'Graphics-Tools-ar.2'. 
		'Balloon3D-All-ar.18'->'Balloon3D-Math-ar.2'. 
		'Balloon3D-All-ar.18'->'Balloon3D-Morphic-ar.3'. 
		'Balloon3D-All-ar.18'->'Balloon3D-Constants-ar.4'. 'Balloon3D-All-ar.18'->'Balloon3D-Kernel-ar.6'. 'Balloon3D-All-ar.18'->'Balloon3D-Tutorial-ar.4'. 'Balloon3D-All-ar.18'->'Balloon3D-Plugins-ar.2'. 'Balloon3D-All-ar.18'->'Balloon3D-Pooh-ar.3'. 'Balloon3D-All-ar.18'->'Balloon3D-VRML-ar.2'. 'Balloon3D-All-ar.18'->'Balloon3D-Packaging-ar.6'. 'Balloon3D-All-ar.18'->'Balloon3D-Wonderland-ar.4'. 'Balloon3D-All-ar.18'->'Balloon3D-Import-ar.3'. 'Balloon3D-All-ar.18'->'Graphics-External-ar.1'. 
	}! !

Object subclass: #EcoDuplicationInspector
	instanceVariableNames: 'candidates ecosystem xcurrent xcommon xproportion xversions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/4/2010 16:13'!
candidates: anOrderedCollection 
	candidates := anOrderedCollection! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/10/2010 21:29'!
candidatesAsPairs
	| newCandidates |
	newCandidates := Set new.
	candidates do: [:e | e allButFirst do: [:a | 
				(a classes distanceWith: e first classes) > 0.1 ifTrue: [newCandidates add: (Array with: a with: e first)]].
			] displayingProgress: 'pairing'.
	candidates := newCandidates asOrderedCollection .! !

!EcoDuplicationInspector methodsFor: 'filtering' stamp: 'RomainRobbes 8/9/2010 14:17'!
candidatesCloserThan: minDist
	| distance |
	distance := candidates collect: [:e | xcurrent := e. e -> self computeMetrics].
	distance := distance select: [:e | e value > minDist].
	candidates := (distance asSortedCollection: [:a :b | a value > b value]) collect: [:e | e key].
	xcurrent := nil! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/8/2010 12:09'!
computeMetrics
	
	xcommon := xcurrent atRandom classes.
	xcurrent do: [ :e | xcommon := xcommon intersection: e classes ].
	xproportion := (xcurrent collect: [ :e | e -> (xcommon size / e classes size) asFloat]).
	^ (xproportion collect: [:e | e value]) average ! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/4/2010 17:32'!
ecosystem: eco
	ecosystem := eco.
	self candidates: eco findDuplicates.
	self next! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/4/2010 16:16'!
filter
	candidates := candidates select: [:e | e size = 1].! !

!EcoDuplicationInspector methodsFor: 'filtering' stamp: 'RomainRobbes 8/9/2010 19:55'!
keepOnlySamePackageName
	candidates := candidates select: [:e | | init | 
		init := e atRandom packageName.
		e allSatisfy: [:f | f packageName = init]
		].! !

!EcoDuplicationInspector methodsFor: 'filtering' stamp: 'RomainRobbes 8/9/2010 19:53'!
keepOnlySameProjectName
	candidates := candidates select: [:e | | init | 
		init := e atRandom projectName.
		e allSatisfy: [:f | f projectName = init]
		].! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:43'!
merge: i in: j
	(EcoDecision merge: {(xcurrent at: i). (xcurrent at: j).}) applyOn: ecosystem! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 20:00'!
mergeAllCandidates
	candidates copy
		do: [ :e | 
			self next.
			self mergeInOldest ]
		displayingProgress: 'auto merging'.
	self reprocess! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 20:00'!
mergeAllCloserThan: dist
	self reprocess.
	self candidatesCloserThan: dist.
	self mergeAllCandidates! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 19:57'!
mergeAllCloserThan: dist and: selector
	self reprocess.
	self candidatesCloserThan: dist.
	self perform: selector.
	candidates copy do: [:e |
		self next.
		self mergeInOldest.
		] displayingProgress: 'auto merging'.
	self reprocess ! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:44'!
mergeInOldest
	| oldest |
	oldest := xcurrent detectMin: [:e | e firstversion date].
	xcurrent do: [:e | (EcoDecision merge: {e. oldest}) applyOn: ecosystem]  without: oldest! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/8/2010 12:09'!
next
	xcurrent ifNotNilDo: [ :e | candidates addLast: e ].
	candidates ifEmpty: [ ^ xcurrent := xcommon := xproportion := xversions := nil ].
	xcurrent := candidates removeFirst.
	self computeMetrics.
	xversions := (xcurrent
		gather: [ :e | 
			| c |
			c := OrderedCollection new.
			c
				add: e;
				add: '---------------------';
				addAll: e versions;
				add: '';
				add: ''.
			c ]) asArray! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/4/2010 17:56'!
printOn: aStream
	xcurrent ifNil: [^ candidates ifEmpty: [aStream nextPutAll: 'no more duplication']
		ifNotEmpty: [super printOn: aStream]].
	xcurrent do: [:e | e printOn: aStream] separatedBy: [aStream space]! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 14:17'!
prioritizeCandidates
	| distance |
	distance := candidates collect: [:e | xcurrent := e. e -> self computeMetrics].
	candidates := (distance asSortedCollection: [:a :b | a value > b value]) collect: [:e | e key].
	xcurrent := nil! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/11/2010 10:28'!
probableRenames
	| old rest |
	
	self candidatesAsPairs.
	candidates := candidates select: [:e | e allButFirst allSatisfy: [:f | (f classes distanceWith: e first classes) > 0.7 ]].
	
	candidates := candidates collect: [:e | 
			old := e detectMin: [:p | p startDate].
			rest := e copyWithout: old.
			(rest allSatisfy: [:p | old isOriginOf: p]) ifTrue: [e] ifFalse: [nil].
		] displayingProgress: 'detecting renames'.
	candidates := candidates reject: [:e | e isNil]! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/11/2010 10:28'!
probableSplits
	| old rest |
	
	self candidatesAsPairs.
	candidates := candidates select: [:e | e allButFirst allSatisfy: [:f | (f classes distanceWith: e first classes) > 0.3 ]].
	
	candidates := candidates collect: [:e | 
			old := e detectMin: [:p | p startDate].
			rest := e copyWithout: old.
			(rest allSatisfy: [:p | p isSplitFrom:  old]) ifTrue: [e] ifFalse: [nil].
		] displayingProgress: 'detecting splits'.
	candidates := candidates reject: [:e | e isNil]! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/4/2010 17:48'!
reprocess
	self ecosystem: ecosystem ! !

!EcoDuplicationInspector methodsFor: 'accessing' stamp: 'RomainRobbes 8/4/2010 18:04'!
resolved
	xcurrent := nil.
	self reprocess! !

Object subclass: #EcoDuplicationRecord
	instanceVariableNames: 'old new classes relations ecosystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 19:39'!
appliedDecisions
	^ self ecosystem decisions select: [:e | (e concerns: new name) or: [e concerns: old name]]! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 15:14'!
attemptMergingRenames: p
	self renameProb > p ifTrue: [self rename. ^ true].
	^ false ! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 15:15'!
attemptMergingSplits: p
	self splitProb > p ifTrue: [self split. ^ true].
	^ false ! !

!EcoDuplicationRecord methodsFor: 'metrics' stamp: 'RomainRobbes 8/16/2010 19:48'!
bestStats
	
	| rename split incorporate |
	rename := old fastBestRenameMatchFor: new firstVersion.
	split := old fastBestSplitMatchFor: new firstVersion.
	incorporate := new fastBestIncorporateMatchFor: old lastVersion.
	^ {#rename. rename classDistanceWith: new firstVersion.
	#split. split oneWayClassDistanceWith: new firstVersion.
	#incorporate. incorporate oneWayClassDistanceWith: old lastVersion}
	! !

!EcoDuplicationRecord methodsFor: 'metrics' stamp: 'RomainRobbes 8/16/2010 20:49'!
bestStats: n
	
	| rename split incorporate |
	rename := old fastBestRenameMatchFor: (new versions at: n).
	split := old fastBestSplitMatchFor:  (new versions at: n).
	incorporate := new fastBestIncorporateMatchFor: old lastVersion.
	^ {#rename. rename classDistanceWith: new firstVersion.
	#split. split oneWayClassDistanceWith: new firstVersion.
	#incorporate. incorporate oneWayClassDistanceWith: old lastVersion}
	! !

!EcoDuplicationRecord methodsFor: 'metrics' stamp: 'RomainRobbes 8/16/2010 19:50'!
bestVersions
	
	| rename split incorporate |
	rename := old fastBestRenameMatchFor: new firstVersion.
	split := old fastBestSplitMatchFor: new firstVersion.
	incorporate := new fastBestIncorporateMatchFor: old lastVersion.
	^ {#rename. rename. new firstVersion.
	#split. split. new firstVersion.
	#incorporate. incorporate. old lastVersion}
	! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 14:52'!
block: block
	ecosystem decisions add: (EcoDecision block: block)! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:18'!
browseCandidateOriginVersion
	(new originVersionIn: old)  second browse! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:18'!
browseCandidateSplitVersion
	(new versionSplitFrom: old) second  browse! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:17'!
browseFirstVersion
	new firstVersion browse! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:50'!
browseNextVersion
	new firstVersion successors atRandom browse! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 16:08'!
classes
	^ old allProvided intersection: new allProvided! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 19:14'!
ecosystem
	^ ecosystem ifNil: [ecosystem := EcoSystem allInstances last]! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 13:53'!
ecosystem: e
	ecosystem := e! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 14:23'!
erase: project
	ecosystem decisions add: (EcoDecision erase: project)! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 19:22'!
ignoreNew
	self ecosystem decisions add: (EcoDecision ignoreNew: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 19:26'!
ignoreOld
	self ecosystem decisions add: (EcoDecision ignoreOld: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/16/2010 22:08'!
incorporateNew
	self ecosystem decisions add: (EcoDecision incorporateNew: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 19:17'!
incorporateOld
	self ecosystem decisions add: (EcoDecision incorporateOld: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 13:23'!
intializeFrom: assoc
	classes := assoc key.
	old := assoc value detectMin: [:e | e startDate].
	new := assoc value detectMax: [:e | e startDate].
	relations := old relationShipWith: new! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 15:47'!
isExtendedRename
	^ (new extendedDegreeOfOriginFrom: old) > 0.90! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 15:51'!
isExtendedSplit
	^ (new extendedDegreeOfSplitFrom: old) > 0.90! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 16:17'!
isOldDiscontinued
	^ self oldVersionsAfterNew = 0! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 13:27'!
isRename
	^ self renameProb > 0.90! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 13:27'!
isSplit
	^ self splitProb > 0.95! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/16/2010 21:20'!
killVersion: n ofProject:  project
	ecosystem decisions add: (EcoDecision killVersion: {n. project})! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 16:57'!
methodDistance
	relations at: #mRename put: ((old versions: 3 before: new startDate) collect: [:e | e methodDistanceWith: new firstVersion]) max.
	relations at: #mSplit put: ((old versions: 3 before: new startDate) collect: [:e | e oneWayMethodDistanceWith: new firstVersion]) max ! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 17:03'!
methodRename
	ecosystem decisions add: (EcoDecision methodRename: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 17:03'!
methodSplit
	ecosystem decisions add: (EcoDecision methodSplit: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 14:25'!
new
	^ new! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 14:25'!
old
	^ old! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 16:16'!
oldVersionsAfterNew
	^ (old versionsAfter: new startDate) size! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 16:29'!
printOn: aStream
	old printOn: aStream.
	aStream space.
	new printOn: aStream.
	aStream nextPutAll: ' rename: ', self renameProbStr, ' split: ', self splitProbStr.
	aStream nextPutAll: '     #classes: ', self classes size asString! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 16:59'!
relations
	^ relations! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 19:15'!
rename
	self ecosystem decisions add: (EcoDecision rename: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 15:02'!
rename: p1 to: p2
	ecosystem decisions add: (EcoDecision rename: {p1. p2.})! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 18:25'!
renameProb
	^ relations at: #originOf! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 18:26'!
renameProbStr
	^ (relations at: #originOf) printShowingDecimalPlaces: 2! !

!EcoDuplicationRecord methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 19:26'!
split
	self ecosystem decisions add: (EcoDecision mergeSplit: {old. new.})! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 13:27'!
splitProb
	^ relations at: #supersetOf! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 13:32'!
splitProbStr
	^ (relations at: #supersetOf) printShowingDecimalPlaces: 2! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 17:21'!
successorsOfNew
	^ ((ecosystem index index select: [:e | e includes: new]) gather: [:e | e reject: [:f | f = new]]) asBag sortedCounts! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 19:17'!
successorsOfOld
	^ ((self ecosystem index index select: [:e | e includes: old]) gather: [:e | e reject: [:f | f = old]]) asBag sortedCounts! !

!EcoDuplicationRecord methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/15/2010 14:33'!
transitionForCommonClasses
	| c |
	c := self classes.
	^ (old transitions select: [:e | e isRelevantFor: c])
		->  (new transitions select: [:e | e isRelevantFor: c])
		! !

Object subclass: #EcoFileSorter
	instanceVariableNames: 'in out'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoFileSorter class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/5/2010 17:51'!
test
	self new 
		in: '/Users/rr/in/Pharo-1.0-10515-rc3dev10.03.1/package-cache' 
		out: '/Users/rr/in/Pharo-1.0-10515-rc3dev10.03.1/package-cache/test';
		run
	! !

!EcoFileSorter class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 09:54'!
test2
	^ [self new 
		in: '/Users/rr/Projects/images/pkgA-M'
		out: '/Users/rr/Projects/images/ssnap';
		run.
	self new 
		in: '/Users/rr/Projects/images/pkgN-Z'
		out: '/Users/rr/Projects/images/ssnap';
		run] timeToRun / 60000.0	! !

!EcoFileSorter class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 11:28'!
test3
	^ [self new 
		in: '/Users/rr/Projects/images/bogus'
		out: '/Users/rr/Projects/images/ssnap';
		run] timeToRun / 60000.0	! !

!EcoFileSorter methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/5/2010 18:35'!
directoryFor: date
	| origin weeks |
	origin := '1/1/2003' asTimeStamp.
	weeks := (date - origin) days / 7.
	^ weeks floor printPaddedWith: $0 to: 3
	
! !

!EcoFileSorter methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/5/2010 17:32'!
in: aString out: aString2
	in := FileDirectory on: aString. 
	out := FileDirectory on: aString2.
	out assureExistence.! !

!EcoFileSorter methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 11:21'!
run
	| repo files dir |
	EcoSystem withoutMCCacheDo: [
	repo := MCDirectoryRepository new directory: in.
	files := repo allFileNames select: [:e| e endsWith: 'mcz'].
	files do: [:f|
		(repo versionReaderForFileNamed: f) ifNotNilDo: [ :mczReader | 
				[mczReader resetStream.
				dir := self directoryFor: mczReader basicVersion timeStamp] on: Error do: [
				dir := 'bogus']. 
				dir := out directoryNamed: dir.
				dir assureExistence.
				dir putFile:  mczReader resetStream named: f]]
		displayingProgress: 'sorting files']! !

Object subclass: #EcoMethodIndex
	instanceVariableNames: 'bigdic blobs uniqueMethodsDict'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoMethodIndex class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 19:32'!
forBlobs: blbs
	^ (self new)
		blobs: blbs;
		constructIndex! !

!EcoMethodIndex methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 23:40'!
bigdic: anObject
	bigdic := anObject! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 17:36'!
blob: blb providesUnique: met
	| providers |
	providers := bigdic at: met ifAbsent: [^false].
	^ providers size = 1 and: [providers includes: blb].! !

!EcoMethodIndex methodsFor: 'debugging' stamp: 'RomainRobbes 1/13/2010 14:03'!
blobs
	^ blobs ! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 17:43'!
blobs: blbs
	blobs := blbs! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:36'!
computeDependencies
	| depdic providers |
	depdic := Dictionary new.
	'computing dependencies' displayProgressAt: Sensor cursorPoint  from: 0  to: blobs size during: [:bar | 
	
	blobs doWithIndex: [:e :i | bar value: i. 
		providers := self uniqueProvidersForBlob: e.
		depdic at: e put: (providers asSet collect: [:pr | EcoDependency from: e to: pr in: self ])]
		].
	^ depdic! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/13/2009 21:47'!
computeProjectDependencies
	| proDep |

	proDep := Dictionary new.
	self computeDependencies keysAndValuesDo: [:package :deps | 
		proDep at: package project ifAbsentPut: [Set new].
		deps do: [:dep|
			dep isInterProject ifTrue: [
				(proDep at: package project) add:  dep provider project.
				]
			]
		].
	^ proDep! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 17:04'!
constructIndex
	'indexing' displayProgressAt: Sensor cursorPoint  from: 0  to: blobs size during: [:bar | 
		
		blobs doWithIndex: [:e :i | bar value: i. self indexBlob: e]]! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 15:26'!
index
	^ bigdic! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 16:59'!
indexBlob: blb
	blb allProvided do: [:e | self method: e isProvidedBy: blb ]! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 17:08'!
initialize 
	super initialize.
	bigdic := Dictionary new! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 16:01'!
method: e isNoMoreProvidedBy: blb
	(bigdic at: e ifAbsentPut: [Set new]) remove: blb ifAbsent: [].! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:26'!
method: e isProvidedBy: blb
	(bigdic at: e ifAbsentPut: [Set new]) add: blb! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/13/2010 17:16'!
multipleProvidersForBlob: blb max: n
	^ (blb required collect: [:e | (bigdic at: e ifAbsent: [#()])] thenSelect: [:e | e size <= n]) gather: [:e | e]! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 00:24'!
numberOfProvidersOf: entity
	^ (bigdic at: entity ifAbsent: [#()]) size! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/14/2010 11:23'!
providersFor: entity
	^ (bigdic at: entity ifAbsent: [#()])! !

!EcoMethodIndex methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 23:41'!
uniqueMethodsDict
	uniqueMethodsDict isNil ifTrue: 
		[uniqueMethodsDict := Dictionary new.] .
	^uniqueMethodsDict ! !

!EcoMethodIndex methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 23:40'!
uniqueMethodsDict: anObject
	uniqueMethodsDict := anObject! !

!EcoMethodIndex methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 23:45'!
uniqueMethodsIn: aProject
	^self uniqueMethodsDict at: aProject 
	ifAbsentPut: [
			self index keys select: [:e|
				((self index at: e) size = 1) and: [(self index at: e) includes:  aProject ]
			]
		]! !

!EcoMethodIndex methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/9/2009 17:16'!
uniqueProvidersForBlob: blb
	^ (blb required collect: [:e | (bigdic at: e ifAbsent: [#()])] thenSelect: [:e | e size = 1]) gather: [:e | e]! !

Object subclass: #EcoMircea
	instanceVariableNames: ''
	classVariableNames: 'globals'
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoMircea class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/14/2010 23:19'!
globals
	globals isNil ifTrue: [ 
		globals := Dictionary new.
		]..
	^globals! !

!EcoMircea class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/15/2010 01:08'!
repos
	| rs repos | 
	repos := OrderedCollection new.
	rs := self reposString readStream.
	[
		repos add: (rs upTo: Character cr).
		rs atEnd.
	] whileFalse.
	^repos! !

!EcoMircea class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/15/2010 01:05'!
reposString
	^'http://www.squeaksource.com/Bytecode/
http://www.squeaksource.com/TestServer/
http://www.squeaksource.com/Elf/
http://www.squeaksource.com/SBElearning00/
http://www.squeaksource.com/TestingTODO/
http://www.squeaksource.com/JihQuinto/
http://www.squeaksource.com/RegConf/
http://www.squeaksource.com/Squff/
http://www.squeaksource.com/Galantine/
http://www.squeaksource.com/Bougie/
http://www.squeaksource.com/SmallDEVS/
http://www.squeaksource.com/Krestianstvo/
http://www.squeaksource.com/EasyConfig/
http://www.squeaksource.com/Chalten/
http://www.squeaksource.com/EhuruSBEQuinto/
http://www.squeaksource.com/webDev/
http://www.squeaksource.com/PharoInbox/
http://www.squeaksource.com/QuintoJCB/
http://www.squeaksource.com/PackageInfo/
http://www.squeaksource.com/ExternalWebBrowser/
http://www.squeaksource.com/SBEQuintoPNR/
http://www.squeaksource.com/RegexCont/
http://www.squeaksource.com/SBEQuintoAAV/
http://www.squeaksource.com/Random/
http://www.squeaksource.com/SSpec/
http://www.squeaksource.com/scrummer/
http://www.squeaksource.com/SantervoTest/
http://www.squeaksource.com/ObjectiveCBridge2/
http://www.squeaksource.com/IMAP/
http://www.squeaksource.com/RandomLoops/
http://www.squeaksource.com/SecureSqueak/
http://www.squeaksource.com/Schildkroetenrennen/
http://www.squeaksource.com/MinesBlaster/
http://www.squeaksource.com/flotr/
http://www.squeaksource.com/MiniMorphicWrapper/
http://www.squeaksource.com/SDTS/
http://www.squeaksource.com/Stave/
http://www.squeaksource.com/Teachable/
http://www.squeaksource.com/Exupery/
http://www.squeaksource.com/OpenSSLPlugin/
http://www.squeaksource.com/Safara/
http://www.squeaksource.com/VmController/
http://www.squeaksource.com/ODBC/
http://www.squeaksource.com/UpsideDownSnarl/
http://www.squeaksource.com/LibraryImporter/
http://www.squeaksource.com/DSJQuinto/
http://www.squeaksource.com/CodeVis/
http://www.squeaksource.com/TraitsOmniBrowser/
http://www.squeaksource.com/SoundsLike/
http://www.squeaksource.com/oophw1lights/
http://www.squeaksource.com/DynamicBindings/
http://www.squeaksource.com/CESBEQuinto/
http://www.squeaksource.com/Promoter/
http://www.squeaksource.com/Quinto09/
http://www.squeaksource.com/LO/
http://www.squeaksource.com/ttfReaderRefactored/
http://www.squeaksource.com/Monticello2/
http://www.squeaksource.com/SBEQuinto/
http://www.squeaksource.com/SqueakFunAndGames/
http://www.squeaksource.com/DrDoc/
http://www.squeaksource.com/InformationRetrieval/
http://www.squeaksource.com/Skins/
http://www.squeaksource.com/Topologos/
http://www.squeaksource.com/FacetS/
http://www.squeaksource.com/SnmpBasics0/
http://www.squeaksource.com/QuintoMLK/
http://www.squeaksource.com/SimpleCounter1/
http://www.squeaksource.com/jbr/
http://www.squeaksource.com/CouchDB/
http://www.squeaksource.com/RefacEngineUnivFork/
http://www.squeaksource.com/SqueakInstaller/
http://www.squeaksource.com/FelTimetable2/
http://www.squeaksource.com/Gaucho/
http://www.squeaksource.com/pac/
http://www.squeaksource.com/Production/
http://www.squeaksource.com/SBEODB/
http://www.squeaksource.com/novakj48BT/
http://www.squeaksource.com/ObjectsAreNouns/
http://www.squeaksource.com/IsisFields/
http://www.squeaksource.com/HtmlTableMorph/
http://www.squeaksource.com/sjQuinto/
http://www.squeaksource.com/testSS/
http://www.squeaksource.com/sw2fbs/
http://www.squeaksource.com/Metrics/
http://www.squeaksource.com/Packages/
http://www.squeaksource.com/SMarcs/
http://www.squeaksource.com/TBEvent/
http://www.squeaksource.com/Knigge/
http://www.squeaksource.com/Lan/
http://www.squeaksource.com/proyectoPrueba/
http://www.squeaksource.com/SBEF/
http://www.squeaksource.com/TicTacToe/
http://www.squeaksource.com/OSProcessPlugin/
http://www.squeaksource.com/SeasideTesting/
http://www.squeaksource.com/pjCS527rej/
http://www.squeaksource.com/HelloWorld/
http://www.squeaksource.com/testproject123/
http://www.squeaksource.com/musQuinto/
http://www.squeaksource.com/bandykut/
http://www.squeaksource.com/testsbe74/
http://www.squeaksource.com/hessian/
http://www.squeaksource.com/SqueakNOS/
http://www.squeaksource.com/EventTrackerPp/
http://www.squeaksource.com/VictAid/
http://www.squeaksource.com/AtomManager/
http://www.squeaksource.com/lucjsys1/
http://www.squeaksource.com/LearningProject/
http://www.squeaksource.com/SBEQuinto12/
http://www.squeaksource.com/QuintoPK/
http://www.squeaksource.com/PierPersistentStore2/
http://www.squeaksource.com/SqueakBot/
http://www.squeaksource.com/VWXML/
http://www.squeaksource.com/AidaSP/
http://www.squeaksource.com/laserGame/
http://www.squeaksource.com/PicoBlaze/
http://www.squeaksource.com/QuintoTest/
http://www.squeaksource.com/Smalltalk2Java/
http://www.squeaksource.com/AioPlugin/
http://www.squeaksource.com/SqueakPoint/
http://www.squeaksource.com/NewInspector/
http://www.squeaksource.com/LoFi/
http://www.squeaksource.com/TeaShop/
http://www.squeaksource.com/OpenDocument/
http://www.squeaksource.com/SqueakWiimote/
http://www.squeaksource.com/FCGI/
http://www.squeaksource.com/BipBip/
http://www.squeaksource.com/GStreamer/
http://www.squeaksource.com/ShoreBase/
http://www.squeaksource.com/NARSqueak/
http://www.squeaksource.com/LoFPlayer2/
http://www.squeaksource.com/Revenge/
http://www.squeaksource.com/ParallelPort/
http://www.squeaksource.com/Pastell/
http://www.squeaksource.com/Gutenberg/
http://www.squeaksource.com/BobsBrowser/
http://www.squeaksource.com/memcached/
http://www.squeaksource.com/Ecotalk/
http://www.squeaksource.com/mySBE/
http://www.squeaksource.com/SW/
http://www.squeaksource.com/PastaJIPE/
http://www.squeaksource.com/BrowserBooster/
http://www.squeaksource.com/SystemTracer2/
http://www.squeaksource.com/ADL/
http://www.squeaksource.com/Money/
http://www.squeaksource.com/StefCounter/
http://www.squeaksource.com/criterion1/
http://www.squeaksource.com/SandstoneExtention/
http://www.squeaksource.com/squeakelib/
http://www.squeaksource.com/Dispatch/
http://www.squeaksource.com/WindowsInstaller/
http://www.squeaksource.com/Conman/
http://www.squeaksource.com/awhsbe/
http://www.squeaksource.com/SBEQuintoPyg/
http://www.squeaksource.com/SBEQuintodgl/
http://www.squeaksource.com/BlockFile/
http://www.squeaksource.com/HttpSsp/
http://www.squeaksource.com/Scribd/
http://www.squeaksource.com/FileOutClasses/
http://www.squeaksource.com/OSProcess/
http://www.squeaksource.com/AnimationStudio/
http://www.squeaksource.com/smash/
http://www.squeaksource.com/StoryEvaluatorModel/
http://www.squeaksource.com/YupikaieiSBE/
http://www.squeaksource.com/Josie/
http://www.squeaksource.com/shapes/
http://www.squeaksource.com/GLMorphic/
http://www.squeaksource.com/RussianSupport/
http://www.squeaksource.com/ObjectiveCBridge/
http://www.squeaksource.com/skriptarna/
http://www.squeaksource.com/AdvProg2009/
http://www.squeaksource.com/PDALBS/
http://www.squeaksource.com/SmallWiki2Importer/
http://www.squeaksource.com/OmniBase/
http://www.squeaksource.com/picowiki/
http://www.squeaksource.com/Reflectivity/
http://www.squeaksource.com/BinaryTree/
http://www.squeaksource.com/InstanceEncoder/
http://www.squeaksource.com/floyd/
http://www.squeaksource.com/QuintoDave/
http://www.squeaksource.com/Stripes/
http://www.squeaksource.com/WorldOfMemory/
http://www.squeaksource.com/Cryptography/
http://www.squeaksource.com/MetaclassTalk/
http://www.squeaksource.com/ArbitraryPrecisionFl/
http://www.squeaksource.com/BackTalk/
http://www.squeaksource.com/SokobanEnh/
http://www.squeaksource.com/Hexconverter/
http://www.squeaksource.com/STheimanngecyasar/
http://www.squeaksource.com/StructureExplorer/
http://www.squeaksource.com/Saphir/
http://www.squeaksource.com/hpgl/
http://www.squeaksource.com/setup/
http://www.squeaksource.com/GdsFeel/
http://www.squeaksource.com/CircularReasoning/
http://www.squeaksource.com/Coverage/
http://www.squeaksource.com/LiveWiki/
http://www.squeaksource.com/SBEQuinto60/
http://www.squeaksource.com/TeamLocator/
http://www.squeaksource.com/ProcessWrapper/
http://www.squeaksource.com/Proment/
http://www.squeaksource.com/CS2340GT/
http://www.squeaksource.com/PierSecurityManager/
http://www.squeaksource.com/tween/
http://www.squeaksource.com/SentorsaSeasideForms/
http://www.squeaksource.com/DemoBuilder/
http://www.squeaksource.com/Hexagon/
http://www.squeaksource.com/paypal/
http://www.squeaksource.com/ChatServerCore/
http://www.squeaksource.com/Pica/
http://www.squeaksource.com/cmilitantwiki/
http://www.squeaksource.com/pokus/
http://www.squeaksource.com/GeoffreyKing/
http://www.squeaksource.com/Maps/
http://www.squeaksource.com/ss/
http://www.squeaksource.com/PierImageGallery/
http://www.squeaksource.com/AlienOpenGL/
http://www.squeaksource.com/SystemEditor/
http://www.squeaksource.com/FlexDB/
http://www.squeaksource.com/AST/
http://www.squeaksource.com/TraceLibrary/
http://www.squeaksource.com/PierTemplates/
http://www.squeaksource.com/MathMorphsRevival/
http://www.squeaksource.com/SUnit/
http://www.squeaksource.com/OrderedDictionary/
http://www.squeaksource.com/SemPrace/
http://www.squeaksource.com/SqAGI/
http://www.squeaksource.com/AdvancedProgramming/
http://www.squeaksource.com/AnytimeFunctions/
http://www.squeaksource.com/STV/
http://www.squeaksource.com/GeKonGeoAgent/
http://www.squeaksource.com/PhilsCode/
http://www.squeaksource.com/CROquetReqViz/
http://www.squeaksource.com/MatzESTTutTodoApp/
http://www.squeaksource.com/SWFObject/
http://www.squeaksource.com/TestSmells/
http://www.squeaksource.com/ProcessModel/
http://www.squeaksource.com/VacationTracking/
http://www.squeaksource.com/CS598rejCheckers/
http://www.squeaksource.com/Allowance/
http://www.squeaksource.com/JCompiledMethods/
http://www.squeaksource.com/SmallScheme/
http://www.squeaksource.com/GuidedLayout/
http://www.squeaksource.com/RemoteFracTalk/
http://www.squeaksource.com/FullImage/
http://www.squeaksource.com/MySUnitExtensions/
http://www.squeaksource.com/KensSBEQuinto/
http://www.squeaksource.com/SPort/
http://www.squeaksource.com/Scheduler/
http://www.squeaksource.com/PharoMorphicExtras/
http://www.squeaksource.com/FreeCellSolver/
http://www.squeaksource.com/WatchMorph/
http://www.squeaksource.com/DerrellTest/
http://www.squeaksource.com/QuintoGameExample/
http://www.squeaksource.com/AthenaS/
http://www.squeaksource.com/FelTimetable/
http://www.squeaksource.com/LightweightClasses/
http://www.squeaksource.com/LegoIR/
http://www.squeaksource.com/wkmSBEQuinto/
http://www.squeaksource.com/FixedDecimal/
http://www.squeaksource.com/wikiticy/
http://www.squeaksource.com/GoogleStaticMaps/
http://www.squeaksource.com/Jabber/
http://www.squeaksource.com/eToysTests/
http://www.squeaksource.com/Bank/
http://www.squeaksource.com/SqueakByExample/
http://www.squeaksource.com/Sparkle/
http://www.squeaksource.com/SunnysidePL2Loader/
http://www.squeaksource.com/QuintoGameByLC/
http://www.squeaksource.com/SBEQunitojsy/
http://www.squeaksource.com/syslog/
http://www.squeaksource.com/SwaLint/
http://www.squeaksource.com/Mixins/
http://www.squeaksource.com/quintosbe/
http://www.squeaksource.com/OmniBrowser/
http://www.squeaksource.com/MyExperiments/
http://www.squeaksource.com/OpenFlashChart/
http://www.squeaksource.com/iCMS/
http://www.squeaksource.com/Chomon/
http://www.squeaksource.com/Roboquad/
http://www.squeaksource.com/IMUSPackage/
http://www.squeaksource.com/AjProject/
http://www.squeaksource.com/Algo3iL/
http://www.squeaksource.com/bgpQuinto/
http://www.squeaksource.com/PharoByExample/
http://www.squeaksource.com/SDGoodsStore/
http://www.squeaksource.com/gamesbetestquinto/
http://www.squeaksource.com/IliadDev/
http://www.squeaksource.com/TwitterStatuses/
http://www.squeaksource.com/QuintoMBL/
http://www.squeaksource.com/FeatureBrowser/
http://www.squeaksource.com/PharoExamples/
http://www.squeaksource.com/IPDesignTool/
http://www.squeaksource.com/LabsTest/
http://www.squeaksource.com/Kilauea/
http://www.squeaksource.com/Kerala/
http://www.squeaksource.com/RFB/
http://www.squeaksource.com/Tanked/
http://www.squeaksource.com/Smallverse/
http://www.squeaksource.com/Bloc/
http://www.squeaksource.com/AnalogClock/
http://www.squeaksource.com/SCGPier/
http://www.squeaksource.com/Pazta/
http://www.squeaksource.com/ReflectiveTest/
http://www.squeaksource.com/Blokker/
http://www.squeaksource.com/YAQ/
http://www.squeaksource.com/MP3File/
http://www.squeaksource.com/MJKHARTDatatypes/
http://www.squeaksource.com/HeimTheory/
http://www.squeaksource.com/avilib/
http://www.squeaksource.com/LanAgMh/
http://www.squeaksource.com/ProvesSeaside/
http://www.squeaksource.com/daniloSPP/
http://www.squeaksource.com/VerletParticles/
http://www.squeaksource.com/ChrizelQuinto/
http://www.squeaksource.com/Sandcastle/
http://www.squeaksource.com/VMMaker/
http://www.squeaksource.com/MergingInPharo/
http://www.squeaksource.com/RubyShards/
http://www.squeaksource.com/SeasideAndSails/
http://www.squeaksource.com/ComputerShop/
http://www.squeaksource.com/SeasidePresentation/
http://www.squeaksource.com/ExtremeCalender07/
http://www.squeaksource.com/fnquinto/
http://www.squeaksource.com/SOO/
http://www.squeaksource.com/newtest/
http://www.squeaksource.com/eoglorp/
http://www.squeaksource.com/IMUSCitezen/
http://www.squeaksource.com/SeasideMVC/
http://www.squeaksource.com/Glorp37Compat/
http://www.squeaksource.com/Documentation/
http://www.squeaksource.com/Squeaky/
http://www.squeaksource.com/Quinto68/
http://www.squeaksource.com/HNExperiments/
http://www.squeaksource.com/JavaConnect/
http://www.squeaksource.com/Momo/
http://www.squeaksource.com/EEG/
http://www.squeaksource.com/POOElefante/
http://www.squeaksource.com/AuthorshipViewer/
http://www.squeaksource.com/Quintogame/
http://www.squeaksource.com/PhotosPublisher/
http://www.squeaksource.com/kejzljos/
http://www.squeaksource.com/KeyBinder/
http://www.squeaksource.com/vmProject/
http://www.squeaksource.com/Tomagoshi/
http://www.squeaksource.com/X36OBPBinaryTree/
http://www.squeaksource.com/Iterator/
http://www.squeaksource.com/MaPro/
http://www.squeaksource.com/XMLLambdaParser/
http://www.squeaksource.com/BKokSBEQuinto/
http://www.squeaksource.com/Java/
http://www.squeaksource.com/Sinapze/
http://www.squeaksource.com/CSVData/
http://www.squeaksource.com/Nile/
http://www.squeaksource.com/WebCounter/
http://www.squeaksource.com/GoogleMap/
http://www.squeaksource.com/Sake/
http://www.squeaksource.com/PJGWebCount/
http://www.squeaksource.com/SBEQuintoJRoss/
http://www.squeaksource.com/Quinto/
http://www.squeaksource.com/AMQP/
http://www.squeaksource.com/SW2NKDS/
http://www.squeaksource.com/BootStrappedClasses/
http://www.squeaksource.com/YASBEQuinto/
http://www.squeaksource.com/SUnitForDaliot/
http://www.squeaksource.com/Fame/
http://www.squeaksource.com/eCompletion/
http://www.squeaksource.com/InfoRepository/
http://www.squeaksource.com/Scribo/
http://www.squeaksource.com/uss/
http://www.squeaksource.com/SqueakAddOns/
http://www.squeaksource.com/MCUpdateTest/
http://www.squeaksource.com/ImusGutemberg/
http://www.squeaksource.com/Changeling/
http://www.squeaksource.com/PlayerST/
http://www.squeaksource.com/Subjectivity/
http://www.squeaksource.com/cs598frog/
http://www.squeaksource.com/iStoa/
http://www.squeaksource.com/ElefantePADA/
http://www.squeaksource.com/DocumentationManager/
http://www.squeaksource.com/ComixUI/
http://www.squeaksource.com/leh/
http://www.squeaksource.com/jhemono/
http://www.squeaksource.com/sqonopoly/
http://www.squeaksource.com/Officious/
http://www.squeaksource.com/Widgets/
http://www.squeaksource.com/SBEQuinto21apr09/
http://www.squeaksource.com/hos/
http://www.squeaksource.com/BinTreeullrilad/
http://www.squeaksource.com/KVBindings/
http://www.squeaksource.com/LoFEQ/
http://www.squeaksource.com/mediamanagement/
http://www.squeaksource.com/QuintoSBEGame/
http://www.squeaksource.com/Sorrow/
http://www.squeaksource.com/example/
http://www.squeaksource.com/UbiquitalkGB/
http://www.squeaksource.com/CS420Code/
http://www.squeaksource.com/NamedProcess/
http://www.squeaksource.com/Collaborations/
http://www.squeaksource.com/ModuleAlgebra/
http://www.squeaksource.com/Eg/
http://www.squeaksource.com/Lisp/
http://www.squeaksource.com/TDDFacilities/
http://www.squeaksource.com/iTD/
http://www.squeaksource.com/teste/
http://www.squeaksource.com/SnakeGame/
http://www.squeaksource.com/Tube45/
http://www.squeaksource.com/VoronoiDiagram/
http://www.squeaksource.com/QuintoPractice/
http://www.squeaksource.com/ThreadSafeTranscript/
http://www.squeaksource.com/QuintoGameSBE/
http://www.squeaksource.com/cDlm/
http://www.squeaksource.com/JamTomorrow/
http://www.squeaksource.com/ProcessLocalStorage/
http://www.squeaksource.com/SIN01/
http://www.squeaksource.com/CroquetBag/
http://www.squeaksource.com/GolfHolidays/
http://www.squeaksource.com/STSCGLBET/
http://www.squeaksource.com/ProjectEuler/
http://www.squeaksource.com/adhobpbintree/
http://www.squeaksource.com/st/
http://www.squeaksource.com/sha/
http://www.squeaksource.com/Ruslan/
http://www.squeaksource.com/ss2/
http://www.squeaksource.com/ECMSBETUTQuinto/
http://www.squeaksource.com/TransButor/
http://www.squeaksource.com/PurpleMonkeySite/
http://www.squeaksource.com/ChatServerGui/
http://www.squeaksource.com/PicaRobot/
http://www.squeaksource.com/Quinto01/
http://www.squeaksource.com/RenderMouse/
http://www.squeaksource.com/PixelFilter/
http://www.squeaksource.com/SqueakCells/
http://www.squeaksource.com/XMLPullParser/
http://www.squeaksource.com/Freezable/
http://www.squeaksource.com/BFAV2/
http://www.squeaksource.com/SqueakPipes/
http://www.squeaksource.com/BrowseUnit/
http://www.squeaksource.com/ams/
http://www.squeaksource.com/LCSTalk/
http://www.squeaksource.com/SeasideToDoNew/
http://www.squeaksource.com/Scrabble/
http://www.squeaksource.com/playWrite/
http://www.squeaksource.com/SimpleCoverage/
http://www.squeaksource.com/TimesTable/
http://www.squeaksource.com/Diamond/
http://www.squeaksource.com/MandelMorph2/
http://www.squeaksource.com/EtoyMaker/
http://www.squeaksource.com/QGame/
http://www.squeaksource.com/Units/
http://www.squeaksource.com/lnPBELightsOut/
http://www.squeaksource.com/STicky/
http://www.squeaksource.com/STDoc/
http://www.squeaksource.com/SqueakNosAcpi/
http://www.squeaksource.com/Soup/
http://www.squeaksource.com/SandBox/
http://www.squeaksource.com/Sapphire/
http://www.squeaksource.com/SQueaken/
http://www.squeaksource.com/Membra/
http://www.squeaksource.com/ContIntegration/
http://www.squeaksource.com/mpd/
http://www.squeaksource.com/PBELightsOut/
http://www.squeaksource.com/SqueakFS/
http://www.squeaksource.com/PEG/
http://www.squeaksource.com/Waveosplash/
http://www.squeaksource.com/JerryLearnSBE/
http://www.squeaksource.com/SyntaxHighlig/
http://www.squeaksource.com/hamstraQuinto/
http://www.squeaksource.com/QuintoGame1959/
http://www.squeaksource.com/modbus/
http://www.squeaksource.com/X36OBPExpressions/
http://www.squeaksource.com/mytstQuintoProj/
http://www.squeaksource.com/GoogleAnalytics/
http://www.squeaksource.com/dsm/
http://www.squeaksource.com/ClassboxJava/
http://www.squeaksource.com/StuartsStuff/
http://www.squeaksource.com/akuhn/
http://www.squeaksource.com/OpenPlay/
http://www.squeaksource.com/phexample/
http://www.squeaksource.com/BugsBeansAndToads/
http://www.squeaksource.com/SiliconSqueak/
http://www.squeaksource.com/Nanola/
http://www.squeaksource.com/HistOOry/
http://www.squeaksource.com/HttpView2/
http://www.squeaksource.com/CAG/
http://www.squeaksource.com/Diffusr/
http://www.squeaksource.com/Moose/
http://www.squeaksource.com/modelBookLibrary/
http://www.squeaksource.com/DrCroquet/
http://www.squeaksource.com/mc/
http://www.squeaksource.com/DeveloperWorkspace/
http://www.squeaksource.com/IRCLogViewer/
http://www.squeaksource.com/Hapax/
http://www.squeaksource.com/Linda/
http://www.squeaksource.com/BotIncPica/
http://www.squeaksource.com/Daskalos/
http://www.squeaksource.com/Prolog/
http://www.squeaksource.com/Briques/
http://www.squeaksource.com/PigTris/
http://www.squeaksource.com/SUnitsSlowNFast/
http://www.squeaksource.com/ToDoTutorial/
http://www.squeaksource.com/tbutests/
http://www.squeaksource.com/DeltaStreams/
http://www.squeaksource.com/BacklogManager/
http://www.squeaksource.com/AgentNo7/
http://www.squeaksource.com/VersionsBrowser2/
http://www.squeaksource.com/Fuzz/
http://www.squeaksource.com/RSSFeed/
http://www.squeaksource.com/SRK/
http://www.squeaksource.com/Scripter/
http://www.squeaksource.com/DynaGlyph/
http://www.squeaksource.com/QuintoWScores/
http://www.squeaksource.com/Merchant/
http://www.squeaksource.com/Stellar/
http://www.squeaksource.com/MooseAlgos/
http://www.squeaksource.com/DemoCounterAlGe/
http://www.squeaksource.com/afst/
http://www.squeaksource.com/Scamper/
http://www.squeaksource.com/APS/
http://www.squeaksource.com/TaiPei/
http://www.squeaksource.com/dnsclient/
http://www.squeaksource.com/HJRQuinto/
http://www.squeaksource.com/MockObjects/
http://www.squeaksource.com/test/
http://www.squeaksource.com/SBE8o7o6oa/
http://www.squeaksource.com/PharoGoodies/
http://www.squeaksource.com/AbeSbe/
http://www.squeaksource.com/FJSQuinto/
http://www.squeaksource.com/Celeste/
http://www.squeaksource.com/squeak/
http://www.squeaksource.com/PierPersistentStore/
http://www.squeaksource.com/Chronos/
http://www.squeaksource.com/Comix/
http://www.squeaksource.com/HTML/
http://www.squeaksource.com/SimpleCounter/
http://www.squeaksource.com/Numerics/
http://www.squeaksource.com/GigsManager/
http://www.squeaksource.com/jQueryNotMIT/
http://www.squeaksource.com/MethodAuthorship/
http://www.squeaksource.com/MyKakuroStuff/
http://www.squeaksource.com/SBEQuintoEMS/
http://www.squeaksource.com/lightsout/
http://www.squeaksource.com/Applescript/
http://www.squeaksource.com/MAStorage/
http://www.squeaksource.com/SelfSendCounter/
http://www.squeaksource.com/Kalorik/
http://www.squeaksource.com/PharoTaskForces/
http://www.squeaksource.com/QuintoTestExample/
http://www.squeaksource.com/DomView/
http://www.squeaksource.com/Phoenix/
http://www.squeaksource.com/Keymapping/
http://www.squeaksource.com/fradoSBEQuinto/
http://www.squeaksource.com/MPKSimulation/
http://www.squeaksource.com/zsu0915Quinto/
http://www.squeaksource.com/RoerdQuinto/
http://www.squeaksource.com/FancyBinaryTree/
http://www.squeaksource.com/MosaicGenerator/
http://www.squeaksource.com/TeamModulus/
http://www.squeaksource.com/DependencyAnalyzer/
http://www.squeaksource.com/OCV/
http://www.squeaksource.com/PrintProjectsAsPng/
http://www.squeaksource.com/Minotaur09/
http://www.squeaksource.com/Pastajgg/
http://www.squeaksource.com/PigTris2/
http://www.squeaksource.com/stlecture/
http://www.squeaksource.com/ByteCode/
http://www.squeaksource.com/AdvancedRuby/
http://www.squeaksource.com/SqueakPoker/
http://www.squeaksource.com/quintounico/
http://www.squeaksource.com/binarniStromOBP/
http://www.squeaksource.com/Compass/
http://www.squeaksource.com/unlur/
http://www.squeaksource.com/REServe/
http://www.squeaksource.com/dtwSBEQuinto/
http://www.squeaksource.com/BackupMaker/
http://www.squeaksource.com/MuseoVirtualWeb/
http://www.squeaksource.com/BinarniStrom/
http://www.squeaksource.com/DemoCounter/
http://www.squeaksource.com/KedamaPlugins/
http://www.squeaksource.com/MonticelloMultiRep/
http://www.squeaksource.com/BinTree/
http://www.squeaksource.com/MAD/
http://www.squeaksource.com/SBEQuintoGamePackage/
http://www.squeaksource.com/KFGui/
http://www.squeaksource.com/FieldCrawler/
http://www.squeaksource.com/QC/
http://www.squeaksource.com/Mold/
http://www.squeaksource.com/RpnCalculator/
http://www.squeaksource.com/AstroMorphs/
http://www.squeaksource.com/Asteroid/
http://www.squeaksource.com/minotauros/
http://www.squeaksource.com/GemStone/
http://www.squeaksource.com/BlueSequence/
http://www.squeaksource.com/Autotester/
http://www.squeaksource.com/1337MorphicLayouts/
http://www.squeaksource.com/SqueakManhattan/
http://www.squeaksource.com/shout/
http://www.squeaksource.com/Seaside29old/
http://www.squeaksource.com/GraphGear/
http://www.squeaksource.com/Tsunami/
http://www.squeaksource.com/UbiquiTalk/
http://www.squeaksource.com/ASTBridge/
http://www.squeaksource.com/KBComix/
http://www.squeaksource.com/essai/
http://www.squeaksource.com/QuintoNeoe/
http://www.squeaksource.com/WebTester/
http://www.squeaksource.com/Lichtenberg/
http://www.squeaksource.com/loxo/
http://www.squeaksource.com/btree0obp0kyle/
http://www.squeaksource.com/CWGenerator/
http://www.squeaksource.com/XPath/
http://www.squeaksource.com/PunchedCards/
http://www.squeaksource.com/BuildBot/
http://www.squeaksource.com/TeamCreation/
http://www.squeaksource.com/dstreminder/
http://www.squeaksource.com/GlueForObjectHistory/
http://www.squeaksource.com/Lecos/
http://www.squeaksource.com/Dojo/
http://www.squeaksource.com/fgg/
http://www.squeaksource.com/LaserGame/
http://www.squeaksource.com/PEGSQLParser/
http://www.squeaksource.com/SeaBreezePort/
http://www.squeaksource.com/ODE/
http://www.squeaksource.com/WifiBot/
http://www.squeaksource.com/ATEO/
http://www.squeaksource.com/projectSquish/
http://www.squeaksource.com/EngJourneering/
http://www.squeaksource.com/EventTracker/
http://www.squeaksource.com/COM/
http://www.squeaksource.com/DirtyPacketsPlaybenc/
http://www.squeaksource.com/TestSBEQuinto/
http://www.squeaksource.com/DependencyWalker/
http://www.squeaksource.com/DidYouKnow/
http://www.squeaksource.com/ImageForDevelopers/
http://www.squeaksource.com/SW2Utilities/
http://www.squeaksource.com/Printf/
http://www.squeaksource.com/pda/
http://www.squeaksource.com/Smalltalks2009/
http://www.squeaksource.com/IRC/
http://www.squeaksource.com/pmj1st/
http://www.squeaksource.com/EasyMorphicGUI/
http://www.squeaksource.com/KidsFirst/
http://www.squeaksource.com/rsrss/
http://www.squeaksource.com/BkbagSeasideTesting/
http://www.squeaksource.com/sFOP/
http://www.squeaksource.com/notebook/
http://www.squeaksource.com/MiniToDo/
http://www.squeaksource.com/TypePlug/
http://www.squeaksource.com/KFMysql/
http://www.squeaksource.com/OBProtocolBrowser/
http://www.squeaksource.com/Orion/
http://www.squeaksource.com/GNUPlot/
http://www.squeaksource.com/Quinto1/
http://www.squeaksource.com/FracTalkPlus/
http://www.squeaksource.com/MoViz/
http://www.squeaksource.com/mjhQuintoGame/
http://www.squeaksource.com/DeepAquariumMVC/
http://www.squeaksource.com/jqueryplugins/
http://www.squeaksource.com/ScoutTracker/
http://www.squeaksource.com/HotelReservation/
http://www.squeaksource.com/PhotoBlog/
http://www.squeaksource.com/BackgroundLoader/
http://www.squeaksource.com/Mondrian/
http://www.squeaksource.com/owtrta/
http://www.squeaksource.com/KomWebServer/
http://www.squeaksource.com/TigersAndGoats/
http://www.squeaksource.com/ScreenLogger/
http://www.squeaksource.com/traitstesis/
http://www.squeaksource.com/MyTestProjectQuinto/
http://www.squeaksource.com/OldPocketQuinto/
http://www.squeaksource.com/PLoPtc/
http://www.squeaksource.com/HandySimulator/
http://www.squeaksource.com/khunjiri/
http://www.squeaksource.com/SBEQuinto2008/
http://www.squeaksource.com/A2/
http://www.squeaksource.com/Video4Squeak/
http://www.squeaksource.com/PacoHello/
http://www.squeaksource.com/AsciiDosConverter/
http://www.squeaksource.com/aramactex/
http://www.squeaksource.com/cs2340M2/
http://www.squeaksource.com/Prototype/
http://www.squeaksource.com/CS598rjSummer09/
http://www.squeaksource.com/Morphic/
http://www.squeaksource.com/Spy/
http://www.squeaksource.com/CardsGame/
http://www.squeaksource.com/IPAddressArithmetics/
http://www.squeaksource.com/AidaBrowser/
http://www.squeaksource.com/AidaContributed/
http://www.squeaksource.com/AsTimeGoesBy/
http://www.squeaksource.com/SueldosEducacion/
http://www.squeaksource.com/Nothing/
http://www.squeaksource.com/PastaSRA/
http://www.squeaksource.com/SelectorNamespace/
http://www.squeaksource.com/CORC/
http://www.squeaksource.com/DynamicSynch/
http://www.squeaksource.com/Beepeng/
http://www.squeaksource.com/metacello/
http://www.squeaksource.com/abel/
http://www.squeaksource.com/Elefante/
http://www.squeaksource.com/Brie/
http://www.squeaksource.com/StoryEvaluator/
http://www.squeaksource.com/SBEQuintoPWB/
http://www.squeaksource.com/SmallBrother/
http://www.squeaksource.com/Lumiere/
http://www.squeaksource.com/MultipleMops/
http://www.squeaksource.com/Compiler/
http://www.squeaksource.com/MSE/
http://www.squeaksource.com/Mewa/
http://www.squeaksource.com/PharoTreatedInbox/
http://www.squeaksource.com/WikiTracker/
http://www.squeaksource.com/UnitTestTP/
http://www.squeaksource.com/dpstest/
http://www.squeaksource.com/NewFileInOutFormat/
http://www.squeaksource.com/MutationTesting/
http://www.squeaksource.com/Classroom/
http://www.squeaksource.com/FracTalkAOP/
http://www.squeaksource.com/Green/
http://www.squeaksource.com/KenD/
http://www.squeaksource.com/ClassboxBrowser/
http://www.squeaksource.com/BinTreeX36OBP/
http://www.squeaksource.com/Miro/
http://www.squeaksource.com/MAPIClient/
http://www.squeaksource.com/SelfEvaluatingObject/
http://www.squeaksource.com/codescope/
http://www.squeaksource.com/sbelgl/
http://www.squeaksource.com/BeachFrontCommunity/
http://www.squeaksource.com/CollectionManager/
http://www.squeaksource.com/TraitsModel/
http://www.squeaksource.com/CS598rej/
http://www.squeaksource.com/SmaccDevelopment/
http://www.squeaksource.com/MyQuintoTest/
http://www.squeaksource.com/SmalltalkRbRuntime/
http://www.squeaksource.com/IRCBot/
http://www.squeaksource.com/PackagesForSqueak/
http://www.squeaksource.com/Slideshow/
http://www.squeaksource.com/Bibliothouris/
http://www.squeaksource.com/PastaAGS/
http://www.squeaksource.com/Choose/
http://www.squeaksource.com/JamesWhiteneckCS520/
http://www.squeaksource.com/LightsOutWVR/
http://www.squeaksource.com/PacketStudio/
http://www.squeaksource.com/SapphireInbox/
http://www.squeaksource.com/Chuck/
http://www.squeaksource.com/Faces/
http://www.squeaksource.com/QuintoGameMookyn/
http://www.squeaksource.com/Janus/
http://www.squeaksource.com/ep1/
http://www.squeaksource.com/MYQuinto/
http://www.squeaksource.com/CurlPlugin/
http://www.squeaksource.com/hh2/
http://www.squeaksource.com/CodA/
http://www.squeaksource.com/ExtMetaclasses/
http://www.squeaksource.com/Kuntatti/
http://www.squeaksource.com/GoodsServer/
http://www.squeaksource.com/AALocalHome/
http://www.squeaksource.com/LANimus2006/
http://www.squeaksource.com/PostgresV2/
http://www.squeaksource.com/391/
http://www.squeaksource.com/Labase/
http://www.squeaksource.com/TheRealDrCroquet/
http://www.squeaksource.com/UIUC4OLPC/
http://www.squeaksource.com/stamp/
http://www.squeaksource.com/SqueakSet/
http://www.squeaksource.com/WaveBreak/
http://www.squeaksource.com/STLecture07/
http://www.squeaksource.com/bskScribbles/
http://www.squeaksource.com/VladimirSBEQuinto/
http://www.squeaksource.com/JDColorPicker/
http://www.squeaksource.com/AuthorChecker/
http://www.squeaksource.com/311/
http://www.squeaksource.com/ChuckBench/
http://www.squeaksource.com/DrGeoII/
http://www.squeaksource.com/MARPGE/
http://www.squeaksource.com/JBARepo/
http://www.squeaksource.com/VHRP/
http://www.squeaksource.com/SplitJoin/
http://www.squeaksource.com/StarBrowser/
http://www.squeaksource.com/BaseLandes/
http://www.squeaksource.com/LatestInspector/
http://www.squeaksource.com/XDCP/
http://www.squeaksource.com/YahooWebServices/
http://www.squeaksource.com/Glamour/
http://www.squeaksource.com/StatefulTraits/
http://www.squeaksource.com/Shark/
http://www.squeaksource.com/ajp/
http://www.squeaksource.com/ShareWork/
http://www.squeaksource.com/smhquinto/
http://www.squeaksource.com/DoubleLinkedList/
http://www.squeaksource.com/FATALL/
http://www.squeaksource.com/Null/
http://www.squeaksource.com/RsvgPlugin/
http://www.squeaksource.com/MusicAll/
http://www.squeaksource.com/TallySupport/
http://www.squeaksource.com/pkquinto/
http://www.squeaksource.com/Traits/
http://www.squeaksource.com/ChristmasWishLists/
http://www.squeaksource.com/koprizde/
http://www.squeaksource.com/FelBinarTree/
http://www.squeaksource.com/SBE/
http://www.squeaksource.com/IOSPersistent/
http://www.squeaksource.com/CI/
http://www.squeaksource.com/Numb3rs/
http://www.squeaksource.com/impilearn/
http://www.squeaksource.com/PictureBook/
http://www.squeaksource.com/FTPServer/
http://www.squeaksource.com/ateubner/
http://www.squeaksource.com/Seaside30Addons/
http://www.squeaksource.com/CairoGraphics/
http://www.squeaksource.com/stehnvl1obp/
http://www.squeaksource.com/Games/
http://www.squeaksource.com/stroljakbt/
http://www.squeaksource.com/SDLWorkbench/
http://www.squeaksource.com/GoogleCharts/
http://www.squeaksource.com/dbus/
http://www.squeaksource.com/VocaLearning/
http://www.squeaksource.com/RayQuinto/
http://www.squeaksource.com/WAX/
http://www.squeaksource.com/Classloader/
http://www.squeaksource.com/Enigma/
http://www.squeaksource.com/Perseus/
http://www.squeaksource.com/CFD/
http://www.squeaksource.com/AZA/
http://www.squeaksource.com/NineMensMorris/
http://www.squeaksource.com/OggPlugin/
http://www.squeaksource.com/MapComponent/
http://www.squeaksource.com/ReverseGeneric/
http://www.squeaksource.com/CardCombat/
http://www.squeaksource.com/OmniCompass/
http://www.squeaksource.com/SOIDavos/
http://www.squeaksource.com/SeasideBlog/
http://www.squeaksource.com/BORGQuinto/
http://www.squeaksource.com/zondsSBEQuinto/
http://www.squeaksource.com/ROE/
http://www.squeaksource.com/CollectionExtensions/
http://www.squeaksource.com/WebStore/
http://www.squeaksource.com/CroquetMD/
http://www.squeaksource.com/WordsRepeat/
http://www.squeaksource.com/suduku/
http://www.squeaksource.com/SBEQuintoSFED/
http://www.squeaksource.com/MethodWrappers/
http://www.squeaksource.com/JJSBEQuinto/
http://www.squeaksource.com/ReserveerBeer/
http://www.squeaksource.com/Fibonacci/
http://www.squeaksource.com/CIS/
http://www.squeaksource.com/KomHttpServer/
http://www.squeaksource.com/SAweb/
http://www.squeaksource.com/RobertLarrabee/
http://www.squeaksource.com/Jacaranda/
http://www.squeaksource.com/Rtoys/
http://www.squeaksource.com/Sketchbook/
http://www.squeaksource.com/iCalSummerTalk/
http://www.squeaksource.com/ccst/
http://www.squeaksource.com/ChangetechCoreman/
http://www.squeaksource.com/jQuery/
http://www.squeaksource.com/Sanki/
http://www.squeaksource.com/SmallLang/
http://www.squeaksource.com/MLSudoku/
http://www.squeaksource.com/smallwiki/
http://www.squeaksource.com/DebtReduction/
http://www.squeaksource.com/BBProjectDescription/
http://www.squeaksource.com/SmallFinance/
http://www.squeaksource.com/Glorp/
http://www.squeaksource.com/jobeQuinto/
http://www.squeaksource.com/INIFile/
http://www.squeaksource.com/WireSqueak/
http://www.squeaksource.com/Prevayler/
http://www.squeaksource.com/SmallFaces/
http://www.squeaksource.com/ViewPoints/
http://www.squeaksource.com/MagritteGlorp/
http://www.squeaksource.com/WikiPhone/
http://www.squeaksource.com/Gruppe15Projekt/
http://www.squeaksource.com/ali/
http://www.squeaksource.com/SmallReddit/
http://www.squeaksource.com/STExercises/
http://www.squeaksource.com/shoffle/
http://www.squeaksource.com/MooseJEE/
http://www.squeaksource.com/PicasaClient/
http://www.squeaksource.com/A3/
http://www.squeaksource.com/siwi/
http://www.squeaksource.com/PortingJTP/
http://www.squeaksource.com/Testing/
http://www.squeaksource.com/Ted/
http://www.squeaksource.com/jbendge/
http://www.squeaksource.com/LanguageInfo/
http://www.squeaksource.com/rST/
http://www.squeaksource.com/SpyCam/
http://www.squeaksource.com/APOO/
http://www.squeaksource.com/MyRepo/
http://www.squeaksource.com/RetonatorLearning/
http://www.squeaksource.com/BuildBtMockProject/
http://www.squeaksource.com/Wabbe/
http://www.squeaksource.com/SipStack/
http://www.squeaksource.com/BreakOut/
http://www.squeaksource.com/PhysicalEtoys/
http://www.squeaksource.com/SBEquintoGame/
http://www.squeaksource.com/Regex/
http://www.squeaksource.com/ht/
http://www.squeaksource.com/TraitsInClassboxes/
http://www.squeaksource.com/PackageClassSwitch/
http://www.squeaksource.com/Persephone/
http://www.squeaksource.com/ARCQuinto/
http://www.squeaksource.com/Assignment1/
http://www.squeaksource.com/ArbreDesCauses/
http://www.squeaksource.com/PreferenceBrowser/
http://www.squeaksource.com/testing123/
http://www.squeaksource.com/FreeRM/
http://www.squeaksource.com/BkbagMagritteTesting/
http://www.squeaksource.com/SFR/
http://www.squeaksource.com/Realtalk/
http://www.squeaksource.com/MiniTurtle/
http://www.squeaksource.com/jphplay/
http://www.squeaksource.com/MatrixPlugin/
http://www.squeaksource.com/ExpertSystem/
http://www.squeaksource.com/kSBEQuinto/
http://www.squeaksource.com/Refactory/
http://www.squeaksource.com/TreeMerge/
http://www.squeaksource.com/ArkhamHorror/
http://www.squeaksource.com/Amuda/
http://www.squeaksource.com/HennerJakob/
http://www.squeaksource.com/URI/
http://www.squeaksource.com/BinaryTreeJT/
http://www.squeaksource.com/GenericActions/
http://www.squeaksource.com/SystemBenchmarks/
http://www.squeaksource.com/SeaMonkey/
http://www.squeaksource.com/Breakout/
http://www.squeaksource.com/LDAPlayer/
http://www.squeaksource.com/ISobot/
http://www.squeaksource.com/SW2Calendar/
http://www.squeaksource.com/QuintoNadav/
http://www.squeaksource.com/UAPOSBEQuinto/
http://www.squeaksource.com/RobotSoccer/
http://www.squeaksource.com/DestinoMochila/
http://www.squeaksource.com/TraitsBrowser/
http://www.squeaksource.com/DynaMoose/
http://www.squeaksource.com/NewCompiler/
http://www.squeaksource.com/SeasideExamples/
http://www.squeaksource.com/TODO/
http://www.squeaksource.com/JKExperiments/
http://www.squeaksource.com/iPhone/
http://www.squeaksource.com/seasideWorkshop08/
http://www.squeaksource.com/Seal3D/
http://www.squeaksource.com/plotr/
http://www.squeaksource.com/SOAPClientExamples/
http://www.squeaksource.com/P1/
http://www.squeaksource.com/PicasaClientLightbox/
http://www.squeaksource.com/Seaside30/
http://www.squeaksource.com/ex2/
http://www.squeaksource.com/StaticPierGen/
http://www.squeaksource.com/Lava/
http://www.squeaksource.com/TalkBack/
http://www.squeaksource.com/OLPCPB/
http://www.squeaksource.com/Battleship/
http://www.squeaksource.com/AKSEAsteroid/
http://www.squeaksource.com/DDE/
http://www.squeaksource.com/RMOCQuinto/
http://www.squeaksource.com/cellVision/
http://www.squeaksource.com/justagame/
http://www.squeaksource.com/TPSBEQuinto/
http://www.squeaksource.com/corewar/
http://www.squeaksource.com/jpptest/
http://www.squeaksource.com/KryptOn/
http://www.squeaksource.com/ceeiExercise4/
http://www.squeaksource.com/Wudoku/
http://www.squeaksource.com/PlusTools/
http://www.squeaksource.com/PedidosWeb/
http://www.squeaksource.com/GlassSubject/
http://www.squeaksource.com/PAOD/
http://www.squeaksource.com/SWTTrackback/
http://www.squeaksource.com/moody2/
http://www.squeaksource.com/FracTalk/
http://www.squeaksource.com/FMA/
http://www.squeaksource.com/MAFTest/
http://www.squeaksource.com/LightsOutCS520VM/
http://www.squeaksource.com/gkoquinto/
http://www.squeaksource.com/MagmaTester/
http://www.squeaksource.com/BobsUI/
http://www.squeaksource.com/SimpleTextParser/
http://www.squeaksource.com/PharoSound/
http://www.squeaksource.com/ParseNodeMods/
http://www.squeaksource.com/FRP/
http://www.squeaksource.com/Quaternion/
http://www.squeaksource.com/DiscussionInPIER/
http://www.squeaksource.com/LazyList/
http://www.squeaksource.com/DispatchingZoo/
http://www.squeaksource.com/Monticello/
http://www.squeaksource.com/RSZSBEQuinto/
http://www.squeaksource.com/FileOmnibrowser/
http://www.squeaksource.com/AlgoInANutshell/
http://www.squeaksource.com/MultilingualTests/
http://www.squeaksource.com/Squant/
http://www.squeaksource.com/SunnysidePLLoader/
http://www.squeaksource.com/MudPie/
http://www.squeaksource.com/Namespace/
http://www.squeaksource.com/BinarStrom/
http://www.squeaksource.com/Othello/
http://www.squeaksource.com/TuringMachine2/
http://www.squeaksource.com/Pastadgl/
http://www.squeaksource.com/SunnysidePlanning/
http://www.squeaksource.com/fdCS420/
http://www.squeaksource.com/PackageInfoExtras/
http://www.squeaksource.com/Faure/
http://www.squeaksource.com/FCA/
http://www.squeaksource.com/Arimaa/
http://www.squeaksource.com/kjquinto/
http://www.squeaksource.com/Geography/
http://www.squeaksource.com/Seaside/
http://www.squeaksource.com/spsEval/
http://www.squeaksource.com/PastaARM/
http://www.squeaksource.com/adl/
http://www.squeaksource.com/CLFramework/
http://www.squeaksource.com/ExercisesST/
http://www.squeaksource.com/LightsOut/
http://www.squeaksource.com/SAASSBEQuinto/
http://www.squeaksource.com/MyBox/
http://www.squeaksource.com/SBEQuinto12345/
http://www.squeaksource.com/Hermes/
http://www.squeaksource.com/IOOBCarcassone/
http://www.squeaksource.com/PhotoCatalog/
http://www.squeaksource.com/EventsMonitor/
http://www.squeaksource.com/NSGame/
http://www.squeaksource.com/InterleavedChangeSet/
http://www.squeaksource.com/MooseDen/
http://www.squeaksource.com/SBEQuintoGF/
http://www.squeaksource.com/HaigSBEQuinto/
http://www.squeaksource.com/opensearch/
http://www.squeaksource.com/sourcetalk/
http://www.squeaksource.com/TokyoTyrant/
http://www.squeaksource.com/Classbox/
http://www.squeaksource.com/Z3950/
http://www.squeaksource.com/DiagramBrowser/
http://www.squeaksource.com/SBEQuintoJDP/
http://www.squeaksource.com/POSys/
http://www.squeaksource.com/quintoTest/
http://www.squeaksource.com/Binarytree/
http://www.squeaksource.com/CS420HSS/
http://www.squeaksource.com/SBEQuintoByJLB/
http://www.squeaksource.com/BinaryStreamTools/
http://www.squeaksource.com/openid/
http://www.squeaksource.com/SqueakTooth/
http://www.squeaksource.com/SeaBookCalendars/
http://www.squeaksource.com/Jabbertalk/
http://www.squeaksource.com/PFBackup/
http://www.squeaksource.com/ZSBE/
http://www.squeaksource.com/Pharo/
http://www.squeaksource.com/JRH/
http://www.squeaksource.com/ChatClientFEL/
http://www.squeaksource.com/ZurgleAnimation/
http://www.squeaksource.com/oystaex/
http://www.squeaksource.com/MagicWords/
http://www.squeaksource.com/SubastasInversas/
http://www.squeaksource.com/Chris/
http://www.squeaksource.com/animat/
http://www.squeaksource.com/RoelTyper/
http://www.squeaksource.com/SVI/
http://www.squeaksource.com/CollectiveBehavior/
http://www.squeaksource.com/SOI/
http://www.squeaksource.com/smtpserver/
http://www.squeaksource.com/SmalltalkAMF/
http://www.squeaksource.com/VocSide/
http://www.squeaksource.com/openmoney/
http://www.squeaksource.com/CommandShell/
http://www.squeaksource.com/DiffMerge/
http://www.squeaksource.com/GeKonContinuousStr/
http://www.squeaksource.com/Trike/
http://www.squeaksource.com/SGrid/
http://www.squeaksource.com/SBEQuintoDHD/
http://www.squeaksource.com/OLE/
http://www.squeaksource.com/SBEQuintoGameJK/
http://www.squeaksource.com/MetaF/
http://www.squeaksource.com/RefactoringEngine/
http://www.squeaksource.com/Gradebook/
http://www.squeaksource.com/MyFirstSqueakProject/
http://www.squeaksource.com/Isaac/
http://www.squeaksource.com/Combat/
http://www.squeaksource.com/NiceDoIt/
http://www.squeaksource.com/Actalk/
http://www.squeaksource.com/Net/
http://www.squeaksource.com/MamboHTTP/
http://www.squeaksource.com/SHPica/
http://www.squeaksource.com/STTutTodoApp/
http://www.squeaksource.com/SchoolFun/
http://www.squeaksource.com/Scl/
http://www.squeaksource.com/SBEQuintoTest/
http://www.squeaksource.com/intelliwhisker/
http://www.squeaksource.com/FontDisplayer/
http://www.squeaksource.com/VentaDirecta/
http://www.squeaksource.com/JDRQuinto/
http://www.squeaksource.com/Giselle/
http://www.squeaksource.com/pokus1/
http://www.squeaksource.com/PetiCategory/
http://www.squeaksource.com/unsorted/
http://www.squeaksource.com/XTream/
http://www.squeaksource.com/Beach/
http://www.squeaksource.com/WatchIt/
http://www.squeaksource.com/AsteriskMonitor/
http://www.squeaksource.com/cindytest/
http://www.squeaksource.com/HomeSecurity/
http://www.squeaksource.com/Tafers/
http://www.squeaksource.com/TraceDebugger/
http://www.squeaksource.com/Batuta/
http://www.squeaksource.com/SBEJoel/
http://www.squeaksource.com/Slots/
http://www.squeaksource.com/SphericalMaps/
http://www.squeaksource.com/SqueakNxt/
http://www.squeaksource.com/RemoteObjects/
http://www.squeaksource.com/2340sum05/
http://www.squeaksource.com/OSCClient/
http://www.squeaksource.com/herdbehavior/
http://www.squeaksource.com/Radar/
http://www.squeaksource.com/azzz/
http://www.squeaksource.com/Gamopoly/
http://www.squeaksource.com/Gnicils/
http://www.squeaksource.com/SBEQUINTO/
http://www.squeaksource.com/4C/
http://www.squeaksource.com/Iliad/
http://www.squeaksource.com/Quotes/
http://www.squeaksource.com/Ladrillos/
http://www.squeaksource.com/MyQuinto/
http://www.squeaksource.com/FreeTypePlus/
http://www.squeaksource.com/Maui/
http://www.squeaksource.com/NamedSerialPort/
http://www.squeaksource.com/3C/
http://www.squeaksource.com/SBEQuintoEx/
http://www.squeaksource.com/ID3Tags/
http://www.squeaksource.com/OpenVG/
http://www.squeaksource.com/SBEQuintojag/
http://www.squeaksource.com/TLCSBE1/
http://www.squeaksource.com/FICalculator/
http://www.squeaksource.com/CMQG/
http://www.squeaksource.com/ThingLab/
http://www.squeaksource.com/LAN/
http://www.squeaksource.com/BirdView/
http://www.squeaksource.com/Rikaiko/
http://www.squeaksource.com/SmalltalkInPerseus/
http://www.squeaksource.com/SeasideMootools/
http://www.squeaksource.com/romividmar/
http://www.squeaksource.com/ks001/
http://www.squeaksource.com/MASMSBEQuinto/
http://www.squeaksource.com/DacMotorola/
http://www.squeaksource.com/FrobS/
http://www.squeaksource.com/iPhotoSupport/
http://www.squeaksource.com/SmallScript/
http://www.squeaksource.com/BobsUIDevelopment/
http://www.squeaksource.com/GlorpPostGIS/
http://www.squeaksource.com/MyWorkStuff/
http://www.squeaksource.com/myTestQuinto/
http://www.squeaksource.com/SSPQuinto/
http://www.squeaksource.com/ANTLR/
http://www.squeaksource.com/Minigolf/
http://www.squeaksource.com/Blackjack/
http://www.squeaksource.com/Merlin/
http://www.squeaksource.com/FullText/
http://www.squeaksource.com/VolkmannMorphic/
http://www.squeaksource.com/OmniTesting/
http://www.squeaksource.com/Almond/
http://www.squeaksource.com/tenantDB/
http://www.squeaksource.com/yubikey/
http://www.squeaksource.com/JohnsPlayground/
http://www.squeaksource.com/OurCollections/
http://www.squeaksource.com/Metanool/
http://www.squeaksource.com/HelmholtzKarlsruhe/
http://www.squeaksource.com/SBEQuinto123/
http://www.squeaksource.com/SqueakDefense/
http://www.squeaksource.com/billgkohlSBEQuinto/
http://www.squeaksource.com/LanguageEditor/
http://www.squeaksource.com/SqueakBackgammon/
http://www.squeaksource.com/ARTAS/
http://www.squeaksource.com/MRHSBE/
http://www.squeaksource.com/PointerExplorer/
http://www.squeaksource.com/ARBQuinto/
http://www.squeaksource.com/djminotauros/
http://www.squeaksource.com/libnotify/
http://www.squeaksource.com/SampleApp/
http://www.squeaksource.com/DMPQuinto/
http://www.squeaksource.com/Installer/
http://www.squeaksource.com/TeamSquawk/
http://www.squeaksource.com/OBUniverse/
http://www.squeaksource.com/TicTacToeFOOP/
http://www.squeaksource.com/HTTPClient/
http://www.squeaksource.com/QuickQuinto/
http://www.squeaksource.com/ParObj/
http://www.squeaksource.com/ImageMap/
http://www.squeaksource.com/Logging/
http://www.squeaksource.com/pfkSBEexercise/
http://www.squeaksource.com/SawfishCompat/
http://www.squeaksource.com/fs/
http://www.squeaksource.com/SeaBookToDo/
http://www.squeaksource.com/CodeScope/
http://www.squeaksource.com/Conrad/
http://www.squeaksource.com/Scaffolding/
http://www.squeaksource.com/ComplexExtensions/
http://www.squeaksource.com/jloSappariWeb/
http://www.squeaksource.com/fuelconverter/
http://www.squeaksource.com/BigBrother/
http://www.squeaksource.com/SillySort/
http://www.squeaksource.com/TTT/
http://www.squeaksource.com/Athena/
http://www.squeaksource.com/Coral/
http://www.squeaksource.com/BoggleCS598rej/
http://www.squeaksource.com/MarbleBox/
http://www.squeaksource.com/phork/
http://www.squeaksource.com/TaserianSqueak/
http://www.squeaksource.com/KastnerQuinto/
http://www.squeaksource.com/Speech/
http://www.squeaksource.com/Installers/
http://www.squeaksource.com/CoverageTestCase/
http://www.squeaksource.com/BinarniStro/
http://www.squeaksource.com/dogastestproject/
http://www.squeaksource.com/Currency/
http://www.squeaksource.com/kdscrum/
http://www.squeaksource.com/Archaeology/
http://www.squeaksource.com/semestral/
http://www.squeaksource.com/Curso/
http://www.squeaksource.com/rb/
http://www.squeaksource.com/PerunTest/
http://www.squeaksource.com/FileOutProject/
http://www.squeaksource.com/ical/
http://www.squeaksource.com/Quintotest1/
http://www.squeaksource.com/backup/
http://www.squeaksource.com/PolicyTools/
http://www.squeaksource.com/SmaCCOld/
http://www.squeaksource.com/dialogs/
http://www.squeaksource.com/repositorytest/
http://www.squeaksource.com/Names/
http://www.squeaksource.com/sbeTestQuinto/
http://www.squeaksource.com/SpaceWar/
http://www.squeaksource.com/ClassSelectorSets/
http://www.squeaksource.com/Freetype/
http://www.squeaksource.com/MatleyExpose/
http://www.squeaksource.com/Rio/
http://www.squeaksource.com/sblog/
http://www.squeaksource.com/SUnitExtensions/
http://www.squeaksource.com/ExtDock/
http://www.squeaksource.com/Essai28L/
http://www.squeaksource.com/sternQuintoGame/
http://www.squeaksource.com/SBEQuintoSDM/
http://www.squeaksource.com/BinarniStromMrazP/
http://www.squeaksource.com/PictureBookv2/
http://www.squeaksource.com/AmazTalk/
http://www.squeaksource.com/SWATetris/
http://www.squeaksource.com/Metaboard/
http://www.squeaksource.com/DMWCroquet/
http://www.squeaksource.com/SBEQuintoEG/
http://www.squeaksource.com/SampleImageViewer/
http://www.squeaksource.com/pre310/
http://www.squeaksource.com/nemsbequintogame/
http://www.squeaksource.com/SBSBEQuinto/
http://www.squeaksource.com/PluggablePlotMorph/
http://www.squeaksource.com/SandCastles/
http://www.squeaksource.com/LearnAIDA/
http://www.squeaksource.com/rpzQuinto/
http://www.squeaksource.com/AvatoxMooseImporter/
http://www.squeaksource.com/SICPsequences/
http://www.squeaksource.com/ktsbe01/
http://www.squeaksource.com/lnSimpleCounter/
http://www.squeaksource.com/WordLearning/
http://www.squeaksource.com/SWT/
http://www.squeaksource.com/MJKQuinto/
http://www.squeaksource.com/OBAddOns/
http://www.squeaksource.com/lnLAN/
http://www.squeaksource.com/DcBeginnings/
http://www.squeaksource.com/ProMed/
http://www.squeaksource.com/SeasideLoader/
http://www.squeaksource.com/Fish/
http://www.squeaksource.com/testproject/
http://www.squeaksource.com/TimeZoneDatabase/
http://www.squeaksource.com/workbench/
http://www.squeaksource.com/SbeAI/
http://www.squeaksource.com/automatingtapetes/
http://www.squeaksource.com/Roar/
http://www.squeaksource.com/asADL/
http://www.squeaksource.com/ObjectHistory/
http://www.squeaksource.com/AKSEAsteroids/
http://www.squeaksource.com/pieradons2/
http://www.squeaksource.com/Metabolika/
http://www.squeaksource.com/walter/
http://www.squeaksource.com/Reactalk/
http://www.squeaksource.com/Leisure/
http://www.squeaksource.com/Graph/
http://www.squeaksource.com/SEATools/
http://www.squeaksource.com/Tables/
http://www.squeaksource.com/X36OBPRegExps/
http://www.squeaksource.com/jhbsqueak/
http://www.squeaksource.com/Arrocco/
http://www.squeaksource.com/WangGo1/
http://www.squeaksource.com/doodesProject/
http://www.squeaksource.com/Tirade/
http://www.squeaksource.com/processingjs/
http://www.squeaksource.com/TateTechnology/
http://www.squeaksource.com/NetworkMusicPlayer/
http://www.squeaksource.com/SBEQuintoRGM/
http://www.squeaksource.com/OmniSupport/
http://www.squeaksource.com/accparser/
http://www.squeaksource.com/UIEnhancements/
http://www.squeaksource.com/Aquarium/
http://www.squeaksource.com/DynamicProtocols/
http://www.squeaksource.com/LEQTest/
http://www.squeaksource.com/Dock/
http://www.squeaksource.com/JWSSBEQuinto/
http://www.squeaksource.com/ByteSurgeon/
http://www.squeaksource.com/sjg56Quinto/
http://www.squeaksource.com/StMud/
http://www.squeaksource.com/MagmaPharo/
http://www.squeaksource.com/Scheme/
http://www.squeaksource.com/Citezen/
http://www.squeaksource.com/OmniBrowserFixes/
http://www.squeaksource.com/OBP/
http://www.squeaksource.com/Alquileres/
http://www.squeaksource.com/PRDSBE/
http://www.squeaksource.com/ReadOnlyness/
http://www.squeaksource.com/OperationPi/
http://www.squeaksource.com/Toothpick/
http://www.squeaksource.com/ofx/
http://www.squeaksource.com/JavaScript/
http://www.squeaksource.com/StatisticalAnalysis/
http://www.squeaksource.com/daap/
http://www.squeaksource.com/Michel/
http://www.squeaksource.com/ShoreComponents/
http://www.squeaksource.com/Hermion/
http://www.squeaksource.com/SmallWikiEnh/
http://www.squeaksource.com/MLNrepos/
http://www.squeaksource.com/AgendaAula/
http://www.squeaksource.com/CodeForTeaching/
http://www.squeaksource.com/WriteBarrier/
http://www.squeaksource.com/AsStEx/
http://www.squeaksource.com/QuintoByPunit/
http://www.squeaksource.com/hornbeckSBEGame/
http://www.squeaksource.com/Kabungu/
http://www.squeaksource.com/Unstuck/
http://www.squeaksource.com/Tamaris/
http://www.squeaksource.com/PierForum/
http://www.squeaksource.com/MJKTicTacToe/
http://www.squeaksource.com/ObjectsAsMethodsWrap/
http://www.squeaksource.com/LatexMorph/
http://www.squeaksource.com/JNHSBE/
http://www.squeaksource.com/OceansideBook/
http://www.squeaksource.com/MediaView/
http://www.squeaksource.com/Squeaklandia/
http://www.squeaksource.com/UninstallCS/
http://www.squeaksource.com/mac4412008/
http://www.squeaksource.com/CorruptVM/
http://www.squeaksource.com/iAddress/
http://www.squeaksource.com/GraphViz/
http://www.squeaksource.com/Cdcquinto/
http://www.squeaksource.com/IGLecture/
http://www.squeaksource.com/Cartographers/
http://www.squeaksource.com/QuintoGame/
http://www.squeaksource.com/pitchSetExplorer/
http://www.squeaksource.com/IntensiVE/
http://www.squeaksource.com/hpcw/
http://www.squeaksource.com/SqueakDBX/
http://www.squeaksource.com/GestionAlumnos/
http://www.squeaksource.com/NewQCM/
http://www.squeaksource.com/ML/
http://www.squeaksource.com/foobar/
http://www.squeaksource.com/Contracts/
http://www.squeaksource.com/Drummers/
http://www.squeaksource.com/Unnamed/
http://www.squeaksource.com/DGV/
http://www.squeaksource.com/GeKonSpatialConstr/
http://www.squeaksource.com/Services/
http://www.squeaksource.com/katmandu/
http://www.squeaksource.com/TransactionManager/
http://www.squeaksource.com/DowaitoQuinto/
http://www.squeaksource.com/Overquet/
http://www.squeaksource.com/WebScrabble/
http://www.squeaksource.com/quinto/
http://www.squeaksource.com/Terminus/
http://www.squeaksource.com/Musinum2/
http://www.squeaksource.com/ChadDemo/
http://www.squeaksource.com/RasnaTest/
http://www.squeaksource.com/tpSallasGilbert/
http://www.squeaksource.com/SqueakPoint2340/
http://www.squeaksource.com/TagClouds/
http://www.squeaksource.com/Tradeboner/
http://www.squeaksource.com/Raphael/
http://www.squeaksource.com/Vacation/
http://www.squeaksource.com/Timers/
http://www.squeaksource.com/htmlcssparser/
http://www.squeaksource.com/obpbintree/
http://www.squeaksource.com/RPGSqueak/
http://www.squeaksource.com/grekobor/
http://www.squeaksource.com/Jihachol/
http://www.squeaksource.com/GOODS/
http://www.squeaksource.com/Musinum/
http://www.squeaksource.com/Trax/
http://www.squeaksource.com/DPON/
http://www.squeaksource.com/SandstoneDb/
http://www.squeaksource.com/CollectionArithmetic/
http://www.squeaksource.com/BkbagMagmaTesting/
http://www.squeaksource.com/ttran/
http://www.squeaksource.com/MorphicAtInternet/
http://www.squeaksource.com/CSV/
http://www.squeaksource.com/HID/
http://www.squeaksource.com/TuringMachine/
http://www.squeaksource.com/Lock/
http://www.squeaksource.com/AtomFeed/
http://www.squeaksource.com/sketchPad/
http://www.squeaksource.com/HJNtest/
http://www.squeaksource.com/pgsSBEGame/
http://www.squeaksource.com/Nabarro/
http://www.squeaksource.com/ObjectFinder/
http://www.squeaksource.com/OGRPNCalculator/
http://www.squeaksource.com/gauge/
http://www.squeaksource.com/VVD2008/
http://www.squeaksource.com/StoryEvaluatorChart/
http://www.squeaksource.com/AbstractTree/
http://www.squeaksource.com/TestProject/
http://www.squeaksource.com/POYET/
http://www.squeaksource.com/NNTPClient/
http://www.squeaksource.com/123123321312321/
http://www.squeaksource.com/BinarniStromUloha/
http://www.squeaksource.com/JQueryWidgetBox/
http://www.squeaksource.com/SqueakPeopleStats/
http://www.squeaksource.com/lnTutorialTheater/
http://www.squeaksource.com/binarnistrom/
http://www.squeaksource.com/SqueakDesk/
http://www.squeaksource.com/Mocketry/
http://www.squeaksource.com/AXAnnouncements/
http://www.squeaksource.com/TestISB/
http://www.squeaksource.com/Jags/
http://www.squeaksource.com/SBEQuintoKW/
http://www.squeaksource.com/Sweet/
http://www.squeaksource.com/SEBeatwebs/
http://www.squeaksource.com/TSUG/
http://www.squeaksource.com/Stemmer/
http://www.squeaksource.com/smallwiki1/
http://www.squeaksource.com/Infinity/
http://www.squeaksource.com/Goya/
http://www.squeaksource.com/Pepper/
http://www.squeaksource.com/InterfaceDiscoverer/
http://www.squeaksource.com/PDSBEQuinto/
http://www.squeaksource.com/RAILSBridge/
http://www.squeaksource.com/TestForSBEUserSCS/
http://www.squeaksource.com/Vista/
http://www.squeaksource.com/DiacriticSupport/
http://www.squeaksource.com/ersteSchritte/
http://www.squeaksource.com/pathname/
http://www.squeaksource.com/Daniel/
http://www.squeaksource.com/GTD/
http://www.squeaksource.com/DynamicAspects/
http://www.squeaksource.com/LoremIpsum/
http://www.squeaksource.com/seasidemo/
http://www.squeaksource.com/Danaus/
http://www.squeaksource.com/SRP/
http://www.squeaksource.com/FluidDB/
http://www.squeaksource.com/FouseSqueakPoint/
http://www.squeaksource.com/RubyQuiz/
http://www.squeaksource.com/TracingMessagesBrows/
http://www.squeaksource.com/SBEQuintodcd/
http://www.squeaksource.com/InT/
http://www.squeaksource.com/LegoMindstorms/
http://www.squeaksource.com/MyPuzzles/
http://www.squeaksource.com/proba/
http://www.squeaksource.com/Marvin/
http://www.squeaksource.com/RJMQuinto/
http://www.squeaksource.com/moqam/
http://www.squeaksource.com/MrTSBEQuinto/
http://www.squeaksource.com/SeasideFusionCharts/
http://www.squeaksource.com/PagedReader/
http://www.squeaksource.com/AsyncWrapper/
http://www.squeaksource.com/TicTacToeKata/
http://www.squeaksource.com/seasidetutorial/
http://www.squeaksource.com/Ironk/
http://www.squeaksource.com/MonticelloRename/
http://www.squeaksource.com/Prince2/
http://www.squeaksource.com/MondrianAnimator/
http://www.squeaksource.com/ShaiSBE/
http://www.squeaksource.com/Smalltalk04/
http://www.squeaksource.com/Organizer/
http://www.squeaksource.com/MagasinOxfam/
http://www.squeaksource.com/WSFF/
http://www.squeaksource.com/SmallAutoDoc/
http://www.squeaksource.com/SqueakSoul/
http://www.squeaksource.com/CCSE/
http://www.squeaksource.com/MyStuff/
http://www.squeaksource.com/Geppetto/
http://www.squeaksource.com/AT/
http://www.squeaksource.com/SealinesGame/
http://www.squeaksource.com/Metropolis/
http://www.squeaksource.com/TinyHeliDemo/
http://www.squeaksource.com/MiaUnuaPasxo/
http://www.squeaksource.com/QuA/
http://www.squeaksource.com/NumberExtensions/
http://www.squeaksource.com/GeneticAlgorithm/
http://www.squeaksource.com/bluesky/
http://www.squeaksource.com/Pacman/
http://www.squeaksource.com/Aida/
http://www.squeaksource.com/PierMagritte/
http://www.squeaksource.com/Algernon/
http://www.squeaksource.com/TestServerSimple/
http://www.squeaksource.com/SqueakBot2/
http://www.squeaksource.com/CassandraClient/
http://www.squeaksource.com/FasterSets/
http://www.squeaksource.com/BinaryTreeCvika2/
http://www.squeaksource.com/garyquinto/
http://www.squeaksource.com/SqueakExamples/
http://www.squeaksource.com/ABKTEST/
http://www.squeaksource.com/Nicu/
http://www.squeaksource.com/mollom/
http://www.squeaksource.com/tp2fiuba/
http://www.squeaksource.com/systemeExpert/
http://www.squeaksource.com/tp/
http://www.squeaksource.com/QuintoByDED/
http://www.squeaksource.com/Squash/
http://www.squeaksource.com/AwesomeAtom/
http://www.squeaksource.com/SmallPoker/
http://www.squeaksource.com/GameDevTools/
http://www.squeaksource.com/GeKonGUI/
http://www.squeaksource.com/QCM/
http://www.squeaksource.com/OpenID/
http://www.squeaksource.com/BowWave/
http://www.squeaksource.com/SmallPOS/
http://www.squeaksource.com/Reversi/
http://www.squeaksource.com/Hitman/
http://www.squeaksource.com/ron/
http://www.squeaksource.com/Dice/
http://www.squeaksource.com/SimFish/
http://www.squeaksource.com/FullPersistence/
http://www.squeaksource.com/Atom/
http://www.squeaksource.com/XSos/
http://www.squeaksource.com/OCompletion/
http://www.squeaksource.com/DMGSBEQuinto/
http://www.squeaksource.com/RuslanSlobodyanik/
http://www.squeaksource.com/Test/
http://www.squeaksource.com/Techo/
http://www.squeaksource.com/tumaj/
http://www.squeaksource.com/Maispion/
http://www.squeaksource.com/MSCNP/
http://www.squeaksource.com/SBEQuinto12122008/
http://www.squeaksource.com/Phantasia/
http://www.squeaksource.com/PackageExplorer/
http://www.squeaksource.com/JobinQuinto/
http://www.squeaksource.com/SpacewarHPI/
http://www.squeaksource.com/IwaTetris/
http://www.squeaksource.com/Albatross/
http://www.squeaksource.com/BehaviorMockup/
http://www.squeaksource.com/Squeakfr/
http://www.squeaksource.com/Sueldos/
http://www.squeaksource.com/CompassInstaller/
http://www.squeaksource.com/rcs/
http://www.squeaksource.com/dhksbe/
http://www.squeaksource.com/RealTimeGroupEditor/
http://www.squeaksource.com/RemoteControl/
http://www.squeaksource.com/Swazoo/
http://www.squeaksource.com/andrewco/
http://www.squeaksource.com/ASN1/
http://www.squeaksource.com/maccaSqueak/
http://www.squeaksource.com/mmhsqueaktutorial/
http://www.squeaksource.com/ASAQuintoGame/
http://www.squeaksource.com/hyper/
http://www.squeaksource.com/Popeye/
http://www.squeaksource.com/MirKiQuinto/
http://www.squeaksource.com/SmallWorld/
http://www.squeaksource.com/KidsFirstMerge/
http://www.squeaksource.com/YUISeaside/
http://www.squeaksource.com/jrtg/
http://www.squeaksource.com/autoMethodCat/
http://www.squeaksource.com/BinarnyStrom/
http://www.squeaksource.com/MoosePlayground/
http://www.squeaksource.com/X36OBP/
http://www.squeaksource.com/Smalltronics/
http://www.squeaksource.com/dwd/
http://www.squeaksource.com/PrototypeWindow/
http://www.squeaksource.com/SCS/
http://www.squeaksource.com/DAVServerDirectory/
http://www.squeaksource.com/RayTracer/
http://www.squeaksource.com/HPDF/
http://www.squeaksource.com/travnja3obp/
http://www.squeaksource.com/LoginBeta/
http://www.squeaksource.com/HaltOnce/
http://www.squeaksource.com/STExercices/
http://www.squeaksource.com/RJKTest/
http://www.squeaksource.com/TmuSbeQuinto/
http://www.squeaksource.com/ClassDoc/
http://www.squeaksource.com/JSON/
http://www.squeaksource.com/UIGenericTest/
http://www.squeaksource.com/TutorialJDP/
http://www.squeaksource.com/Venice/
http://www.squeaksource.com/SBEQuinto1234/
http://www.squeaksource.com/Unibe/
http://www.squeaksource.com/Register/
http://www.squeaksource.com/Sextant/
http://www.squeaksource.com/harald/
http://www.squeaksource.com/SunnysidePlanning2/
http://www.squeaksource.com/Gardner/
http://www.squeaksource.com/Roborally/
http://www.squeaksource.com/UBWebservices/
http://www.squeaksource.com/HoNCaiCSC3180Project/
http://www.squeaksource.com/Rome/
http://www.squeaksource.com/RWS/
http://www.squeaksource.com/JoeTheMiner/
http://www.squeaksource.com/WaterOuzel/
http://www.squeaksource.com/Jetsam/
http://www.squeaksource.com/OmniBaseUnix/
http://www.squeaksource.com/SVHSBEQuinto/
http://www.squeaksource.com/JWProject/
http://www.squeaksource.com/DateCollection/
http://www.squeaksource.com/Hits/
http://www.squeaksource.com/PierTools/
http://www.squeaksource.com/DbpSbeQuinto/
http://www.squeaksource.com/Seaside30LGPL/
http://www.squeaksource.com/JCRM/
http://www.squeaksource.com/pbelearning/
http://www.squeaksource.com/Aconcagua/
http://www.squeaksource.com/PNGReadWriter2/
http://www.squeaksource.com/GROUPAWESOME/
http://www.squeaksource.com/gfwttt/
http://www.squeaksource.com/EBot/
http://www.squeaksource.com/InfraRed/
http://www.squeaksource.com/Sursagar/
http://www.squeaksource.com/Mars/
http://www.squeaksource.com/MantisConnect/
http://www.squeaksource.com/Drakborgen/
http://www.squeaksource.com/sygma/
http://www.squeaksource.com/ST2JS/
http://www.squeaksource.com/Balloon3D/
http://www.squeaksource.com/PackageLoader/
http://www.squeaksource.com/SeasideToDo/
http://www.squeaksource.com/TimSBEQuinto/
http://www.squeaksource.com/Ilias/
http://www.squeaksource.com/ChangeBoxes/
http://www.squeaksource.com/StatePattern/
http://www.squeaksource.com/TrxViewer/
http://www.squeaksource.com/OpenGL/
http://www.squeaksource.com/PBLearningSqueak/
http://www.squeaksource.com/PhotoGala/
http://www.squeaksource.com/KernelImage/
http://www.squeaksource.com/JobrLightouts/
http://www.squeaksource.com/PSUCS520/
http://www.squeaksource.com/CharRecog/
http://www.squeaksource.com/timesheets/
http://www.squeaksource.com/Feelit/
http://www.squeaksource.com/WorldOfGames/
http://www.squeaksource.com/Realtalk2/
http://www.squeaksource.com/OPMLParser/
http://www.squeaksource.com/SeabookToDoAddMagma/
http://www.squeaksource.com/omnidojo/
http://www.squeaksource.com/PtitonioTeaching/
http://www.squeaksource.com/SBEQuintobyTE/
http://www.squeaksource.com/Quintotocaaa/
http://www.squeaksource.com/Ounce/
http://www.squeaksource.com/MutliColumnListMorph/
http://www.squeaksource.com/TinyNumberDemo/
http://www.squeaksource.com/Sudoku/
http://www.squeaksource.com/jjrsbe/
http://www.squeaksource.com/CS420TermProj/
http://www.squeaksource.com/SqueakBaseClasses/
http://www.squeaksource.com/Nanmon/
http://www.squeaksource.com/xorp/
http://www.squeaksource.com/Albaplata/
http://www.squeaksource.com/Magma/
http://www.squeaksource.com/Minotaur/
http://www.squeaksource.com/HydraVM/
http://www.squeaksource.com/PropertyList/
http://www.squeaksource.com/Seaside29Addons/
http://www.squeaksource.com/sjtQuinto/
http://www.squeaksource.com/NeuralNetwork/
http://www.squeaksource.com/MinorityReport/
http://www.squeaksource.com/Qifer/
http://www.squeaksource.com/seachart/
http://www.squeaksource.com/SamplePierApp/
http://www.squeaksource.com/SmallabPathest/
http://www.squeaksource.com/WorldMenuRegistry/
http://www.squeaksource.com/SocRecording/
http://www.squeaksource.com/Nurikabe/
http://www.squeaksource.com/2BDeterminedLBS/
http://www.squeaksource.com/TwitChanges/
http://www.squeaksource.com/NewCompilerPragma/
http://www.squeaksource.com/SBETest/
http://www.squeaksource.com/Addons/
http://www.squeaksource.com/TesteFunc/
http://www.squeaksource.com/Yadis/
http://www.squeaksource.com/Taskbar/
http://www.squeaksource.com/greysquinto/
http://www.squeaksource.com/ElefanteFase3/
http://www.squeaksource.com/Squill/
http://www.squeaksource.com/Dynaplex/
http://www.squeaksource.com/ODBCEnh/
http://www.squeaksource.com/SW2Captcha/
http://www.squeaksource.com/DuoSystemBrowser/
http://www.squeaksource.com/RFStreams/
http://www.squeaksource.com/LazyCollections/
http://www.squeaksource.com/EditTextColors/
http://www.squeaksource.com/LogBook/
http://www.squeaksource.com/XFiles/
http://www.squeaksource.com/Smallchange/
http://www.squeaksource.com/EnhancedOB/
http://www.squeaksource.com/tester/
http://www.squeaksource.com/AscQuintoGame/
http://www.squeaksource.com/mim/
http://www.squeaksource.com/HJR/
http://www.squeaksource.com/dolezjin/
http://www.squeaksource.com/iasa2007/
http://www.squeaksource.com/QuintoExample/
http://www.squeaksource.com/ChangeNotifTests/
http://www.squeaksource.com/Alf/
http://www.squeaksource.com/lxstage/
http://www.squeaksource.com/Kaching/
http://www.squeaksource.com/GolfPolynomDivision/
http://www.squeaksource.com/SBEQuinto23/
http://www.squeaksource.com/DPPServices/
http://www.squeaksource.com/SeasideXUL/
http://www.squeaksource.com/vitoujanbs/
http://www.squeaksource.com/CellularAutomata/
http://www.squeaksource.com/Sapien/
http://www.squeaksource.com/DynaGraph/
http://www.squeaksource.com/Aton/
http://www.squeaksource.com/AALocalHomeSeaside/
http://www.squeaksource.com/CS420PokerDice/
http://www.squeaksource.com/AOStA/
http://www.squeaksource.com/FileList/
http://www.squeaksource.com/Gtk/
http://www.squeaksource.com/Television/
http://www.squeaksource.com/elefanchi/
http://www.squeaksource.com/JoeTheBox/
http://www.squeaksource.com/hyperlexis/
http://www.squeaksource.com/SliSbeQuinto/
http://www.squeaksource.com/CS2340SqueakPoint/
http://www.squeaksource.com/genie/
http://www.squeaksource.com/SofistekQuinto/
http://www.squeaksource.com/Shabeen/
http://www.squeaksource.com/CS410apDFA2REStelter/
http://www.squeaksource.com/JasonDanielsonGroupP/
http://www.squeaksource.com/Singletons/
http://www.squeaksource.com/fl/
http://www.squeaksource.com/tomsunikOBP/
http://www.squeaksource.com/OPAX/
http://www.squeaksource.com/CropSketchMorphs/
http://www.squeaksource.com/SW2Gallery/
http://www.squeaksource.com/dreamlines/
http://www.squeaksource.com/squeakWUD/
http://www.squeaksource.com/evaluablestrings/
http://www.squeaksource.com/FinancialCalc/
http://www.squeaksource.com/fpm/
http://www.squeaksource.com/CS2340M2/
http://www.squeaksource.com/DemoCounter2/
http://www.squeaksource.com/AgendaCarlo/
http://www.squeaksource.com/Test1/
http://www.squeaksource.com/RayTracing/
http://www.squeaksource.com/ScreenShotMorph/
http://www.squeaksource.com/KDDTest/
http://www.squeaksource.com/SnakesOnAPlane/
http://www.squeaksource.com/NewDebugger/
http://www.squeaksource.com/Pasta/
http://www.squeaksource.com/MaClientServer/
http://www.squeaksource.com/KofnosWorkingSet/
http://www.squeaksource.com/WorryWart/
http://www.squeaksource.com/PersonalSetting/
http://www.squeaksource.com/SmallDude/
http://www.squeaksource.com/gekon/
http://www.squeaksource.com/mvbdoesquinto/
http://www.squeaksource.com/Testproject/
http://www.squeaksource.com/Diplomacy/
http://www.squeaksource.com/CamisAddons/
http://www.squeaksource.com/Cresta/
http://www.squeaksource.com/MonticelloVW/
http://www.squeaksource.com/Nisshoku/
http://www.squeaksource.com/VersionsBrowser/
http://www.squeaksource.com/Sonora/
http://www.squeaksource.com/2D/
http://www.squeaksource.com/SeasideDynamicSVG/
http://www.squeaksource.com/EdT/
http://www.squeaksource.com/ToolBuilderSeaside/
http://www.squeaksource.com/PlantDB/
http://www.squeaksource.com/SLIJelloWhirled/
http://www.squeaksource.com/ToolDad/
http://www.squeaksource.com/AutoBugFinder/
http://www.squeaksource.com/SBEQuintoJE/
http://www.squeaksource.com/310build/
http://www.squeaksource.com/RWBQuinto/
http://www.squeaksource.com/monticellossl/
http://www.squeaksource.com/Kruks/
http://www.squeaksource.com/XMLSupport/
http://www.squeaksource.com/TeePuzzle/
http://www.squeaksource.com/SimpleDB/
http://www.squeaksource.com/SqueakPeople/
http://www.squeaksource.com/TreeLW/
http://www.squeaksource.com/cwjQuintocwj/
http://www.squeaksource.com/Tuio/
http://www.squeaksource.com/FuzzySearch/
http://www.squeaksource.com/mshcrypto/
http://www.squeaksource.com/LazyRabbit/
http://www.squeaksource.com/Cloudfork/
http://www.squeaksource.com/Bob/
http://www.squeaksource.com/MetaSource/
http://www.squeaksource.com/NonAsciiCollation/
http://www.squeaksource.com/YABreakOut/
http://www.squeaksource.com/ixcrw/
http://www.squeaksource.com/XMLRPC/
http://www.squeaksource.com/SAZIPortal/
http://www.squeaksource.com/KomAjpServer/
http://www.squeaksource.com/CodePhoo/
http://www.squeaksource.com/Kidare/
http://www.squeaksource.com/ndaSBEQuinto/
http://www.squeaksource.com/scaffoldingdr/
http://www.squeaksource.com/KLCQuinto/
http://www.squeaksource.com/Gainer/
http://www.squeaksource.com/QuintoTrin/
http://www.squeaksource.com/Oondir/
http://www.squeaksource.com/jiskquinto/
http://www.squeaksource.com/Alien/
http://www.squeaksource.com/Changeboxes2/
http://www.squeaksource.com/LoFPlayer1/
http://www.squeaksource.com/TeaWebShop/
http://www.squeaksource.com/DevEnvironment38/
http://www.squeaksource.com/FlyingObjects/
http://www.squeaksource.com/Metaspin/
http://www.squeaksource.com/Smallapack/
http://www.squeaksource.com/xsendfile/
http://www.squeaksource.com/x36obpbintree/
http://www.squeaksource.com/CardsGameFramework/
http://www.squeaksource.com/SkoumalBinaryTree/
http://www.squeaksource.com/BPSmallReddit/
http://www.squeaksource.com/MySQL/
http://www.squeaksource.com/FluxRSS/
http://www.squeaksource.com/SqueakEx/
http://www.squeaksource.com/ossb/
http://www.squeaksource.com/RV/
http://www.squeaksource.com/Quintozzz/
http://www.squeaksource.com/tables/
http://www.squeaksource.com/GTP/
http://www.squeaksource.com/ObjV/
http://www.squeaksource.com/BTree/
http://www.squeaksource.com/htosQuintoGame/
http://www.squeaksource.com/testProject32167/
http://www.squeaksource.com/xbase/
http://www.squeaksource.com/GestionImmo/
http://www.squeaksource.com/MethodInfo/
http://www.squeaksource.com/ToolBuilder/
http://www.squeaksource.com/BldBtMockPrjLoader/
http://www.squeaksource.com/Cassowary/
http://www.squeaksource.com/SeasideBook/
http://www.squeaksource.com/Kian/
http://www.squeaksource.com/SimSimDrive/
http://www.squeaksource.com/ColorLegend/
http://www.squeaksource.com/SBEQuintoGame/
http://www.squeaksource.com/CAnalyzer/
http://www.squeaksource.com/MorphoPhysics/
http://www.squeaksource.com/linusdmTest/
http://www.squeaksource.com/CookingTimer/
http://www.squeaksource.com/Valves/
http://www.squeaksource.com/TCExample/
http://www.squeaksource.com/TestBrowser/
http://www.squeaksource.com/Tarzan/
http://www.squeaksource.com/SBEQuintoUH/
http://www.squeaksource.com/SqueakEnh/
http://www.squeaksource.com/Arduino/
http://www.squeaksource.com/PatRecLecture/
http://www.squeaksource.com/cb2ewe/
http://www.squeaksource.com/CroquetCg/
http://www.squeaksource.com/QuintoGame78/
http://www.squeaksource.com/ChangeNotification/
http://www.squeaksource.com/K8055/
http://www.squeaksource.com/GlassExamTeam1/
http://www.squeaksource.com/universes/
http://www.squeaksource.com/Platypus/
'! !

!EcoMircea methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/13/2010 20:24'!
changeFolderTo: aString ForVersionsIn: anEcosystem
	anEcosystem allVersions asOrderedCollection
		do: [ :e | e folder: (FileDirectory forFileName: aString asFileName) ]! !

!EcoMircea methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/15/2010 21:48'!
computeMissingVersions
	EcoMircea globals at: 'missing-version-names' put: 
		((EcoMircea globals at: 'missing-versions') collect: [:e| e name, '.mcz']).
	(FileDirectory on: '/Users/mircea/Desktop/sspk') fileNames do: [:e|
		(EcoMircea globals at: 'missing-version-names') remove: e ifAbsent: [].
		].
	! !

!EcoMircea methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/15/2010 01:48'!
downloadMissingPackages

"	self class repos do: [:e| 
		self downloadMissingPackagesFromRepo: e.
			].
"
	self class repos do: [:e| 
		[self downloadMissingPackagesFromRepo: e] 
			on: Error 
			do: [:f| Transcript show: e, ' ', f printString ; cr.].
			].
	! !

!EcoMircea methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/15/2010 01:09'!
downloadMissingPackagesFromRepo: aString
	| repo |
	repo := MCHttpRepository location: aString user: '' password: ''.
	(repo allFileNames select: [ :e | (EcoMircea globals at: 'missing-version-names') includes: e])
		do: [ :fn | 
			repo
				readStreamForFileNamed: fn
				do: [ :rs | 
					| fs |
					fs := FileStream forceNewFileNamed: '/Users/mircea/Desktop/sspk/' , fn.
					fs nextPutAll: rs contents.
					fs close.
					(EcoMircea globals at: 'missing-version-names') remove: fn.
					 ] ]! !

Object subclass: #EcoMob
	instanceVariableNames: 'blobs theBigBlob'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/11/2009 13:28'!
addAll: blbs
	blobs addAll: blbs.
	blbs do: [:e | e mob: self]! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/11/2009 13:28'!
addBlob: blb
	blobs add: blb.
	blb mob: self! !

!EcoMob methodsFor: 'blob protocol' stamp: 'MirceaLungu 12/13/2009 20:56'!
allProvided
	^ self theBigBlob allProvided! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/10/2009 19:23'!
blobs
	^ blobs! !

!EcoMob methodsFor: 'adding' stamp: 'RomainRobbes 1/10/2010 13:36'!
blobs: blbs
	blbs do: [:e | self addBlob: e]! !

!EcoMob methodsFor: 'adding' stamp: 'RomainRobbes 8/4/2010 15:16'!
computeBigBlob
	| bigBlobClass |
	bigBlobClass := self hasClassBlobs ifTrue: [EcoClassMethodBlob] ifFalse: [EcoBlob].
	^ blobs inject: bigBlobClass new into: [:blob :big | blob + big]! !

!EcoMob methodsFor: 'adding' stamp: 'RomainRobbes 8/4/2010 15:16'!
hasClassBlobs
	^ self blobs anySatisfy: [:e | e isKindOf: EcoClassMethodBlob]! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/11/2009 13:27'!
initialize
	blobs := Set new! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/11/2009 13:30'!
join: aMob
	| m |
	m := self class new.
	m addAll: self blobs.
	m addAll: aMob blobs.
	^ m! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/14/2009 16:51'!
nameMatches: aString
	^self blobs anySatisfy: [:e| e nameMatches: aString]! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/13/2009 21:20'!
printOn: aStream
	| blbs |
	blbs := blobs asArray.
	aStream nextPutAll: '(', blbs size asString, '): '.
	1 to: (5 min: blobs size) do: [:i|
		aStream nextPutAll: (blbs at: i) printString, ', '.
		].
	(blobs size > 5) ifTrue: [	
		aStream nextPutAll: '...'.
		].! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/13/2009 21:41'!
project
	^ self theBigBlob project! !

!EcoMob methodsFor: 'blob protocol' stamp: 'MirceaLungu 12/15/2009 16:33'!
provided
	^ self theBigBlob provided! !

!EcoMob methodsFor: 'blob protocol' stamp: 'MirceaLungu 12/13/2009 21:01'!
required
	^ self theBigBlob required! !

!EcoMob methodsFor: 'blob protocol' stamp: 'MirceaLungu 12/15/2009 16:34'!
similarityWith: blobOrMob
	^ self theBigBlob similarityWith: blobOrMob! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/11/2009 17:09'!
size
	^self blobs size! !

!EcoMob methodsFor: 'adding' stamp: 'MirceaLungu 12/13/2009 20:50'!
theBigBlob
	^ theBigBlob ifNil: [theBigBlob := self computeBigBlob]! !

Object subclass: #EcoMobBuilder
	instanceVariableNames: 'blobs similarityIndex mobs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/13/2009 20:42'!
blobs
	^ blobs! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/11/2009 13:30'!
blobs: blbs
	blobs := blbs.
	blobs do: [:e | e mob: nil]! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/13/2009 20:32'!
blobsAndMobs
	^(blobs reject: [:e | e mob blobs size > 1]) addAll: mobs; yourself! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/11/2009 15:20'!
computeSimilarities
	
	'similarizing' displayProgressAt: Sensor cursorPoint from: 0 to: blobs size during: [:bar | 
	1 to: blobs size do: [:i|
			bar value: i.
			i + 1 to: blobs size do: [:j|
					| a b sim |
					a := blobs at: i.
					b := blobs at: j.
					a mob = b mob ifFalse: [
					sim := a similarityWith: b. 
					(sim > 0.90) ifTrue: [ | mob |
					
						mobs remove: a mob ifAbsent: [].
						mobs remove: b mob ifAbsent: [].
						mob := (a mob join: b mob).
						mobs add: mob].
					].
				]
		]].
	
	! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/11/2009 17:40'!
computeSimilarities: threshold
	
	'similarizing' displayProgressAt: Sensor cursorPoint from: 0 to: blobs size during: [:bar | 
	1 to: blobs size do: [:i|
			bar value: i.
			i + 1 to: blobs size do: [:j|
					| a b sim |
					a := blobs at: i.
					b := blobs at: j.
					a mob = b mob ifFalse: [
					sim := a similarityWith: b. 
					(sim > threshold) ifTrue: [ | mob |
					
						mobs remove: a mob ifAbsent: [].
						mobs remove: b mob ifAbsent: [].
						mob := (a mob join: b mob).
						mobs add: mob].
					].
				]
		]].
	
	! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/13/2009 20:42'!
ensureBlobsHaveRightMobs
	"there's a bug to fix making this method necessary"
	self blobs do: [:b | b mob: nil].
	self mobs do: [:m | m blobs do: [:e | e mob: m]]! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/10/2009 19:20'!
initialize
	super initialize.
	mobs := Set new.! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/11/2009 13:33'!
initializeBlobsWith: someBlobs
	self blobs: (someBlobs select: [:e | e printString beginsWith:  'Seaside'])! !

!EcoMobBuilder methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/10/2009 19:24'!
mobs
	^ mobs! !

Object subclass: #EcoPatch
	instanceVariableNames: 'operations item'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Ripples'!

!EcoPatch class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:23'!
on: item
	^ self new item: item! !

!EcoPatch methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:22'!
asString 
	^ item printString ! !

!EcoPatch methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 02:16'!
item
	^ item! !

!EcoPatch methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 02:16'!
item: anObject
	item := anObject! !

!EcoPatch methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 01:53'!
operations
	^ operations! !

!EcoPatch methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 01:53'!
operations: anObject
	operations := anObject! !

!EcoPatch methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 02:27'!
patchWrapper 
	^ self wrapper ! !

!EcoPatch methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 01:57'!
wrapper
	^ EcoWrapper new item: self! !

EcoPatch subclass: #EcoProjectPatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Ripples'!

EcoPatch subclass: #EcoTransitionPatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Ripples'!

!EcoTransitionPatch methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 02:23'!
item: anEcoTransition
	item := anEcoTransition.
	operations := item patch operations ! !

Object subclass: #EcoProject
	instanceVariableNames: 'firstversion versions flatblob name versionmap dependsOn dependents ignorelist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/14/2010 19:15'!
addDependency:  dep 
	self dependsOn add: dep.
	dep provider dependents add: dep! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/4/2010 17:44'!
addEcoVersion: version
	versions add: version.
	firstversion ifNil: [firstversion := version]
		ifNotNil: [version date < firstversion date ifTrue: [firstversion := version]]! !

!EcoProject methodsFor: 'updating' stamp: 'OzC 10/28/2010 10:00'!
addVersion: anMCVersion
	"flatblob should be a ag to count the number of times a class was provided and remove some extra noise, eg, if only one version provides a class"
	| version ancestors |
	version := self getVersion: anMCVersion info.
	version fromVersion: anMCVersion.
	"ancestors := anMCVersion info ancestors collect: [:e | self getVersion: e].
	ancestors do: [:e | e ancestorOf: version].
	flatblob processSnapshot: anMCVersion snapshot."
	self addEcoVersion: version! !

!EcoProject methodsFor: 'updating' stamp: 'OzC 10/28/2010 10:01'!
addVersion: anMCVersion folder: folder
	| version ancestors |
	version := self getVersion: anMCVersion info.
	version fromVersion: anMCVersion.
	version folder: folder.
	"ancestors := anMCVersion info ancestors collect: [:e | self getVersion: e].
	ancestors do: [:e | e ancestorOf: version].
	flatblob processSnapshot: anMCVersion snapshot."
	self addEcoVersion: version! !

!EcoProject methodsFor: 'blob' stamp: 'RomainRobbes 8/14/2010 19:23'!
allProvided
	^ flatblob allProvided ! !

!EcoProject methodsFor: 'blob' stamp: 'RomainRobbes 8/18/2010 20:17'!
allProvidedMethods
	^ (self transitions gather: [:e | e methodsInProvided]) asSet ! !

!EcoProject methodsFor: 'ignorelist' stamp: 'RomainRobbes 8/17/2010 12:18'!
allProvidedNotIgnored
	^ self allProvided difference: self ignorelist! !

!EcoProject methodsFor: 'blob' stamp: 'RomainRobbes 8/14/2010 19:47'!
allRequired
	^ flatblob allRequired ! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 08:39'!
areVersionsSorted
	versions overlappingPairsDo: [:a :b | a date > b date ifTrue: [^ false]].
	^ true! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 17:40'!
blob
	^ flatblob ! !

!EcoProject methodsFor: 'blob' stamp: 'RomainRobbes 8/14/2010 19:23'!
both
	^ flatblob both! !

!EcoProject methodsFor: 'visualization' stamp: 'RomainRobbes 8/8/2010 18:37'!
buildTransitions 
	versions do: [:e | e buildTransitions]! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 16:58'!
classes
	^ flatblob allProvided ! !

!EcoProject methodsFor: 'testing' stamp: 'RomainRobbes 8/14/2010 20:05'!
classesInCommonWith: other
	^ Array with: self with: other with: (self allProvided intersection: other allProvided)! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/18/2010 20:23'!
clients
	^ self dependents collect: #client! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/6/2010 14:26'!
coarseIndexIn: index
	| pName |
	pName := self projectName.
	flatblob allProvided do: [:e | index method: e isProvidedBy: pName]! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/17/2010 10:08'!
connect: version with: ancestor as: transitionClass
	| transition |
	ancestor date > version date ifTrue: [self halt].
	ancestor ancestorOf: version.
	transition := transitionClass new.
	transition setFrom: ancestor to: version.
	ancestor transitions add: transition.
	transition computeChange.
	version killPrevTransitions. "just in case" 
	^ transition! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/4/2010 16:01'!
deIndexIn: index
	flatblob allProvided do: [:e | index method: e isNoMoreProvidedBy: self]! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 13:07'!
degreeOfOriginFrom: otherProject
	| vs |
	vs := otherProject  versions: 5 before: self startDate.
	vs ifEmpty: [^ 0].
	^ (vs detectMax:  [:e | (e classDistanceWith: self firstversion)]) classDistanceWith: self firstversion! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 13:08'!
degreeOfSplitFrom: otherProject
	| vs |
	vs := otherProject  versions: 5 before: self startDate.
	vs ifEmpty: [^ 0].
	^ (vs detectMax:  [:e | (e oneWayClassDistanceWith: self firstversion)] ) oneWayClassDistanceWith: self firstversion! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/17/2010 16:10'!
dependentProjects
	^ (self dependents collect: [:e | e client projectName]) asSet! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/14/2010 19:08'!
dependents
	^ dependents ifNil: [dependents := OrderedCollection new]! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/14/2010 19:07'!
dependsOn
	^ dependsOn ifNil: [dependsOn := OrderedCollection new]! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/14/2010 19:08'!
dependsOn: other
	self dependsOn add: other.
	other dependents add: self! !

!EcoProject methodsFor: 'connectingversions' stamp: 'RomainRobbes 8/17/2010 07:10'!
disconnectRecoveredVersions
	self versions do: [:e |
		(e transitions reject: [:t | t class = EcoTransition]) do: [:t | t uninstall.].
		(e transitions select: [:t | t isSelfConnected]) do: [:t | t uninstall.]
		]! !

!EcoProject methodsFor: 'connectingversions' stamp: 'RomainRobbes 8/16/2010 09:13'!
disconnectedVersions
	^ (self versions select: [:e | e ancestors allSatisfy: [:a | a incomplete]]) remove: firstversion ifAbsent: []; yourself! !

!EcoProject methodsFor: 'duplication' stamp: 'RomainRobbes 8/15/2010 10:27'!
distinctVersionNames
	^ (versions collect: [:e | e name copyUpTo: $-]) asSet! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 09:14'!
ensureSort
	(versions isKindOf: SortedCollection ) ifFalse: [self sortVersions]! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 15:56'!
extendedDegreeOfOriginFrom: otherProject
	| vs |
	vs := otherProject  versions: 1 after: self startDate.
	vs ifEmpty: [^ 0].
	^ (vs detectMax:  [:e | (e classDistanceWith: self firstversion)] ) classDistanceWith: self firstversion! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 15:57'!
extendedDegreeOfSplitFrom: otherProject
	| vs |
	vs := otherProject  versions: 1 after: self startDate.
	vs ifEmpty: [^ 0].
	^ (vs detectMax:  [:e | (e oneWayClassDistanceWith: self firstversion)] ) oneWayClassDistanceWith: self firstversion! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 20:33'!
fastBestIncorporateMatchFor: version
	"we need the earliest version after that one"	
	| vclasses |
	vclasses := version classes.
	^ ((firstversion transitionClassesCollect: [:v :cls | v date < version date ifTrue: [v -> -1] ifFalse: [v -> (cls oneWayDistanceWith: vclasses)]])  detectMax: [:e | e value]) key! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 21:48'!
fastBestRenameMatchFor: version
	
	| vclasses |
	vclasses := version classes.
	^ ((firstversion transitionClassesCollect: [:v :cls | v date >= version date ifTrue: [v -> -1] ifFalse: [v -> (cls distanceWith: vclasses)]]) reversed detectMax: [:e | e value]) key! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 21:48'!
fastBestSplitMatchFor: version
	
	| vclasses |
	vclasses := version classes.
	^ ((firstversion transitionClassesCollect: [:v :cls | v date >= version date ifTrue: [v -> -1] ifFalse: [v -> (cls oneWayDistanceWith: vclasses)]]) reversed detectMax: [:e | e value]) key! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 10:53'!
findBestRenameMatchFor: version
	| i sub |
	i := versions indexForInserting: version.
	sub := (versions copyFrom: ((i - 5) max: 1) to: i - 1).
	^ sub detectMax:  [:e | e classDistanceWith:  version].
! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 09:34'!
findBestSplitMatchFor: version
	| i sub |
	i := versions indexForInserting: version.
	sub := (versions copyFrom: ((i - 5) max: 1) to: i - 1).
	^ sub detectMax:  [:e | e oneWayClassDistanceWith:  version].
! !

!EcoProject methodsFor: 'linking' stamp: 'RomainRobbes 8/6/2010 16:00'!
findLinksForVersion: info
	info breadthFirstAncestorsDo: [:inf2 |
		(self hasVersion: inf2) ifTrue: [^ self getVersion: inf2]
		].
	^ nil! !

!EcoProject methodsFor: 'linking' stamp: 'RomainRobbes 8/9/2010 20:30'!
findMissingLinks
	| versionsToLink failed |
	
	versionsToLink := (versions select: [:e | e hasIncompleteAncestry]) reject: [:e | e = firstversion].
	versionsToLink do: [:e | 
		e incompleteAncestors do: [:ancestor | | ancInfo newAnc |
			failed := OrderedCollection new.
			ancInfo := e mcInfo ancestors detect: [:anc | anc name = ancestor name].
			newAnc := self findLinksForVersion:ancInfo.
			newAnc ifNotNil: [newAnc successorOf: e] ifNil: [failed add: ancestor].
			].
		e purgeIncompleteAncestryExcluding: failed.
		].
	^ self! !

!EcoProject methodsFor: 'initialize-release' stamp: 'MirceaLungu 8/19/2010 15:14'!
firstDate
	^ firstversion date! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/15/2010 16:04'!
firstVersion
	^ firstversion ! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/4/2010 17:51'!
firstversion 
	^ firstversion ! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/4/2010 12:12'!
getVersion: aVersionInfo
	^ versionmap at: aVersionInfo name ifAbsentPut: [EcoProjectVersion new name: aVersionInfo name]! !

!EcoProject methodsFor: 'duplication' stamp: 'RomainRobbes 8/15/2010 10:28'!
hasDistinctVersionNames
	^ self distinctVersionNames size > 1! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/6/2010 15:50'!
hasVersion: aVersionInfo
	^ (versionmap at: aVersionInfo name ifAbsent: [nil]) notNil! !

!EcoProject methodsFor: 'ignorelist' stamp: 'RomainRobbes 8/17/2010 12:17'!
ignoreClassesDefinedBy: new
	| inter |
	inter := self allProvided intersection: new allProvided.
	self ignorelist addAll: inter! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/17/2010 12:15'!
ignorelist 
	^ ignorelist ifNil: [ignorelist := Set new]! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 17:42'!
incorporate: otherProject
	otherProject versions do: [:e | self addEcoVersion: e].
	otherProject blob addIn: flatblob ! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 15:21'!
initialize 
	versions := OrderedCollection  new.
	versionmap := Dictionary new.
	flatblob := EcoClassBlob new.! !

!EcoProject methodsFor: 'connectingversions' stamp: 'RomainRobbes 8/16/2010 08:26'!
isDisconnected
	^ (self versions select: [:e | e ancestors allSatisfy: [:a | a incomplete]]) size > 1! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/10/2010 20:44'!
isOriginOf: otherProject
	| vs |
	vs := self versions: 3 before: otherProject startDate.
	^ vs anySatisfy: [:e | (e classDistanceWith: otherProject firstversion) > 0.95]! !

!EcoProject methodsFor: 'connectingversions' stamp: 'RomainRobbes 8/16/2010 08:26'!
isPartiallyDisconnected
	^ (self versions select: [:e | e ancestors anySatisfy: [:a | a incomplete]]) size > 1! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 11:48'!
isSplitFrom: otherProject
	| vs |
	vs := otherProject  versions: 3 before: self startDate.
	^ vs anySatisfy: [:e | (e oneWayClassDistanceWith: self firstversion) > 0.99] ! !

!EcoProject methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:29'!
itemNamed: n
	^ versionmap at: n ifAbsent: [nil]! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 18:27'!
lastVersion
	^ versions last! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/16/2010 19:52'!
name
	^ self versions first name! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/3/2010 16:47'!
name: n
	name := n ! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 12:44'!
originVersionIn: otherProject
	| vs max |
	vs := otherProject  versions: 5 before: self startDate.
	max := (vs detectMax: [:e | (e classDistanceWith: self firstversion)]).
	^ Array with: otherProject firstversion with: max with: (self firstversion classDistanceWith: max)! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/9/2010 19:54'!
packageName
	^ self name copyUpToLast: $-! !

!EcoProject methodsFor: 'connectingversions' stamp: 'RomainRobbes 8/16/2010 08:26'!
partiallyDisconnectedVersions
	^ ((self versions select: [:e | e ancestors anySatisfy: [:a | a incomplete]]) asSortedCollection: [:a :b | a date < b date]) removeFirst; yourself! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/16/2010 19:53'!
printOn: aStream 
	aStream nextPutAll: self name; space; nextPut: $(; nextPutAll: versions size asString ; space;
		nextPutAll: self firstVersion date date mmddyyyy; nextPut: $-; nextPutAll: self lastVersion date date mmddyyyy; 
	nextPutAll: ', '; nextPutAll: flatblob allProvided size asString; nextPut: $)! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 14:22'!
projectName
	^ self name copyUpTo: $-! !

!EcoProject methodsFor: 'blob' stamp: 'RomainRobbes 8/14/2010 19:59'!
provided
	^ flatblob provided ! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/17/2010 12:21'!
reIndexCommonalitiesWith: aProject in: index
	"avoid overwriting previous ignores (somewhat?)"
	(self allProvidedNotIgnored intersection: aProject allProvidedNotIgnored) do: [:e | index method: e isProvidedBy: self]! !

!EcoProject methodsFor: 'updating' stamp: 'RomainRobbes 8/17/2010 12:19'!
reIndexIn: index
	self allProvidedNotIgnored do: [:e | index method: e isProvidedBy: self]! !

!EcoProject methodsFor: 'connectingversions' stamp: 'RomainRobbes 8/16/2010 12:38'!
reconnectVersions
	| match |
	^ self disconnectedVersions collect: [:e |
		match := self fastBestRenameMatchFor: e.
		self connect: e with: match as: EcoReconnectTransition.
		e -> match
		] displayingProgress: 'connecting versions ...'! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 15:09'!
relationShipWith: other
	| rel |
	rel := Dictionary new.
	rel at: #splitFrom put: (self degreeOfSplitFrom: other).
	rel at: #supersetOf put: (other degreeOfSplitFrom: self).
	rel at: #originOf put: (other degreeOfOriginFrom: self).
	rel at: #descendentOf put: (self degreeOfOriginFrom: other).
	^ rel! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/5/2010 15:56'!
required
	^ flatblob required ! !

!EcoProject methodsFor: 'visualization' stamp: 'RomainRobbes 8/14/2010 18:54'!
setupVersions
	self versions do: [:e | e project: self]! !

!EcoProject methodsFor: 'visualization' stamp: 'RomainRobbes 8/16/2010 10:27'!
showVersions
	| view edges |
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	view interaction action: #browse.
	
	view shape rectangle 
		text: [:v | v date date mmddyyyy];
		textPadding: 3;
		borderColor: [:v | (v transitions allSatisfy: [:e | e class = EcoTransition]) ifTrue: [Color gray] ifFalse: [Color black]].
	view nodes: self versions.
	view layout: MOHorizontalDominanceTreeLayout new.
	edges := OrderedCollection new.
	self versions do: [:ver|
		ver ancestors do: [:anc|
		edges add: anc -> ver.].].
view shape arrowedLine arrowSize: 4; color: [:as | ((as key transitions detect: [:e | e newVersion = as value] ifNone: [nil]) class = EcoTransition)  ifTrue: [Color gray] ifFalse: [Color black]].
	view edges: edges 	
				from: #key
				to: #value.
	view open! !

!EcoProject methodsFor: 'versions' stamp: 'RomainRobbes 8/16/2010 09:06'!
sortVersions
	versions := versions asSortedCollection: [:a :b | a date < b date]! !

!EcoProject methodsFor: 'accessing' stamp: 'RomainRobbes 8/10/2010 19:33'!
startDate
	^ self firstversion date! !

!EcoProject methodsFor: 'accessing' stamp: 'MirceaLungu 8/9/2010 16:04'!
transitions
	^ versions gather: [:e | e transitions]! !

!EcoProject methodsFor: 'relationships' stamp: 'RomainRobbes 8/15/2010 12:16'!
versionSplitFrom: otherProject
	| vs mx |
	vs := otherProject  versions: 5 before: self startDate.
	vs ifEmpty: [^ nil].
	mx :=  (vs detectMax: [:e | (e oneWayClassDistanceWith: self firstversion)]).
	^ Array with: self firstversion with: mx with: (mx oneWayClassDistanceWith: self firstversion) with:  (mx classDistanceWith: self firstversion)! !

!EcoProject methodsFor: 'initialize-release' stamp: 'MirceaLungu 8/4/2010 11:46'!
versions 
	^versions! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/15/2010 15:37'!
versions: n after: date
	| candidates |
	candidates := (versions select: [:e | e date > date]).
	candidates size < n ifTrue: [^candidates].
	^ candidates first: n ! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/10/2010 19:38'!
versions: n before: date
	| candidates |
	candidates := (versions select: [:e | e date < date]).
	candidates size < n ifTrue: [^candidates].
	^ candidates last: n ! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/15/2010 16:15'!
versionsAfter: date
	| candidates |
	^ (versions select: [:e | e date > date]).
	! !

!EcoProject methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/15/2010 15:37'!
versionsAround: date before: n after: m
	^ (self versions: n before: date), (self versions: m after: date)! !

!EcoProject methodsFor: 'dependencies' stamp: 'RomainRobbes 8/17/2010 11:12'!
wipeDependencies
	dependents := self dependents select: [:e | e isCopyDep].
	dependsOn := self dependsOn select: [:e | e isCopyDep].! !

Object subclass: #EcoProjectVersion
	instanceVariableNames: 'blob ancestors successors info name date author folder transitions prevTransitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

EcoProjectVersion class
	instanceVariableNames: 'versions accesses misses'!

EcoProjectVersion class
	instanceVariableNames: 'versions accesses misses'!

!EcoProjectVersion class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 19:00'!
cacheMCVersionFor: aVersion
	| repo version |
	misses := misses + 1.
	EcoSystem withoutMCCacheDo: [
		repo := MCDirectoryRepository new directory: (FileDirectory on: aVersion folder).
		repo versionReaderForFileNamed: aVersion name, '.mcz' do: [:reader | 
			reader resetStream.
			version := reader basicVersion]
		].
	versions size > self maxSize ifTrue: [self removeOldestVersion].
	^ versions add: (Array with: aVersion with: version with: DateAndTime now)! !

!EcoProjectVersion class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 13:46'!
initialize 
	versions := OrderedCollection new.
	accesses := 0.
	misses := 0 ! !

!EcoProjectVersion class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 09:07'!
maxSize
	^ 50! !

!EcoProjectVersion class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 19:01'!
mcVersionFor: aVersion
	accesses := accesses + 1.
	^ (versions detect: [:e | e first = aVersion ifTrue: [e at: 3 put: DateAndTime now. true] ifFalse: [false]] ifNone: [self cacheMCVersionFor: aVersion]) second! !

!EcoProjectVersion class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 19:07'!
removeOldestVersion
	versions remove: (versions detectMin: [:e | e third])! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/5/2010 16:14'!
ancestorOf: aVersion
	
	successors add: aVersion.
	aVersion successorOf: self.
	! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 12:07'!
ancestors 
	^ ancestors ! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 10:49'!
author
	^ author! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/10/2010 15:59'!
browse
	^ self mcVersion browse! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/9/2010 13:47'!
buildTransitions
	"ancestors := ancestors collect: [:e | self to: e]."
	transitions := successors collect: [:e | self to: e]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'MirceaLungu 8/19/2010 22:16'!
changeFromAncestors
	^self computeBigChangeFromAncestors ! !

!EcoProjectVersion methodsFor: 'comparing' stamp: 'RomainRobbes 8/10/2010 19:36'!
classDistanceWith: otherVersion
	^ self classes distanceWith: otherVersion classes! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/10/2010 19:16'!
classes
	^ self mcVersion snapshot definitions select: [:e | e isClassDefinition] thenCollect: [:e | e className]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'MirceaLungu 8/19/2010 22:20'!
computeBigChangeFromAncestors
	| bunchOfChanges bigBag |
	bunchOfChanges := ((ancestors select: [:e| e transitions notNil]) collect: [:e | (e transitions detect: [:t | t newVersion = self])]) collect: [: ff| ff change].
	bigBag := bunchOfChanges inject: EcoChange new into: [:bigChange :change| change addToChange: bigChange].
	^bigBag ! !

!EcoProjectVersion methodsFor: 'importing' stamp: 'RomainRobbes 8/9/2010 17:24'!
convertToCurrentVersion: varDict refStream: smartRefStrm
	"we do nothing, we just added an inst var that is nil in the beginning (changes of 08/09/10)"! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 17:46'!
date
	^ date ! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/16/2010 20:42'!
firstOriginalVersion
	(transitions noneSatisfy: [:e | e class = EcoIncorporateTransition]) ifTrue: [^ self].
	^ (successors collect: [:e | e firstOriginalVersion]) detectMin: [:e | e date]! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 09:09'!
folder 
	^ folder! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 12:01'!
folder: fld

	folder := fld pathName ! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 17:57'!
fromVersion: aMCVersion
	date := aMCVersion timeStamp.
	author := aMCVersion info author.
	"blob processSnapshot: aMCVersion snapshot"! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/11/2010 19:34'!
getDataFrom: other
	| s |
	self name = other name ifFalse: [self halt].
	transitions := other transitions.
	transitions do: [:t | s := (successors detect: [:e | e name = t newVersion name]).
		t setFrom: self to: s.]! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/6/2010 15:46'!
hasIncompleteAncestry
	^ self incompleteAncestors notEmpty! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/6/2010 15:45'!
incomplete
	^ author isNil ! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/6/2010 16:02'!
incompleteAncestors
	^ ancestors select: [:e | e incomplete]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 17:57'!
initialize 
	ancestors := Set new.
	successors := Set new.
	"blob := EcoBlob new"! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/9/2010 14:01'!
initializePrevTransitions 
	prevTransitions := ancestors collect: [:e | (e transitions detect: [:t | t newVersion = self]) opposite].
	^ prevTransitions ! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/16/2010 09:43'!
killPrevTransitions
	prevTransitions := nil! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/10/2010 16:11'!
mcCbag
	self incomplete ifTrue: [^ EcoBag new].
	^ EcoClassBag new processSnapshot: self mcVersion snapshot! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/6/2010 15:46'!
mcInfo
	^ self mcVersion info! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 09:10'!
mcVersion
	^ self class mcVersionFor: self! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/8/2010 18:32'!
mcbag
	self incomplete ifTrue: [^ EcoBag new].
	^ EcoBag new processSnapshot: self mcVersion snapshot! !

!EcoProjectVersion methodsFor: 'comparing' stamp: 'RomainRobbes 8/15/2010 17:08'!
methodDistanceWith: otherVersion
	^ self methods asSet distanceWith: otherVersion methods asSet! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/15/2010 16:41'!
methods
	^ self mcVersion snapshot definitions select: [:e | e isMethodDefinition] thenCollect: [:e | e selector]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 18:11'!
name
	^ name! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 18:11'!
name: n
	name := n.
	! !

!EcoProjectVersion methodsFor: 'comparing' stamp: 'RomainRobbes 8/10/2010 20:47'!
oneWayClassDistanceWith: otherVersion
	^ self classes oneWayDistanceWith: otherVersion classes! !

!EcoProjectVersion methodsFor: 'comparing' stamp: 'RomainRobbes 8/15/2010 17:09'!
oneWayMethodDistanceWith: otherVersion
	^ self methods asSet oneWayDistanceWith: otherVersion methods asSet! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/9/2010 14:00'!
prevTransitions
	^ prevTransitions ifNil: [self initializePrevTransitions]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 17:26'!
printOn: aStream
	aStream nextPutAll:  name; space; nextPut: $(; nextPutAll: (date date mmddyyyy); nextPut: $)! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/14/2010 18:54'!
project
	^ info! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/14/2010 18:53'!
project: p
	"needs to be renamed at some point"
	info := p! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/6/2010 15:52'!
purgeIncompleteAncestry
	ancestors := ancestors reject: [:e | e incomplete]! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/9/2010 20:30'!
purgeIncompleteAncestryExcluding: keepers
	ancestors := ancestors reject: [:e | e incomplete and: [(keepers includes: e) not]]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 18:12'!
successorOf: aVersion
	ancestors add: aVersion. 
	! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/4/2010 12:07'!
successors 
	^ successors ! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/11/2010 18:49'!
to: anotherVersion
	^ EcoTransition new altFrom: self to: anotherVersion ! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/16/2010 14:20'!
transitionClassesCollect: twoArgBlock
	| result seen |
	result := OrderedCollection new.
	seen := Set new.
	self transitionCollect: twoArgBlock withClasses: self classes asOrderedCollection result: result seen: seen. 
	^ result! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/16/2010 11:17'!
transitionCollect: twoArgBlock withClasses: classes result: result
	result add: (twoArgBlock value: self value: classes).
	self transitions do: [:t | 
		t applyClassesOn: classes.
		t newVersion transitionCollect: twoArgBlock withClasses: classes result: result.
		t unApplyClassesOn: classes. 
		].
	! !

!EcoProjectVersion methodsFor: 'transitions' stamp: 'RomainRobbes 8/16/2010 12:15'!
transitionCollect: twoArgBlock withClasses: classes result: result seen: seen
	(seen includes: self) ifTrue: [^ self].
	seen add: self.
	result add: (twoArgBlock value: self value: classes).
	self transitions do: [:t | 
		t applyClassesOn: classes.
		t newVersion transitionCollect: twoArgBlock withClasses: classes result: result seen: seen.
		t unApplyClassesOn: classes. 
		].
	! !

!EcoProjectVersion methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 08:28'!
transitionFor: aVersion
	^ self transitions detect: [:e | e newVersion = aVersion]! !

!EcoProjectVersion methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/16/2010 11:13'!
transitions
	^transitions ifNil: [#()]! !

!EcoProjectVersion methodsFor: 'testing' stamp: 'RomainRobbes 8/6/2010 18:05'!
trashBlob
	blob := nil! !

Object subclass: #EcoRepoReader
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoRepoReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/4/2010 15:16'!
blobType
	^ type = #classes ifTrue: [EcoClassMethodBlob] ifFalse: [EcoBlob]! !

!EcoRepoReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 17:12'!
buildClasses
	type := #classes! !

!EcoRepoReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 17:11'!
initialize 
	super initialize. 
	type = #methods! !

!EcoRepoReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/3/2009 18:53'!
readAll
	
	
	| repos |
	repos := self repositories.
	'parsing super-repository' 
		displayProgressAt: Sensor cursorPoint 
		from: 0 to: repos size 
		during: [:bar | repos doWithIndex: [:repo :idx | bar value: idx. self readRepository: repo]]! !

!EcoRepoReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/3/2009 18:00'!
repositories
	^ Array new! !

EcoRepoReader subclass: #EcoSqueaksourceReader
	instanceVariableNames: 'blobs snapshotting buggyMczs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

EcoSqueaksourceReader subclass: #EcoLocalDirMczReader
	instanceVariableNames: 'repoList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/15/2009 19:22'!
getRepository: location
	^MCDirectoryRepository new directory: (FileDirectory on: location)! !

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/15/2009 20:37'!
makeBlobForMcz: mcz name: name
	mcz resetStream.
	^ super makeBlobForMcz: mcz name: name! !

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 12:29'!
readFile: f in: repo location: location
	| ext |
	f first = $. ifFalse: [
	ext := f copyAfterLast: $..
	ext = 'mcz' ifTrue: [^ self readMcz: f in: repo location: location].
	ext = 'sar' ifTrue: [^self readSar: f in: repo location: location].
	(ext = 'st' or: [ext = 'cs']) ifTrue: [self readStOrCs: f in: repo location: location]]! !

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 09:28'!
readSar: f in: repo location: location
	| reader mob bigBlob |
	reader := EcoLocalDirSarReader new repoList: self repoList first, '/', f.
	type = #classes ifTrue: [reader buildClasses]. 
	reader readAll.
	mob := EcoMob new.
 	mob blobs: reader blobs.
	bigBlob := mob theBigBlob.
	bigBlob flushEntities.
	bigBlob addEntity: (f copyUpToLast: $.).
	blobs add: bigBlob ! !

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 12:26'!
readStOrCs: file in: repo location: location
	| reader blob stream |
	reader := MCReader readerClassForFileNamed: file.
	reader ifNotNil: [
	stream := FileStream fileNamed: repo directory pathName, '/', file.
	reader := reader on: stream.
	reader loadDefinitions.
	"file = 'BitArray1.cs' ifTrue: [reader halt]."
	blob := self blobType new.
	blob addEntity: (file copyUpToLast: $.).
	Transcript cr; show: 'reading '; show: file.
	reader definitions do: [:def | blob onMCDef: def].
	blobs add: blob.]! !

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/3/2010 17:33'!
repoList 
	^repoList ! !

!EcoLocalDirMczReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/3/2010 15:37'!
repoList: rl
	repoList := rl! !

EcoLocalDirMczReader subclass: #EcoLocalDirSarReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 09:28'!
blobs 
	^ blobs ! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/15/2009 19:19'!
getRepository: location
	^ MCHttpRepository location: location
		user: 'ecco'
		password: 'ecco'! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/11/2009 14:30'!
initialize 
	super initialize.
	blobs := OrderedCollection new.
	snapshotting := true.
	buggyMczs := OrderedCollection new.! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/3/2010 17:39'!
makeBlobForMcz: mcz
	| blob |
	(mcz isKindOf: MCMczReader) ifFalse: [Transcript cr; show: 'Found an: '; show: mcz class name. ^self.].
	mcz loadDefinitions.
	blob := self blobType new.
	mcz definitions do: [:def | blob onMCDef: def].
	blobs add: blob.! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/3/2010 17:41'!
makeBlobForMcz: mcz name: name
	| blob |
	(mcz isKindOf: MCMczReader) ifFalse: [Transcript cr; show: 'Found an: '; show: mcz class name. ^self.].
	mcz loadDefinitions; loadVersionInfo.
	blob := self blobType new.
	blob addEntity: name.
	blob addEntity: mcz version info.
	"blob trashAncestors."
	Transcript cr; show: 'reading '; show: mcz version; show: 'from: '; show: name.
	mcz definitions do: [:def | blob onMCDef: def].
	blobs add: blob.
	self halt.
	^ blob
	"mcz wipe"! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/11/2009 14:31'!
noSnapshot
	snapshotting := false.! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 12/7/2009 15:26'!
onlyLatestVersionsOf: files
	| selected packageName |
	selected := Set new.
	^ files select: [:e | packageName := e copyUpToLast: $-.
				(selected includes: packageName) 
					ifTrue: [false]
					ifFalse: [selected add: packageName. true. ]
				]! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/3/2009 17:58'!
packageList
	^ Array with: 'http://www.squeaksource.com/Bytecode/'! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 21:57'!
readFile: f in: repo location: location
	self readMcz: f in: repo  location: location ! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/12/2010 15:54'!
readMcz: f in: repo location: location
	| blob |
	(repo versionReaderForFileNamed: f) ifNotNilDo: [ :mcz | 
	Transcript cr; show: 'reading mcz: '; show: f; cr.
	blob := self makeBlobForMcz: mcz name: location.
	blob flushEntities.
	blob addEntity: (f copyUpToLast: $.).
	MCCacheRepository default flushCache]! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 1/10/2010 21:57'!
readRepository: location
	| repo files |
	Transcript
		cr;
		show: 'reading repository:';
		cr;
		show: location.
	repo := self getRepository: location.
	files := repo allFileNames.
	snapshotting ifTrue: [ files := self onlyLatestVersionsOf: files ].
	location displayProgressAt: Sensor cursorPoint
		from: 0
		to: files size
		during:
			[ :bar | 
			files doWithIndex:
					[ :f :i | 
					bar value: i.
					self readFile: f in: repo  location: location ]]! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/12/2009 12:43'!
readRepository: location startingAtFile: file
	| repo files |
	repo := MCHttpRepository location: location user: 'ecco' password: 'ecco'.
	files := repo allFileNames.
	files := files copyFrom: (files indexOf: file) to: files size.
	location displayProgressAt: Sensor cursorPoint from: 0 to: files size during: [:bar | 
	files doWithIndex: [:f :i | bar value: i. [(repo versionReaderForFileNamed: f) ifNotNilDo: [:mcz | self makeBlobForMcz: mcz name: location. MCCacheRepository default flushCache]]
		on: Error do: [:e | buggyMczs add: location -> f]]].
	! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/12/2009 12:39'!
repoList
	| strm repos |
	strm := FileStream fileNamed: 'squeaksource.txt'.
	repos := OrderedCollection new.
	strm contents linesDo: [:e | repos add: e].
	^ repos copyFrom: (repos indexOf: 'http://www.squeaksource.com/Seaside/') + 1 to: repos size.
	! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/3/2009 18:47'!
repositories 
	^ self repoList ! !

!EcoSqueaksourceReader methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/7/2009 07:51'!
writeBlobsOn: fName
	| tempBlbs is arr |
	tempBlbs := blobs.
	blobs := nil.
	is := ImageSegment new.
	arr := Array with: tempBlbs.
	is 
		copyFromRoots: arr
		sizeHint: 1000000
		areUnique: true.
	is writeForExportOn: (FileStream fileNamed: fName).	
	blobs := tempBlbs! !

Object subclass: #EcoRipple
	instanceVariableNames: 'from to ecosystem transitions originator patch pt'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Ripples'!

EcoRipple class
	instanceVariableNames: 'selected rejected'!

EcoRipple class
	instanceVariableNames: 'selected rejected'!

!EcoRipple class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/17/2010 12:44'!
deprecatedMethods

	^ ({self deprecatedMethods1. self deprecatedMethods2. self deprecatedMethods3} 
			gather: [:e | e]) asSortedCollection: [:a :b| a from asString < b from asString]! !

!EcoRipple class methodsFor: 'knowninstances' stamp: 'RomainRobbes 8/13/2010 10:22'!
deprecatedMethods1
	^ 
	{
#(PasteUpMorph bringFlapTabsToFront)   =>   #(PasteUpMorph bringTopmostsToFront) .
#(MultiByteFileStream basicVerbatim: )   =>   #() .
#(String asCharacter)   =>   #() .
#(String findLastOccuranceOfString:startingAt: )   =>   #(String findLastOccurrenceOfString:startingAt:) .
#(FileStream writeSourceCodeFrom:baseName:isSt:useHtml: )   =>   #(FileStream writeSourceCodeFrom:baseName:isSt:) .
#(Utilities authorInitials )   =>   #(Author initials) .
#(Utilities authorInitialsPerSe )   =>   #(Author initialsPerSe) .
#(Utilities authorName )   =>   #(Author fullName) .
#(Utilities authorName: )   =>   #(Author fullName:) .
#(Utilities authorNamePerSe)   =>   #(Author namePerSe) .
#(Utilities classFromPattern:withCaption:)   =>   #(SystemNavigation classFromPattern:withCaption:) .
#(Utilities fileOutChangeSetsNamed:)   =>   #(ChangeSet fileOutChangeSetsNamed:) .
#(Utilities informUser:during:)   =>   #(UIManager default informUser:during:) .
#(Utilities pointersTo:)   =>   #(PointerFinder pointersTo:) .
#(Utilities pointersTo:except:)   =>   #(PointerFinder pointersTo:except:) .
#(Utilities pointersToItem:of:)   =>   #(PointerFinder pointersToItem:of:) .
#(Utilities setAuthorInitials)   =>   #(Author requestInitials) .
#(Utilities setAuthorInitials)   =>   #(Author initials:) .
#(Utilities setAuthorName)   =>   #(Author requestName) .
#(Author initials)   =>   #(Author fullName) .
#(Author initials:)   =>   #(Author fullName:) .
#(Author initialsPerSe)   =>   #(Author fullNamePerSe) .
#(Author requestInitials)   =>   #(Author requestName) .
#(Author requestName)   =>   #(Author requestFullName) .
#(SystemDictionary browseObsoleteMethodReferences)   =>   #(SmalltalkImage browseObsoleteMethodReferences) .
#(SystemDictionary getFileNameFromUser)   =>   #(SmalltalkImage getFileNameFromUser) .
#(SystemDictionary hasMorphic)   =>   #() .
#(SystemDictionary isMorphic)   =>   #() .
#(SystemDictionary obsoleteBehaviors)   =>   #(SystemNavigation obsoleteBehaviors) .
#(SystemDictionary obsoleteClasses)   =>   #(SystemNavigation obsoleteClasses) .
#(SystemDictionary obsoleteMethodReferences)   =>   #(SystemNavigation obsoleteReferencecs) .
#(SystemDictionary pointersTo:)   =>   #(PointerFinder pointersTo:) .
#(SystemDictionary pointersTo:except:)   =>   #(PointerFinder pointersTo:except:) .
#(SystemDictionary pointersToItem:of:)   =>   #(PointerFinder pointersToItem:of:) .
#(SystemDictionary removeAllUnSentMessages)   =>   #(SystemDictionary removeAllUnsentMessages) .
#(SystemDictionary unbindExternalPrimitives)   =>   #(SmalltalkImage unbindExternalPrimitives) .
#(SystemDictionary verifyMorphicAvailability)   =>   #() .
#(SystemNavigation allCallsOn:)   =>   #(SystemNavigation allReferencesTo:) .
#(SystemNavigation allUnSentMessages)   =>   #(SystemNavigation allUnsentMessages) .
#(SystemNavigation allUnSentMessagesIn:)   =>   #(SystemNavigation allUnsentMessagesIn:) .
}! !

!EcoRipple class methodsFor: 'knowninstances' stamp: 'RomainRobbes 8/13/2010 10:25'!
deprecatedMethods2
	^ 
	{
#(Project isMorphic)   =>   #() .
#(ClassDescription categoryFromUserWithPrompt:)   =>   #(CodeHolder categoryFromUserWithPrompt:for:) .
#(ClassDescription commentFollows)   =>   #(ClassCommentReader setClass:category:) .
#(ClassDescription compileInobtrusively:classified:)   =>   #(ClassDescription compileSilently:classified:) .
#(ClassDescription metaclass)   =>   #(ClassDescription theMetaClass) .
#(ClassDescription methods)   =>   #(ClassCategoryReader) .
#(ClassDescription nonMetaclass)   =>   #(ClassDescription theNonMetaClass) .
#(PersonalSetting installer)   =>   #() .
#(Namespace at:)   =>   #(Namespace classNamed:  variableNamed:) .
#(Namespace hasBindingThatBeginsWith:)   =>   #() .
#(HVTTransientView createSelectWidget:name:)   =>   #(HVHtmlBuilder select*) .
#(HVTTransientView createSelectWidget:selected:name:)   =>   #(HVHtmlBuilder select*) .
#(HVTTransientView createSelectWidget:selected:name:withIds:) => #(HVHtmlBuilder select*) .
#(HVTTransientView endhtml)   =>   #(HVHtmlBuilder) .
#(HVTTransientView endhtml:)   =>   #(HVHtmlBuilder) .
#(HVTTransientView link:text:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView linkBack:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView linkBackParent:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView linkBase:local:text:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView linkLocal:text:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView linkback:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView linkbackparent:)   =>   #(HVHtmlBuilder getLink* link*) .
#(HVTTransientView message:linklocal:)   =>   #(HVTTransientView message:linkLocal:) .
#(HVTTransientView message:linklocal:text:)   =>   #(HVTTransientView message:linkLocal:text:) .
#(HVTTransientView methodAfter:)   =>   #(HVTTransientView nextMethod) .
#(HVTTransientView methodInUrl:after:)   =>   #(HVTTransientView nextMethod) .
#(HVTTransientView prefix)   =>   #(HVTTransientView nextMethod) .
#(HVTTransientView starthtml)   =>   #(HVHtmlBuilder) .
#(HVHtmlBuilder linkBack)   =>   #(HVHtmlBuilder linkDefault) .
#(HVHtmlBuilder linkBack:)   =>   #(HVHtmlBuilder linkDefault:) .
#(HVHtmlBuilder linkPrefix:text:)   =>   #(HVHtmlBuilder parentsDo:) .
#(KFNetworkUtils topNodesOf:)   =>   #(KFNetworkUtils rootNodeOfUrl:) .
#(HismoPackageHistory packagedIn)   =>   #(HismoPackageHistory parentPackage) .
#(HismoClassHistory packagedIn)   =>   #(HismoClassHistory parentPackage) .
#(FAMIXNamedEntity packagedIn)   =>   #(FAMIXNamedEntity parentPackage) .
#(Text isoToSqueak)   =>   #() .
#(Text macToSqueak)   =>   #() .
#(Text squeakToIso)   => #().
#(Text squeakToMac)   =>  #().
#(KFSlideshow showImages:delay:)   =>   #(KFSlidedShow showImages:delaySeconds:) .
#(SequenceableCollection startsWith:)   =>   #(SequenceableCollection beginsWith:) .
#(SequenceableCollection upTo:)   =>   #(SequenceableCollection copyUpTo:) .
#(AbstractMoqamItem name)   =>   #(AbstractMoqamItem moqamName) .
#(AbstractMoqamItem name:)   =>   #(AbstractMoqamItem moqamName: ) .
#(FAMIX2FormalParameter defaultIsReceiver)   =>   #() .
#(TFileInOutDescription fileOutCategory:asHtml:)   =>   #(TFileInOutDescription fileOutCategory:) .
#(TFileInOutDescription fileOutMethod:asHtml:)   =>   #(TFileInOutDescription fileOutMethod:) .
#(TClassAndTraitDescription commentFollows)   =>   #(ClassCommentReader) .
}! !

!EcoRipple class methodsFor: 'knowninstances' stamp: 'RomainRobbes 8/13/2010 12:46'!
deprecatedMethods3
	^ 
	{
	
#(VersionsBrowser browseVersionsForClass:selector)   =>   #().
#(VersionsBrowser browseVersionsOf:class:meta:category:selector:)   =>   #().
#(VersionsBrowser browseVersionsOf:class:meta:category:selector:lostMethodPointer: )   => #().
#(VersionsBrowser browseVersionsOf:selector:)   =>   #().
#(VersionsBrowser addPriorVersionsCountForSelector:ofClass:to:)   =>   #().
#(VersionsBrowser addedChangeRecord:)   =>   #() .
#(VersionsBrowser addedChangeRecord)   =>   #() .
#(VersionsBrowser changeListKey:from:)   =>   #() .
#(VersionsBrowser fileInSelections)   =>   #().
#(VersionsBrowser scanVersionsOf:class:meta:category:selector: )   =>   #().
#(VersionsBrowser showVersions)   =>   #() .
#(ClassCommentVersionsBrowser browseCommentOf:)   =>   #() .
#(ClassCommentVersionsBrowser commentRecordsOf:)   =>   #() .
#(ClassCommentVersionsBrowser timeStampFor:class:reverseOrdinal: )   =>   #().
#(ClassCommentVersionsBrowser diffedVersionContents)   =>   #() .
#(ClassCommentVersionsBrowser priorSourceOrNil)   =>   #() .
#(ClassCommentVersionsBrowser scanVersionsOf:)   =>   #() .
#(LogRouter debug:)   =>   #(LogRouter debug) .
#(LogRouter error:)   =>   #(LogRouter error) .
#(LogRouter info:)   =>   #(LogRouter info) .
#(LogRouter warn:)   =>   #(LogRouter warn) .
#(ChangeRecord2 file:position:type:class:category:meta:stamp:)   =>   #() .
#(ScriptLoader loadSeaside29)   =>   #(ScriptLoader loadSeaside30) .
#(ScreenController fullScreenOff)   =>   #() .
#(ScreenController fullScreenOn)   =>   #() .
#(FMPrintClient string:)   =>   #(onString) .
#(FMMSEParser string:)   =>   #(fromString) .
#(NSAbstractDataStream closed)   =>   #(NSAbstractDataStream isClosed) .
#(TheWorldMenu mvcProjectsAllowed)   =>   #() .
#(Flaps newSqueakFlap)   =>   #(Flaps newPharoFlap) .
#(BalloonMorph setBalloonFontTo:)   =>   #(StandardFont balloonFont) .
#(ActionAddPackage belongsTo:)   =>   #() .
#(WisconsinRouter shutDownRouters)   =>   #(shutDown) .
#(GLMTableLayoutBrowser) => #(GLMTabulator) .
#(Compiler format:in:notifying:contentsSymbol:)   =>   #() .
#(Compiler format:in:notifying:decorated:)   =>   #() .
#(Collection isZero)   =>   #() .
#(NSTStream closed)   =>   #(NSStream isClosed) .
#(VerletIntegrator solveCollisions)   =>   #(VerletIntegrator solveCollisionsPlaneSweeped) .
#(SystemOrganizer fileOutCategory:asHtml:)   =>   #(SystemOrganizer fileOutCategory:) .
#(DataStream project)   =>   #() .
#(Author requestInitials)   =>   #(Author requestName) .
#(GtkTooltips delay)   =>   #() .
#(MooseModel addEntity:)   =>   #(add:) .
#(MooseModel overviewCriteria)   =>   #() .
#(MooseModel overviewPractice)   =>   #() .
#(FAMIXPackage viewClassMap)   =>   #() .
#(FAMIXPackage viewPracticeMap)   =>   #() .
#(MoqamModel moqamBrowser)   =>   #() .
#(MagmaCollection commitDo:)   =>   #(MagmaCollection slowlyDo:pageBoundariesDo:) .
#(MagmaCollectionReader at:ifOutOfBounds)   =>   #(MagmaCollectionReader at:ifAbsent:) .
#(Object beep)   =>   #(Beeper beep) .
#(Object beepPrimitive)   =>   #(Beeper beep ) .
#(Object couldOpenInMorphic)   =>   #() .
#(Object isKindOf:orOf:)   =>   #(Object isKindOf:) .
#(CompiledMethod decompileClass:selector:)   =>   #(CompiledMethod decompile) .
#(CompiledMethod hasLiteralThorough:)   =>   #(CompiledMethod refersToLiteral:) .
#(CompiledMethod literalsDo:)   =>   #(CompiledMethod literals do:) .
#(CompiledMethod who)   =>   #(CompiledMethod methodClass  selector) .
#(MethodDictionary do:)   =>   #() .
#(MethodContext answer:)   =>   #() .
#(MethodContext who)   =>   #(MethodContext methodClass  selector) .
#(ContextPart mclass)   =>   #(ContextPart methodClass) .
#(ContextPart methodSelector)   =>   #(ContextPart selector) .
#(Number isInf)   =>   #(Number isInfinite) .
#(SharedQueue2 flush)   =>   #(SharedQueue2 removeAll) .
#(SharedQueue2 flushAllSuchThat:)   =>   #(SharedQueue2 removeAllSuchThat:) .
#(Behavior selectorAtMethod:setClass:)   =>   #(Behavior methodClass  selector) .
#(RBAbstractClass metaclass)   =>   #(RBAbstractClass theMetaClass) .
#(RBAbstractClass nonMetaClass)   =>   #(RBAbstractClass theNonMetaClass) .
#(ImportingTask useFastImport)   =>   #() .
#(ImportTask useFullImport)   =>   #() .
#(AbstractImporter errorLog)   =>   #().
#(AbstractImporter errorLog:)   =>   #() .
#(MooseModel resetMetaDescriptions)   =>   #(MooseModel resetMeta) .
#(MooseAbstractGroup asList)   =>   #(MooseAbtractGroup asOrderedCollection) .
}! !

!EcoRipple class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/13/2010 10:26'!
deprecatedMethodsOn: ecosys

		^ self deprecatedMethods collect: [:e | e ecosystem: ecosys]! !

!EcoRipple class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/16/2010 16:44'!
deprecatedMethodsWithoutAnyInfluenceWhatsoever
	^ #()! !

!EcoRipple class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:50'!
rejected
	^ rejected ifNil: [rejected := OrderedCollection new]! !

!EcoRipple class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/19/2010 03:50'!
selected
	^ selected ifNil: [selected := OrderedCollection new]! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 04:02'!
additionString
	| s |
	s := WriteStream on: ''.
	to do: [:e | s nextPutAll: e, ': +'. s nextPutAll: (self additionsFor: e ) asString] separatedBy: [s space.].
	^ s contents ! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 04:04'!
additionsFor: m
	| fm |
	^ self transitions inject: 0 into: [:sum :t | sum + (t change numOfAddProvided: m) + (t change numOfAddRequired: m)]! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:18'!
allItems
	^ from, to! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:20'!
allMethodItems
	^ (from select: [:e | e first isLowercase]), 
		(to select: [:e | e first isLowercase])! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 03:19'!
browse
	self sortTransitions.
	^ EcoRippleBrowser openRipple: self! !

!EcoRipple methodsFor: 'accessing' stamp: 'MirceaLungu 8/17/2010 17:53'!
browseDeprecationPatch 
	| patch |
	patch := (self relevantPatchForRemovalAcrossTransitions).
	^ [(PSMCPatchMorph forPatch: patch key)  openInWindowLabeled: patch value printString ] timeToRun / 60000.0! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:24'!
browsePatch 
	^ [(PSMCPatchMorph forPatch: (self relevantPatchAcrossTransitions)) newWindow openInWorld] timeToRun / 60000.0! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 05:53'!
browseRelevantPatch
	self sortTransitions.
	^ EcoRippleBrowser new patchType: #relevantPatch; ripple: self; openInWindowLabeled: self printString ! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:31'!
completePatch
	^ MCPatch operations: (self transitions gather: [:e | e patch operations])! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 02:05'!
computePatch
	^ self transitions collect: [:t | EcoTransitionPatch on: t] displayingProgress: 'computing patch ...'! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 06:48'!
description 
	| s |
	s := WriteStream on: ''.
	s cr.
	self printOn: s.
	s nextPutAll: '                                            '; cr; cr; space.
	s nextPutAll: self transitions first newVersion date date asString, ' to ', self transitions last newVersion date date asString; cr;cr; space.
	s nextPutAll: (self transitions size asString, ' transitions'); cr; cr; space.
	s nextPutAll: (self transitionProjects size asString, ' projects'); cr; cr; space.
	s nextPutAll: (self transitionAuthors size asString, ' developers involved'); cr; cr; space.
	s nextPutAll: (self additionString); cr; cr; space.
	s nextPutAll: (self removalString); cr; cr; space.
	^ s contents 
	! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 09:59'!
ecosystem
	^ ecosystem! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 09:59'!
ecosystem: anObject
	ecosystem := anObject! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 20:25'!
findAllTransitions
	| items |
	items := self allMethodItems.
	^ transitions := ecosystem projects gather: [:e | e transitions select: [:t | t isRelevantFor: items]]	! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:44'!
findTransitions
	| items |
	items := self allMethodItems.
	^ transitions := self projects gather: [:e | e transitions select: [:t | t isRelevantFor: items]]	! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 10:00'!
from
	^ from! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 10:00'!
from: anObject
	from := anObject! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 20:28'!
fromMethods
	^ from reject: [:e | e isClassName]! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 20:30'!
hasRemovals
	^ self removals notEmpty ! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 21:11'!
hasTransitions
	^ transitions notNil! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:47'!
involvedProjects
	^ (self transitions collect: [:e | e newVersion name copyUpToLast: $-]) asSet! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:17'!
items
	self shouldBeImplemented! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 21:11'!
originator 
	^ originator ! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 20:21'!
originator: project
	originator := project! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 02:02'!
patch
	^ patch ifNil: [patch := self computePatch ]! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:17'!
printOn: aStream
	from do: [:e | aStream nextPutAll: e; space].
	aStream nextPutAll: ' => '.
	to do: [:e | aStream nextPutAll: e; space].! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 20:24'!
projects
	^ originator ifNotNilDo: [:o | o clients] ifNil: [ecosystem projects]
! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:30'!
relevantPatchAcrossTransitions
	^ MCPatch operations: (self transitions gather: [:e | (e relevantPatchFor: self allItems) operations])! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 21:43'!
relevantPatchForRemovalAcrossTransitions
	^ ((MCPatch operations: (self transitions gather: [:e | (e relevantPatchForRemoval: self from andAddition: self to) operations])) -> (self from, self to))! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 04:04'!
removalString
	| s |
	s := WriteStream on: ''.
	from do: [:e | s nextPutAll: e, ': -'. s nextPutAll: (self removalsFor: e ) asString] separatedBy: [s space.].
	^ s contents ! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 20:30'!
removals
	| fm |
	fm := self fromMethods.
	^ self transitions select: [:t | fm anySatisfy: [:m | t change removesRequired: m]]! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 04:04'!
removalsFor: m
	| fm |
	^ self transitions inject: 0 into: [:sum :t | sum + (t change numOfRemoveRequired: m) + (t change numOfRemoveProvided: m)]! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 14:53'!
showOnATimeline
	| view  edgeShape  firstDate dayWidth shownProjects originMethod newMethod colorForChange |

	colorForChange := [:change|
		| conditions |
		conditions := OrderedCollection 
			with: [change addsProvided: newMethod] -> Color green
			with: [change removesProvided: originMethod] -> Color red
			with: [(change addsRequired: newMethod) and: [change removesRequired: originMethod]] -> Color yellow
			with: [change addsRequired: newMethod] -> Color blue
			with: [change removesRequired: originMethod] -> Color orange
			with: [true] -> Color black.
		(conditions detect: [:cond| cond key value ]) value.].
	
	originMethod := from ifEmpty: [#veryUnlikelyOriginMethodName] ifNotEmpty: [from first].
	newMethod :=  to ifEmpty: [#veryUnlikelyNewMethodName] ifNotEmpty: [to first].
	shownProjects := self transitionProjects asOrderedCollection add: originator; yourself; reverse.
	
	dayWidth := 2.
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change addProvided size) / 4) + 1) min: 8.
		].
	
	edgeShape color: [:e|
		| anc ver conditions change |
		anc := e key.
		ver := e value.
		change := (anc transitionFor: ver) asOrderedCollection first change. 
		colorForChange value: change.
		].
	
	firstDate := Date today.
	shownProjects do: [:proj|
			proj versions first date < firstDate ifTrue: [
					firstDate := proj firstDate.
				]
		].
	
	view layout: MOVerticalLineWithTimelineLayout new.
	view layout timeBlock: [:node| ((node versions first date - firstDate ) days) * dayWidth].

	view shape: MORectangleShape new withoutBorder .
	
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle fillColor: [:ver|
				Color white.
				].
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			
			view layout: (MOHorizontalDominanceTreeWithTimelineLayout new).
			view layout timeBlock: [: e | ((e date - node firstDate ) days) * dayWidth].
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 04:06'!
showProvRipple: entity in: view color: c x: x
	| edges dots n min max |
	n := 0.
	dots := transitions collectWithIndex: [:t :i  | 
		 n := n + (t change numOfAddProvided: entity) - (t change numOfRemoveProvided: entity).
		TransitionDot new transition: t; x: x; y: n; color: c; entity: entity; yourself].
	min := dots detectMin: [:dot | dot y].
	max := dots detectMax: [:dot | dot y].
	view shape diamond fillColor: #color.
	view nodes: dots.
	
	edges := dots overlappingPairsCollect: [:a :b | a -> b]. 
	view shape line color: [:assoc | assoc key color].
	view edges: edges 	
				from: #key
				to: #value.
	^ Array with: min y with: max y with: dots first tdate with: dots last tdate ! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 11:31'!
showRipple
	| view scale scales x color color2 |
	self sortTransitions.
	transitions size < 3 ifTrue: [^ self inform: 'not enough transitions!!'].
	view := MOViewRenderer new.
	view interaction action: #inspect.
	view interaction action: #browse.
	view interaction action: #browseRelevantPatch.
	x := OrderedCollection new.
	scales := OrderedCollection new.
	color := Color blue.
	color2 := Color black.
	from do: [:e | 
		scales add: (self showRipple: e in: view color: color x: x).
		scales add: (self showProvRipple: e in: view color: color2 x: x).
		color := color whiter lighter.
		color2 := color2 whiter lighter].
	color := Color red.
	color2 := Color green.
	to do: [:e | 
		scales add: (self showRipple: e in: view color: color x: x).
		scales add: (self showProvRipple: e in: view color: color2 x: x).
		color := color whiter lighter.
		color2 := color2 whiter lighter].
	scale := Array with: (scales detectMin: #first) first with: (scales detectMax: #second) second
					with: (scales detectMin: #third) third with: (scales detectMax: #fourth) fourth.
	
	x add: scale third.
	view interaction action: #inspect.
	view interaction action: #browse.
	view interaction action: #browseRelevantPatch.
	view shape rectangle text: #description.
	pt := 0 @ (scale second + 10).
	view node: self. 
	
	"self showRipple2: (from asArray first) in: view."
	view layout: (MOScatterplotLayout new x: #x; y: #y; scaleFactorX: 1024.0 /  (scale fourth - scale third); scaleFactorY: 768.0 / (scale second - scale first); upSideDown).
	view open maximize! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 00:52'!
showRipple: entity in: view color: c x: x
	| edges dots n min max |
	n := 0.
	dots := transitions collectWithIndex: [:t :i  | 
		 n := n + (t change numOfAddRequired: entity) - (t change numOfRemoveRequired: entity).
		TransitionDot new transition: t; x: x; y: n; color: c; entity: entity; yourself].
	min := dots detectMin: [:dot | dot y].
	max := dots detectMax: [:dot | dot y].
	view shape rectangle fillColor: #color.
	view nodes: dots.
	
	edges := dots overlappingPairsCollect: [:a :b | a -> b]. 
	view shape line color: [:assoc | assoc key color].
	view edges: edges 	
				from: #key
				to: #value.
	^ Array with: min y with: max y with: dots first tdate with: dots last tdate ! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 23:56'!
sortTransitions 
	transitions := self transitions asSortedCollection: [:a :b | a newVersion date < b newVersion date]! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 06:02'!
switch
	| t |
	t := from.
	from := to.
	to := t.! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 10:00'!
to
	^ to! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 10:00'!
to: anObject
	to := anObject! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 06:48'!
transitionAuthors
	^ (transitions collect: [:e | e newVersion author]) asSet! !

!EcoRipple methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 18:26'!
transitionProjects
	^ (self transitions collect: [:e | e project]) asSet! !

!EcoRipple methodsFor: 'accessing' stamp: 'RomainRobbes 8/13/2010 11:13'!
transitions
	^ transitions ifNil: [self findTransitions]! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 06:23'!
x
	^ pt x! !

!EcoRipple methodsFor: 'visualizing' stamp: 'RomainRobbes 8/19/2010 06:23'!
y
	^ pt y! !

Object subclass: #EcoRippleGenerator
	instanceVariableNames: 'ecosystem project ripples'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Ripples'!

!EcoRippleGenerator class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 20:14'!
project: p
	^ self new ecosystem: EcoSystem current; project: p; yourself ! !

!EcoRippleGenerator class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 20:16'!
seaside
	^ self project:  'Seaside2-ab.2'! !

!EcoRippleGenerator methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/18/2010 20:14'!
ecosystem: e
	ecosystem := e! !

!EcoRippleGenerator methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/18/2010 20:14'!
project: p
	project := ecosystem itemNamed: p ! !

!EcoRippleGenerator methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/18/2010 20:30'!
ripples
	^ project allProvidedMethods collect: [:e | ({e} => {}) ecosystem: ecosystem; originator: project; yourself  ] thenSelect: [:r | r hasRemovals]! !

Object subclass: #EcoSqueakSource
	instanceVariableNames: 'eco'
	classVariableNames: 'methodIndex'
	poolDictionaries: ''
	category: 'Ecco-Projects'!

!EcoSqueakSource class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/19/2010 23:08'!
methodIndex
	methodIndex isNil ifTrue: [
		methodIndex := Dictionary new.
		].
	^methodIndex .! !

!EcoSqueakSource class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/19/2010 15:04'!
on: object
	^self basicNew
		eco: object;
		initialize! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 17:36'!
allFamixes
	^(eco projects select: [:e| 'FAMIX*' match: e name]) ! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 15:40'!
allMooses
	^(eco projects select: [:e| 'Moose*' match: e name]) reject: [:e| e versions < 10]! !

!EcoSqueakSource methodsFor: 'methodindex' stamp: 'MirceaLungu 8/19/2010 23:07'!
buildIndex
	| index |
	index := EcoMethodIndex new.
	eco projects do: [:proj|
		proj allProvidedMethods do: [:met|
			index method: met isProvidedBy: proj.
			]
		].
	^index.
	! !

!EcoSqueakSource methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 15:04'!
eco
	^ eco! !

!EcoSqueakSource methodsFor: 'accessing' stamp: 'MirceaLungu 8/19/2010 15:04'!
eco: anObject
	eco := anObject! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 17:40'!
famixCore
	^(eco projects detect: [:e| 'FAMIX-Core*' match: e name]) ! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 17:39'!
famixCoreAndFriends
	^self famixCore clients copy add: self famixCore; yourself; reverse! !

!EcoSqueakSource methodsFor: 'methodindex' stamp: 'MirceaLungu 8/19/2010 23:11'!
methodIndex
	^self theMethodIndex ! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 16:51'!
mooseCore
	^(eco projects detect: [:e| 'Moose-Core*' match: e name]) ! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 17:14'!
mooseCoreAndFriends
	^self projectsDependingOnMooseCore add: self mooseCore; yourself; reverse! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 15:38'!
moosesThatMatter
	^(eco projects select: [:e| 'Moose*' match: e name]) reject: [:e| e versions size < 10]! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 21:46'!
projectMatching: aSymbol
	self assert: (self projectsMatching: aSymbol) size = 1.
	^(self projectsMatching: aSymbol) asOrderedCollection first! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 15:49'!
projectsDependingOnMooseAll
	^(eco projects detect: [:e| 'Moose-All*' match: e name]) clients! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 16:49'!
projectsDependingOnMooseCore
	^(eco projects detect: [:e| 'Moose-Core*' match: e name]) clients! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 21:45'!
projectsMatching: aSymbol
	^eco projects select: [:e| aSymbol match: e name]! !

!EcoSqueakSource methodsFor: 'queries over the projects' stamp: 'MirceaLungu 8/19/2010 21:49'!
providerFor: aSymbol
	self assert: (eco index providersFor: aSymbol) size = 1.
	^(eco index providersFor: aSymbol ) asOrderedCollection first! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/19/2010 21:51'!
rippleCopyUpTo

	| ripple |
	ripple := 
	#(upTo:) => #(copyUpTo:).
	ripple
		ecosystem: eco;
		originator: (self providerFor: #SequenceableCollection ).
	^ripple.! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/20/2010 00:14'!
rippleOutgoingAccessesAddition

	| ripple |
	ripple := 
	#(isDataClass) => #(somethingElseNotImportant).
	ripple
		ecosystem: eco;
		originator: self famixCore.
	^ripple.! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/20/2010 00:13'!
rippleParentPackageAddition

	| ripple |
	ripple := 
	#(packagedIn) => #(parentPackage).
	ripple
		ecosystem: eco;
		originator: self famixCore.
	^ripple.! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/19/2010 21:48'!
rippleSystemNavigation

	| ripple |
	ripple := 
	#(allCallsOn:) => #(allReferencesTo:).
	ripple
		ecosystem: eco;
		originator: (self providerFor: #SystemNavigation).
	^ripple.! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/19/2010 15:37'!
showAncestryFor: methodName
	eco showAncestryOnATimelineFor: (self perform: methodName)! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/19/2010 15:41'!
showAncestryForMooses
	eco showAncestryOnATimelineFor: self allMooses ! !

!EcoSqueakSource methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/20/2010 01:38'!
showRippleForRemovedMethodsInFamixCore

	self uniqueMethodsInFamixCore do: [:method|
		| ripple |
		ripple := 
		(Array with: method) => #(somethingElseNotImportant).
		ripple
			ecosystem: eco;
			originator: self famixCore.
		ripple showOnATimeline .
	].! !

!EcoSqueakSource methodsFor: 'methodindex' stamp: 'MirceaLungu 8/19/2010 23:12'!
theMethodIndex
	^self class methodIndex at: eco ifAbsentPut: [self buildIndex].! !

!EcoSqueakSource methodsFor: 'famixCore' stamp: 'MirceaLungu 8/19/2010 23:50'!
uniqueMethodsInFamixCore
	^(self methodIndex uniqueMethodsIn: self famixCore ).
! !

!EcoSqueakSource methodsFor: 'famixCore' stamp: 'MirceaLungu 8/19/2010 23:54'!
uniqueMethodsRemovedInFamixCore
	| famixUniques res |
	res := OrderedCollection new.
	famixUniques := (self methodIndex uniqueMethodsIn: self famixCore ).

	(self famixCore versions select: [:e| e transitions notEmpty  ] )do: [:ver|
			| removedInVer |
			removedInVer := ver transitions asOrderedCollection first change removeProvided .
		(removedInVer anySatisfy: [:removed| famixUniques includes: removed ]) ifTrue: [
			res add: ver ->(removedInVer select: [:e| famixUniques includes: e]).
			].
		].
	^res
! !

Object subclass: #EcoSystem
	instanceVariableNames: 'projects projectmap index coarseIndex coarseProjects decisions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Projects'!

EcoSystem class
	instanceVariableNames: 'current'!

EcoSystem class
	instanceVariableNames: 'current'!

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 11:50'!
addVersions: mcVersionCollection to: e
	(mcVersionCollection asSortedCollection: [ :a :b | a  timeStamp < b  timeStamp ])
		do: [ :v | e addVersion: v ]
		displayingProgress: 'building ecosystem'! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 11:55'!
addVersions: mcVersionCollection to: e folder: folder
	(mcVersionCollection asSortedCollection: [ :a :b | a  timeStamp < b  timeStamp ])
		do: [ :v | e addVersion: v folder: folder]
		displayingProgress: 'building ecosystem'! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 16:41'!
current
	^ current! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 16:41'!
current: e
	current := e! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 12:33'!
from: file
	| f |
	f := FileStream fileNamed: file.
	^ (f fileInObjectAndCode install arrayOfRoots first)! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 11:58'!
fromFolder: aFolder
	| e |
	e := self new.
	EcoSystem withoutMCCacheDo: [
	self fromFolder: aFolder in: e.].
	^ e! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'OzC 4/10/2012 20:07'!
fromFolder: folder in: ecosystem
	| mcVersions repo files |
	
	repo := MCDirectoryRepository new directory: folder.
	files := repo allFileNames select: [:e| e endsWith: 'mcz'].
	
	mcVersions := OrderedCollection new.
	files do: [:f|
		(repo versionReaderForFileNamed: f) ifNotNilDo: [ :mczReader |  |mcVersion|
							mczReader resetStream .
							mcVersion := mczReader basicVersion.
							"mcVersion isInTop1000 ifTrue: ["
								mcVersions add: mcVersion.
								Transcript show: f, 'success'; cr. "]."
						].
					] displayingProgress: 'reading versions'.
	^self addVersions: mcVersions to: ecosystem folder: folder! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 12:20'!
fromFolder: folder in: ecosystem until: date
	| mcVersions repo files |
	
	repo := MCDirectoryRepository new directory: folder..
	files := repo allFileNames select: [:e| e endsWith: 'mcz'].
	
	mcVersions := OrderedCollection new.
	files do: [:f|
		(repo versionReaderForFileNamed: f) ifNotNilDo: [ :mczReader | 
							mczReader resetStream .
							mcVersions add: mczReader basicVersion.
							mcVersions last timeStamp > date ifTrue: [^ self].
							Transcript show: f, 'success'; cr.
						].
					] displayingProgress: 'reading versions'.
	^self addVersions: mcVersions to: ecosystem folder: folder! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/5/2010 16:23'!
fromImage
	
	^self fromVersions: MCVersion allInstances! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 12:00'!
fromLocalFolder: folderName
	^ self fromFolder: (FileDirectory default directoryNamed: folderName)! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'OzC 11/2/2010 23:54'!
fromNestedFolder: f
	| e d |
	e := self new.
	d := FileDirectory default directoryNamed: f.
	EcoSystem withoutMCCacheDo: [
	d directoryNames do: [:dir | 
		dir = 'bogus' ifFalse: [self fromFolder: (d directoryNamed: dir) in: e]. 
		] displayingProgress: 'reading directories'].
	^ e! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 14:06'!
fromNestedFolder: f until: date
	| e d |
	e := self new.
	d := FileDirectory on: f.
	EcoSystem withoutMCCacheDo: [
	d directoryNames do: [:dir | 
		dir = 'bogus' ifFalse: [self fromFolder: (d directoryNamed: dir) in: e until: date]. 
		] displayingProgress: 'reading directories'].
	^ e! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/5/2010 17:59'!
fromVersions: mcVersionCollection
	| e versions |
	e := EcoSystem new.
	self addVersions: mcVersionCollection to: e.
	^ e! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/5/2010 17:02'!
showFromImage
	EcoSystem fromImage show.! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/6/2010 12:23'!
theBigOneAt: date
	^ self fromNestedFolder: '/Users/rr/Projects/images/ssnap' until: date asDate! !

!EcoSystem class methodsFor: 'as yet unclassified' stamp: 'OzC 12/21/2011 13:06'!
withoutMCCacheDo: aBlock
	
	[MCVersion compileSilently:  'isCacheable ^ false' classified: '*ecco-silently' notifying: nil.
	MCVersion compileSilently: 'addToCache' classified: '*ecco-silently' notifying: nil.
	aBlock value] ensure: [
		MCVersion compileSilently: 'isCacheable ^ true' classified: '*ecco-silently' notifying: nil.
		MCVersion compileSilently: 'addToCache
			MCCacheRepository default storeVersion: self' classified: '*ecco-silently' notifying: nil.].! !

!EcoSystem methodsFor: 'updating' stamp: 'RomainRobbes 8/4/2010 15:24'!
addVersion: aMCVersion
	| project |
	
	project := self projectForVersionInfo: aMCVersion info.
	project addVersion: aMCVersion.
	project reIndexIn: index.! !

!EcoSystem methodsFor: 'updating' stamp: 'RomainRobbes 8/6/2010 11:55'!
addVersion: aMCVersion folder: folder
	| project |
	
	project := self projectForVersionInfo: aMCVersion info.
	project addVersion: aMCVersion folder: folder.
	project reIndexIn: index.! !

!EcoSystem methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 18:05'!
allVersions
	^ projects gather: [:e | e versions]! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/9/2010 14:06'!
applyAllDecisions
	^ self applyDecisions: decisions ! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/9/2010 14:06'!
applyAllDecisionsFrom: aFile
	^ self applyDecisions: (self readDecisionsFrom: aFile)! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/16/2010 16:42'!
applyAllDecisionsInOrder
	EcoSystem current: self.
	^ self applyDecisions: (decisions asSortedCollection: [:a :b | a date < b date])! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/16/2010 16:40'!
applyDecisions: ds
	ds do: [:e | e applyOn: self] displayingProgress: 'applying decisions ...'! !

!EcoSystem methodsFor: 'accessing' stamp: 'RomainRobbes 8/8/2010 19:50'!
browseChangesAbout: items
	^ (PSMCPatchMorph forPatch: (self changesAbout: items)) newWindow openInWorld ! !

!EcoSystem methodsFor: 'exporting' stamp: 'RomainRobbes 8/11/2010 20:59'!
buildAllTransitionsIncrementally
	| projs is  t pp p |
	(self confirm: 'this will destroy some of the project''s data. are you sure?') ifTrue: [
	index := nil.
	projectmap := nil.
	coarseProjects := nil.
	coarseIndex := nil.
	projs := projects asOrderedCollection.
	projects := nil.
	Smalltalk garbageCollect.
	t := 100.
	pp := OrderedCollection new.
	'working' displayProgressAt: Display center from: 0 to: projs size during: [:bar |
		 'sub' displayProgressAt: Display center from: 0 to: 100 during: [:bar2 |
	[projs isEmpty] whileFalse: [
		bar value: projs size.
		bar2 value: t.
		t := t - 1.
		p := projs removeFirst.
		p findMissingLinks.
		p buildTransitions.
		pp add: p.
		t = 0 ifTrue: [
			t := 100.
			ImageSegment new copyFromRoots: pp asArray
				sizeHint: 1000000
				areUnique: true;
				writeForExportOn: (FileStream fileNamed: 'ecoprojects', projs size, '.seg').
			pp := OrderedCollection new.	
			]
	]]].
	ImageSegment new copyFromRoots: pp asArray
				sizeHint: 1000000
				areUnique: true;
				writeForExportOn: (FileStream fileNamed: 'ecoprojects', projs size, '.seg').
	]! !

!EcoSystem methodsFor: 'exporting' stamp: 'RomainRobbes 8/12/2010 08:55'!
buildAllTransitionsIncrementallyFrom: n to: m
	| projs is  t pp p off |
	(self confirm: 'this will destroy some of the project''s data. are you sure?') ifTrue: [
	index := nil.
	projectmap := nil.
	coarseProjects := nil.
	coarseIndex := nil.
	projs := projects asOrderedCollection copyFrom: n to: m.
	projects := nil.
	Smalltalk garbageCollect.
	t := 0.
	off := 0.
	pp := OrderedCollection new.
	'working' displayProgressAt: Display center from: 0 to: m - n during: [:bar |
		 'sub' displayProgressAt: Display center from: 0 to: 100 during: [:bar2 |
	[projs isEmpty] whileFalse: [
		bar value: off.
		bar2 value: t.
		t := t + 1.
		off := off + 1.
		p := projs removeFirst.
		p findMissingLinks.
		p buildTransitions.
		pp add: p.
		t = 50 ifTrue: [
			t := 0.
			ImageSegment new copyFromRoots: pp asArray
				sizeHint: 1000000
				areUnique: true;
				writeForExportOn: (FileStream fileNamed: 'ecoprojects', (n + off) asString, '.seg').
			pp := OrderedCollection new.	
			]
	]]].
	ImageSegment new copyFromRoots: pp asArray
				sizeHint: 1000000
				areUnique: true;
				writeForExportOn: (FileStream fileNamed: 'ecoprojects', (n + off) asString, '.seg').
	]! !

!EcoSystem methodsFor: 'duplication' stamp: 'RomainRobbes 8/6/2010 14:28'!
buildCoarseIndex
	coarseIndex := EcoMethodIndex new.
	projects do: [:e | e coarseIndexIn: coarseIndex]! !

!EcoSystem methodsFor: 'projects' stamp: 'RomainRobbes 8/8/2010 18:38'!
buildTransitions
	EcoSystem withoutMCCacheDo: [ 
	projects do: [:e | e buildTransitions] displayingProgress: 'building transitions from mc versions'.]! !

!EcoSystem methodsFor: 'accessing' stamp: 'MirceaLungu 8/16/2010 15:59'!
changesAbout: items 
	| operations |
	EcoSystem withoutMCCacheDo: [operations := (projects gather: [:e |
		[e transitions gather: [:t | (t relevantPatchFor: items) operations]
		] on: Error
		do: [Transcript show: 'error while reading ', e name; cr.
			OrderedCollection new.]
		])].	
	^ MCPatch operations: operations! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/6/2010 14:35'!
coarseDependencies
	
	| dic |
	dic := Dictionary new.
	projectmap do: [:e | e blob addIn: (dic at: e projectName ifAbsentPut: [EcoBlob new addEntity: e projectName])].
	coarseProjects := dic asArray.
	coarseIndex blobs: coarseProjects.
	^ coarseIndex computeDependencies gather: [:e | e]! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/14/2010 19:14'!
computeDependencies
	projects do: [:e | e wipeDependencies].
	self dependencies do: [:e | e client addDependency: e.]! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/6/2010 16:52'!
decisions 
	^ decisions ifNil: [decisions := OrderedCollection new]! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/15/2010 18:17'!
decisions: d
	decisions := d! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/5/2010 16:08'!
dependencies
	index blobs: projects.
	^ index computeDependencies gather: [:e | e]! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/17/2010 12:29'!
eraseProject: project
	| rmAssoc toRm |
	
	
	projects remove: project ifAbsent: [self inform: 'huh?'].
	rmAssoc := projectmap associations select: [:e | e value = project].
	rmAssoc do: [:e | projectmap removeKey: e key].
	index index do: [:e | e remove: project ifAbsent: []].
	! !

!EcoSystem methodsFor: 'projects' stamp: 'RomainRobbes 8/16/2010 08:14'!
eraseProjectNamed: name

	| rmAssoc toRm |
	projects := projects reject: [:e | e name beginsWith: name].
	rmAssoc := projectmap associations select: [:e | e value name beginsWith: name].
	rmAssoc do: [:e | projectmap removeKey: e key].
	index index do: [:e | 
		toRm := e select: [:pr | pr name beginsWith: name].
		toRm do: [:rm | e remove: rm].
		 ].
	! !

!EcoSystem methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/9/2010 20:31'!
findAllMissingLinks
	| missing failed r |
	self projects do: [:p |  p findMissingLinks.] displayingProgress: 'linking disconnected versions'.
! !

!EcoSystem methodsFor: 'duplication' stamp: 'RomainRobbes 8/6/2010 14:24'!
findCoarseDuplicates
	| duplicates |
	duplicates := Set new.
	coarseIndex index valuesDo: [:v | v size > 1 ifTrue: [duplicates add: v]].
	^ duplicates asOrderedCollection collect: [:e | e asArray]! !

!EcoSystem methodsFor: 'duplication' stamp: 'RomainRobbes 8/4/2010 17:32'!
findDuplicates
	| duplicates |
	duplicates := Set new.
	index index valuesDo: [:v | v size > 1 ifTrue: [duplicates add: v]].
	^ duplicates asOrderedCollection collect: [:e | e asArray]! !

!EcoSystem methodsFor: 'frameworks' stamp: 'RomainRobbes 8/17/2010 16:11'!
frameworks
	^ projects select: [:e | e dependentProjects size > 2]! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/17/2010 12:17'!
ignoreOld: old prioritizeNew: new
	
	| dep |
	old ignoreClassesDefinedBy: new. 
	index index do: [:e | (e includes: new) ifTrue: [e remove: old ifAbsent: []]].
	dep := EcoCopyDependency from: old to: new.
	old addDependency: dep.! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/17/2010 10:39'!
incorporateOldProject: old inNewer: new
	"the inverse of a split ...
	this is not quite right now ..."
	| version |
	old = new ifTrue: [^ Transcript show: 'already done!!'].
	version := new fastBestIncorporateMatchFor: old lastVersion.
	new connect: version with:  old lastVersion as: EcoIncorporateTransition.
	self mergeProject: old in: new 
	! !

!EcoSystem methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 13:57'!
index
	^ index ! !

!EcoSystem methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 14:28'!
initialize
	projectmap := Dictionary new.
	projects := Set new.
	index := EcoMethodIndex new.
	"just in case it is disabled"
	Scanner allowUnderscoreAsAssignment: true.
	RBScanner initialize ! !

!EcoSystem methodsFor: 'duplication' stamp: 'RomainRobbes 8/4/2010 16:16'!
investigateDuplication
	(EcoDuplicationInspector new ecosystem: self) inspect! !

!EcoSystem methodsFor: 'duplication' stamp: 'RomainRobbes 8/15/2010 20:18'!
investigateDuplicationOnTopPairs: n
	| pairs d |
	pairs := index index select: [:e | e size = 2].
	pairs := (pairs asBag sortedCounts select: [:e | e key >= n]) 
			collect: [:e | EcoDuplicationRecord new intializeFrom: e; ecosystem: self; yourself ] 
			displayingProgress: 'determining relationships'.
	^ pairs
	! !

!EcoSystem methodsFor: 'accessing' stamp: 'RomainRobbes 8/6/2010 16:28'!
itemNamed: n
	^ projectmap at: n ifAbsent: [nil]! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/16/2010 21:19'!
killVersion: n ofProject: p

	n timesRepeat: [p versions removeFirst]! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/16/2010 21:48'!
killVersions: n ofProject: p

	n timesRepeat: [p versions removeFirst transitions do: [:e | e uninstall]]! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/17/2010 12:20'!
mergeProject: aProject in: parentProject 
	aProject = parentProject ifTrue: [^ Transcript cr; show: 'merge issue with: '; show: aProject].
	aProject deIndexIn: index.
	projects remove: aProject ifAbsent: [^Transcript cr; show: 'huh?'].
	aProject versions do: [:v | 
			projectmap at: v name put: parentProject.
		].
	parentProject incorporate: aProject.
	parentProject reIndexCommonalitiesWith: aProject in: index! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/17/2010 10:09'!
mergeSplit: old from: new
	"actually new split from old ..."
	"add new project as a split of the old project"
	| version |
	old = new ifTrue: [^ Transcript show: ('split decision already applied for: ', (old name)); cr].
	version := old fastBestSplitMatchFor: new firstVersion.
	old connect: new firstVersion with: version as: EcoSplitTransition.
	self mergeProject: new in: old! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/16/2010 07:59'!
methodRenameProject: old to: new
	self renameProject: old to: new! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/16/2010 08:05'!
methodSplit: old from: new
	self mergeSplit: old from: new! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/10/2010 15:00'!
partialLinkAndTransitionsFrom: i1 to: i2
	| projs is arr |
	(self confirm: 'this will destroy some of the project''s data. are you sure?') ifTrue: [
	index := nil.
	projectmap := nil.
	coarseProjects := nil.
	coarseIndex := nil.
	projs := projects asArray copyFrom: i1 to: i2.
	projects := nil.
	Smalltalk garbageCollect.
	projs do: [:p |  p findMissingLinks. p buildTransitions] displayingProgress: 'processing projects'.
	is := ImageSegment new.
	arr := Array with: projs.
	is 
		copyFromRoots: arr
		sizeHint: 1000000
		areUnique: true.
	is writeForExportOn: (FileStream fileNamed: 'projects', i1 asString, '-', i2 asString, '.seg').	
	]
	
	
! !

!EcoSystem methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/6/2010 12:48'!
printOn: aStream
	| n |
	super printOn: aStream.
	n := projects inject: 0 into: [:total :each | total + each versions size].
	aStream nextPutAll: ' with '; 
			nextPutAll: projects size asString; 
			nextPutAll: ' projects and ';
			nextPutAll: n asString;
			nextPutAll: ' versions.'! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/16/2010 13:40'!
prioritizeOld: old ignoreNew: new
	self ignoreOld: new prioritizeNew: old! !

!EcoSystem methodsFor: 'accessing' stamp: 'OzC 10/28/2010 09:58'!
projectForVersionInfo: v
	"for now use the name only as a basis for lookup. If that fails, we could look into the ancestors, see if we have one
	with a different name and search for that one."
	| name project |

	"v ancestorsDoWhileTrue: [:an | 
		projectmap at: an name ifPresent: [: p | project := p].
		project isNil]."
	project ifNil: [project := EcoProject new name: v name. projects add: project.].
	^ projectmap at: v name put: project.
	! !

!EcoSystem methodsFor: 'initialize-release' stamp: 'MirceaLungu 8/4/2010 11:43'!
projects 	
	^projects ! !

!EcoSystem methodsFor: 'fixes' stamp: 'RomainRobbes 8/9/2010 18:59'!
projectsOn: name

	| prs |
	prs := IdentitySet new.
	prs addAll:  (projects select: [:e | e name beginsWith: name]).
	prs addAll: (projectmap associations select: [:e | e value name beginsWith: name]
			thenCollect: [:e | e value]).
	prs addAll: (index index gather: [:e |  e select: [:pr | pr name beginsWith: name]]).
	^ prs ! !

!EcoSystem methodsFor: 'importing' stamp: 'RomainRobbes 8/12/2010 10:33'!
readAndUpdateProjectTransitionsFrom: file
	| f prs p |
	f := FileStream fileNamed: file.
	[prs := (f fileInObjectAndCode install arrayOfRoots).
	prs do: [:e |
		p := self itemNamed: e name.
		p versions with: e versions do: [:v1 :v2 | v1 getDataFrom: v2].
	] displayingProgress: 'reading ...'] on: Error do: [:e | Transcript show: 'buggy file: ', file; cr.]! !

!EcoSystem methodsFor: 'importing' stamp: 'RomainRobbes 8/12/2010 15:26'!
readAndUpdateProjectTransitionsFrom: dir to: file

	| directory |
	directory := FileDirectory on: dir.
	directory fileNames do: [:f | 
		(f endsWith: '.seg') ifTrue: [
			self readAndUpdateProjectTransitionsFrom: (directory  fullNameFor: f).
			]
		] displayingProgress: 'reading dir'.
	file ifNotNil: [self writeOn: file]! !

!EcoSystem methodsFor: 'importing' stamp: 'RomainRobbes 8/9/2010 14:06'!
readDecisionsFrom: file
	| f |
	f := FileStream fileNamed: file.
	 ^ (f fileInObjectAndCode install arrayOfRoots first).! !

!EcoSystem methodsFor: 'importing' stamp: 'RomainRobbes 8/17/2010 07:40'!
readDecisionsFromTextFile: file
	| f |
	f := FileStream fileNamed: file.
	^ Compiler evaluate: f contents! !

!EcoSystem methodsFor: 'projects' stamp: 'RomainRobbes 8/16/2010 14:06'!
reconnectVersions
	self projects do: [:e | e reconnectVersions] displayingProgress: 'reconnecting all the versions'! !

!EcoSystem methodsFor: 'decisions' stamp: 'RomainRobbes 8/6/2010 16:34'!
recordDecision: d
	decisions ifNil: [decisions := OrderedCollection new.].
	decisions add: d! !

!EcoSystem methodsFor: 'decisions' stamp: ''!
rejectDecisionBetween: p1 and: p2
	decisions := decisions reject: [:e | (e concerns: p1) and: [e concerns: p2]]! !

!EcoSystem methodsFor: 'mergingprojects' stamp: 'RomainRobbes 8/17/2010 10:09'!
renameProject: old to: new
	"add new project as a fork of the old project"
	| version |
	old = new ifTrue: [^ Transcript show: ('rename decision already applyed for: ', old name) ; cr].
	version := old fastBestRenameMatchFor: new firstVersion.
	old connect: new firstVersion with: version as: EcoRenameTransition.
	self mergeProject: new in: old! !

!EcoSystem methodsFor: 'accessing' stamp: 'RomainRobbes 8/15/2010 10:53'!
setupVersions 
	self projects do: [:e | e setupVersions]! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/5/2010 17:14'!
show
	| view |
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	
	view layout: MOVerticalLineLayout new.
	
	view nodes: self projects
		forEach: [:node|
			| edges |
			view interaction action: #inspect.
			view shape rectangle withText.
			view nodes: node versions.
			view layout: MODominanceTreeLayout new.
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: ver -> anc.].].
			view edges: edges 	
				from: #key
				to: #value.
			].
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/18/2010 19:52'!
showAncestryFocusingOnAddedProviders
	| view shownProjects edgeShape showAllEcosystem |
	
	showAllEcosystem := false.
	
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change addProvided size) / 4) + 1) min: 8.
		].
	
	view layout: MOVerticalLineLayout new.
	view shape: MORectangleShape new withoutBorder .
	shownProjects := self projects.
	showAllEcosystem ifFalse: [
		shownProjects  := shownProjects  select: [:e| (e versions size between: 1500 and: 2000)].
		shownProjects := (self projects select: [:e| e versions size = 70]) asOrderedCollection. 
		shownProjects := (self projects select: [:e| 'Moose*' match: e name]) asOrderedCollection. 
		shownProjects := (self projects select: [:e| (e versions size < 500) and: [e versions size >= 200]]) asOrderedCollection. 	
		].
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeLayout new).
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/18/2010 19:55'!
showAncestryFocusingOnAddedProvidersBetween: low and: high
	| view shownProjects edgeShape  |
	shownProjects := (self projects select: [:e| (e versions size < high) and: [e versions size >= low]]) asOrderedCollection. 
		
	view := MOViewRenderer new.
	view interaction action: #inspect.
	view layout: MOVerticalLineLayout new.
	view shape: MORectangleShape new withoutBorder .	
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change addProvided size) / 4) + 1) min: 8.
		].
	
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeLayout new).
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/18/2010 20:31'!
showAncestryFocusingOnRemovedProvidersBetween: low and: high
	| view shownProjects edgeShape  |
	shownProjects := (self projects select: [:e| (e versions size < high) and: [e versions size >= low]]) asOrderedCollection. 
		
	view := MOViewRenderer new.
	view interaction action: #inspect.
	view layout: MOVerticalLineLayout new.
	view shape: MORectangleShape new withoutBorder .	
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change removeProvided size) / 4) + 1) min: 8.
		].
	
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeLayout new).
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/18/2010 19:43'!
showAncestryHighlighting
	| view shownProjects edgeShape showAllEcosystem |
	
	showAllEcosystem := false.
	
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change addProvided size) / 4) + 1) min: 8.
		].
	
	view layout: MOVerticalLineLayout new.
	view shape: MORectangleShape new withoutBorder .
	
	
	showAllEcosystem ifFalse: [
		shownProjects  := shownProjects  select: [:e| (e versions size between: 1500 and: 2000)].
		shownProjects := (self projects select: [:e| e versions size = 70]) asOrderedCollection. 
		shownProjects := (self projects select: [:e| 'Moose*' match: e name]) asOrderedCollection. 
		shownProjects := (self projects select: [:e| (e versions size < 100) and: [e versions size > 20]]) asOrderedCollection. 	
		].
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeLayout new).
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/19/2010 18:05'!
showAncestryOnATimelineFor: shownProjects
	| view  edgeShape  firstDate dayWidth |
	
	dayWidth := 2.
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change addProvided size) / 4) + 1) min: 8.
		].
	
	edgeShape color: [:e|
		| anc ver conditions change |
		anc := e key.
		ver := e value.
		change := (anc transitionFor: ver) asOrderedCollection first change. 
	
		conditions := OrderedCollection 
			with: [change addsProvided: #parentPackage] -> Color green
			with: [change removesProvided: #packagedIn] -> Color red
			with: [(change addsRequired: #parentPackage) and: [change removesRequired: #packagedIn]] -> Color yellow
			with: [change addsRequired: #parentPackage] -> Color blue
			with: [change removesRequired: #packagedIn] -> Color orange
			with: [true] -> Color black.
		
		(conditions detect: [:cond| cond key value ]) value.
		].
	
	firstDate := Date today.
	shownProjects do: [:proj|
			proj versions first date < firstDate ifTrue: [
					firstDate := proj firstDate.
				]
		].
	
	view layout: MOVerticalLineWithTimelineLayout new.
	view layout timeBlock: [:node| ((node versions first date - firstDate ) days) * dayWidth].

	view shape: MORectangleShape new withoutBorder .
	
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeWithTimelineLayout new).
			view layout timeBlock: [: e | ((e date - node firstDate ) days) * dayWidth].
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/18/2010 18:20'!
showAncestryOnLargeEcosystem
	| view shownProjects edgeShape showAllEcosystem |
	
	showAllEcosystem := false.
	
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 1].
	
	view layout: MOVerticalLineLayout new.
	view shape: MORectangleShape new withoutBorder .
	
	shownProjects := (self projects select: [:e| e versions size = 7]) first.
	showAllEcosystem ifFalse: [
		shownProjects  := shownProjects  select: [:e| (e versions size between: 1500 and: 2000)].
		Transcript show: 'Projects with 55 versions: ', shownProjects size printString ; cr.
		].
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeLayout new).
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: ver -> anc.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'MirceaLungu 8/18/2010 19:14'!
showAncestryOnLargeEcosystemTest
	| view shownProjects edgeShape showAllEcosystem |
	
	showAllEcosystem := false.
	
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	edgeShape := MOLineShape defaultLineShapeInstance.
	edgeShape width: [:e| 
		| anc ver |
		anc := e key.
		ver := e value.
		((((anc transitionFor: ver) asOrderedCollection first change addProvided size) / 4) + 1) min: 8.
		].
	
	view layout: MOVerticalLineLayout new.
	view shape: MORectangleShape new withoutBorder .
	
	shownProjects := (self projects select: [:e| e versions size = 70]) asOrderedCollection. 
	shownProjects := (self projects select: [:e| 'Moose*' match: e name]) asOrderedCollection. 
	shownProjects := (self projects select: [:e| (e versions size < 100) and: [e versions size > 20]]) asOrderedCollection. 
	"showAllEcosystem ifFalse: [
		shownProjects  := shownProjects  select: [:e| (e versions size between: 1500 and: 2000)].
		Transcript show: 'Projects with 55 versions: ', shownProjects size printString ; cr.
		]."
	
	view nodes: (shownProjects)
		forEach: [:node|
			| edges |
			view layout: MOVerticalLineLayout new.
			view node: node forIt: [
			view interaction action: #inspect.
			view shape rectangle.
			view nodes: (node versions asSortedCollection: [:a :b| a date < b date ]).
			view layout: (MOHorizontalDominanceTreeLayout new).
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: anc -> ver.].].
			view edges: edges 	
				from: #key
				to: #value
				using: edgeShape .
			].
			view node: node using: MORectangleShape new withText withoutBorder.
			].
		
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/6/2010 14:41'!
showCoarseDependenciesNoVersions
	| view pedges |
	view := MOViewRenderer new.
	
	view interaction action: #showVersions.
	
	view layout: MODominanceTreeLayout new.
	
	view shape rectangle withText.
	
	coarseIndex ifNil: [self buildCoarseIndex]. 
	pedges := self coarseDependencies.
	pedges := pedges collect: [:e | e client: e client name].
	view nodes: (coarseProjects collect: [:e | e name]).
	view edges: pedges from: #client to: #provider.
	view open
	
! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/5/2010 16:11'!
showDependencies
	| view pedges |
	view := MOViewRenderer new.
	
	view interaction action: #inspect.
	
	view layout: MODominanceTreeLayout new.
	
	view nodes: self projects
		forEach: [:node|
			| edges |
			view interaction action: #inspect.
			view shape rectangle withText.
			view nodes: node versions.
			view layout: MODominanceTreeLayout new.
			edges := OrderedCollection new.
			node versions do: [:ver|
				ver ancestors do: [:anc|
				edges add: ver -> anc.].].
			view edges: edges 	
				from: #key
				to: #value.
			].
	pedges := self dependencies.
	view edges: pedges from: #client to: #provider.
	view open! !

!EcoSystem methodsFor: 'visualization' stamp: 'RomainRobbes 8/6/2010 12:37'!
showDependenciesNoVersions
	| view pedges |
	view := MOViewRenderer new.
	
	view interaction action: #showVersions.
	
	view layout: MODominanceTreeLayout new.
	
	view shape rectangle withText.
	view nodes: self projects.
	pedges := self dependencies.
	view edges: pedges from: #client to: #provider.
	view open! !

!EcoSystem methodsFor: 'projects' stamp: 'RomainRobbes 8/16/2010 09:08'!
sortAllVersions
	projects do: [:e | e sortVersions]! !

!EcoSystem methodsFor: 'exporting' stamp: 'RomainRobbes 8/9/2010 14:04'!
storeDecisionsOn: aFile
	| is o arr  |
	is := ImageSegment new.
	o := Object new.
	arr := Array with: o.
	decisions become: o.
	is 
		copyFromRoots: arr
		sizeHint: 1000000
		areUnique: true.
	is writeForExportOn: (FileStream fileNamed: aFile).	
	o become: decisions! !

!EcoSystem methodsFor: 'duplication' stamp: 'RomainRobbes 8/15/2010 12:21'!
topPairs
	| pairs |
	pairs := index index select: [:e | e size = 2].
	^ pairs asBag sortedCounts! !

!EcoSystem methodsFor: 'exporting' stamp: 'RomainRobbes 8/17/2010 11:28'!
writeDecisions: d on: aFile
	|   f |
	[f := (FileStream fileNamed: aFile).	
	f nextPutAll: d storeString]
	ensure: [f close]! !

!EcoSystem methodsFor: 'exporting' stamp: 'RomainRobbes 8/17/2010 11:33'!
writeDecisionsOn: aFile
	|   dd i |
	dd := decisions copy.
	i := 1.
	[dd size > 20 ] whileTrue: [
		self writeDecisions: (dd removeFirst: 20) on: aFile, i asString.
		i := i + 1.
		].
	self writeDecisions: dd on: aFile, i asString.! !

!EcoSystem methodsFor: 'exporting' stamp: 'RomainRobbes 8/9/2010 12:27'!
writeOn: file
	| is o arr  |
	is := ImageSegment new.
	o := Object new.
	arr := Array with: o.
	self become: o.
	is 
		copyFromRoots: arr
		sizeHint: 1000000
		areUnique: true.
	is writeForExportOn: (FileStream fileNamed: file).	
	o become: self! !

Object subclass: #EcoTransition
	instanceVariableNames: 'change newVersion oldVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Transitions'!

EcoTransition subclass: #EcoDecidedTransition
	instanceVariableNames: 'decision'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Transitions'!

!EcoDecidedTransition methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 18:17'!
decision
	^ decision! !

!EcoDecidedTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 14:00'!
initialize 
	decision := EcoDecision current ! !

!EcoDecidedTransition methodsFor: 'accessing' stamp: 'RomainRobbes 8/16/2010 20:47'!
isIncorporateTransition 
	^ decision selector = #incorporateOldProject:inNewer: ! !

!EcoDecidedTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 18:17'!
printOn: aStream
	decision printOn: aStream! !

EcoDecidedTransition subclass: #EcoIncorporateTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Transitions'!

!EcoIncorporateTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 19:51'!
computeChange
	" we ignore some removals like in the split"
	| ops rem classNames remMethods methods |
	change := EcoChange new.
	ops := self patch operations asSet.
	rem := ops select: [:e | e isRemoval and: [e definition isClassDefinition]].
	classNames := rem collect: [:e | e  definition className].
	methods := ops select: [:e | e isRemoval and: [e definition isMethodDefinition]].
	rem addAll: (methods select: [:m | m definition isExtensionMethod | (classNames includes: m definition className)]).
	(ops difference: rem)
		do: [:op | 
			op fillChange: change.
			change addEntity: op targetClassName]! !

!EcoIncorporateTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 09:16'!
currentMatch 
	^ oldVersion! !

!EcoIncorporateTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 19:33'!
isIncorporate 
	^ true! !

!EcoIncorporateTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 09:09'!
matchSelector 
	^ #fastBestIncorporateMatchFor: ! !

!EcoIncorporateTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 09:16'!
versionToMatch 
	^ newVersion  ! !

EcoDecidedTransition subclass: #EcoRenameTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Transitions'!

!EcoRenameTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 19:33'!
isRename 
	^ true! !

EcoDecidedTransition subclass: #EcoSplitTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Transitions'!

!EcoSplitTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 19:44'!
computeChange
	" we ignore some removals"
	| ops rem classNames remMethods methods |
	change := EcoChange new.
	ops := self patch operations asSet.
	rem := ops select: [:e | e isRemoval and: [e definition isClassDefinition]].
	classNames := rem collect: [:e | e  definition className].
	methods := ops select: [:e | e isRemoval and: [e definition isMethodDefinition]].
	rem addAll: (methods select: [:m | m definition isExtensionMethod | (classNames includes: m definition className)]).
	(ops difference: rem)
		do: [:op | 
			op fillChange: change.
			change addEntity: op targetClassName]
! !

!EcoSplitTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 19:32'!
isSplit 
	^ true! !

!EcoSplitTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/18/2010 09:08'!
matchSelector
	^ #fastBestSplitMatchFor: ! !

EcoTransition subclass: #EcoReconnectTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Transitions'!

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 09:37'!
altFrom: v1 to: v2
	self setFrom: v1 to: v2.
	self computeChange! !

!EcoTransition methodsFor: 'applying' stamp: 'RomainRobbes 8/16/2010 14:11'!
applyClassesOn: classes
	change addedClassesDo: [:plus | 
		(classes includes: plus) ifTrue: [Transcript show: plus, ' already there'; cr].
		classes add: plus.
		].
	change removedClassesDo: [:minus | 
		classes remove: minus ifAbsent: [Transcript show: minus, ' already gone'; cr]
		].! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:35'!
browsePatch
	^ (PSMCPatchMorph forPatch: self patch) newWindow openInWorld ! !

!EcoTransition methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:07'!
change 
	^ change! !

!EcoTransition methodsFor: 'accessing' stamp: 'RomainRobbes 8/18/2010 08:24'!
changeMagnitude
	^ change changeSize! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 09:37'!
computeChange
	change := EcoChange new.
	self patch operations
		do: [ :e | 
			e fillChange: change.
			change addEntity: e targetClassName ]! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/17/2010 07:19'!
concerns: name
	^ (newVersion name beginsWith: name) or: [oldVersion name beginsWith: name]! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 09:15'!
currentMatch
	^ newVersion ! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 09:37'!
from: v1 to: v2
	self setFrom: v1 to: v2.
	change := v1 mcbag to: v2 mcbag! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 19:19'!
getDataFrom: other
	newVersion name = other name ifFalse: [self halt].
	change := other change! !

!EcoTransition methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/9/2010 12:06'!
initializeFromOpposite: oppo
	change := oppo change opposite.
	newVersion := oppo oldVersion.
	oldVersion := oppo newVersion! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 09:05'!
isBasic
	^ self class = EcoTransition ! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 19:32'!
isIncorporate
	^ false! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/16/2010 20:44'!
isIncorporateTransition
	^ false! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 09:17'!
isOptimal
	
	^ self optimalMatch = self currentMatch ! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 19:32'!
isReconnect
	^ false! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:42'!
isRelevantFor: items
	^ change isRelevantFor: items! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 19:32'!
isRename
	^ false! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/17/2010 07:09'!
isSelfConnected 
	^ newVersion = oldVersion ! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 19:32'!
isSplit 
	^ false! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 09:10'!
matchSelector 
	^ #fastBestRenameMatchFor: ! !

!EcoTransition methodsFor: 'change' stamp: 'RomainRobbes 8/18/2010 20:12'!
methodsInProvided
	^ (change addProvided reject: [:e | e isClassName]), (change removeProvided reject: [:e | e isClassName])
	! !

!EcoTransition methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:07'!
newVersion 
	^ newVersion ! !

!EcoTransition methodsFor: 'accessing' stamp: 'RomainRobbes 8/9/2010 12:07'!
oldVersion 
	^ oldVersion ! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/9/2010 12:05'!
opposite
	^ self class new initializeFromOpposite: self! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 09:21'!
optimalMatch

	^ self project perform: self matchSelector with: (Array with: self versionToMatch)! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 19:29'!
patch
	^ MCPatch fromBase: oldVersion mcVersion snapshot target: newVersion mcVersion snapshot ! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/8/2010 18:36'!
printOn: aStream
	oldVersion printOn: aStream.
	aStream nextPutAll: ' -> '.
	newVersion printOn: aStream.
	aStream cr.
	change printOn: aStream ! !

!EcoTransition methodsFor: 'initialize-release' stamp: 'RomainRobbes 8/18/2010 09:20'!
project 
	^ oldVersion project ! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/16/2010 18:56'!
relevantPatchFor: items
	| res |
	(self isRelevantFor: items)
		ifFalse: [ ^ MCPatch empty ].
		
	[
	 res := MCPatch operations: (self patch operations select: [ :e | e isRelevantFor: items ]) ]
		on: Error
		do: [ :e | 
			Transcript
				show: 'Exception in relevantPatchFor: transition from ' , oldVersion printString;
				cr.
			^ MCPatch empty ].
	^ res! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/16/2010 18:55'!
relevantPatchForRemoval: items
	| res |
	(self isRelevantFor: items)
		ifFalse: [ ^ MCPatch empty ].
	[ 
	res := MCPatch
		operations: ((self patch operations reject: [ :e | e isKindOf: MCAddition ]) select: [ :e | e isRelevantFor: items ]) ]
		on: Error
		do: [ :e | 
			Transcript
				show: 'Exception in relevantPatchFor: transition from ' , oldVersion printString;
				cr.
			^ MCPatch empty ].
	^ res! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'MirceaLungu 8/16/2010 19:54'!
relevantPatchForRemoval: rItems andAddition: aITems
	| res |
	(self isRelevantFor: rItems , aITems)
		ifFalse: [ ^ MCPatch empty ].
	[ 
	res := MCPatch
		operations: ((self patch operations reject: [ :e | e isKindOf: MCAddition ]) select: [ :e | e isRelevantForRemoval: rItems andAddition: aITems ]) ]
		on: Error
		do: [ :e | 
			Transcript
				show: 'Exception in relevantPatchFor: transition from ' , oldVersion printString;
				cr.
			^ MCPatch empty ].
	^ res! !

!EcoTransition methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/11/2010 19:31'!
setFrom: v1 to: v2
	oldVersion := v1.
	newVersion := v2.! !

!EcoTransition methodsFor: 'applying' stamp: 'RomainRobbes 8/16/2010 14:12'!
unApplyClassesOn: classes
	change addedClassesDo: [:plus | classes remove: plus ifAbsent: [Transcript show: plus, ' already gone'; cr].].
	change removedClassesDo: [:minus | (classes includes: minus) ifTrue: [Transcript show: minus, ' already there'; cr]. classes add: minus.].! !

!EcoTransition methodsFor: 'removing' stamp: 'RomainRobbes 8/17/2010 07:10'!
uninstall 
	newVersion ancestors remove: oldVersion ifAbsent: [].
	oldVersion successors remove: newVersion ifAbsent: [].
	oldVersion transitions remove: self ifAbsent: []! !

!EcoTransition methodsFor: 'testing' stamp: 'RomainRobbes 8/18/2010 09:16'!
versionToMatch 
	^ oldVersion  ! !

Object subclass: #EcoUniqueIndex
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco'!

Object subclass: #EcoWebData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Web'!

!EcoWebData class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/30/2009 18:15'!
current 
	^ self new! !

!EcoWebData methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/30/2009 18:31'!
projectsAndPackagesFor: userName
	^ {
	{'Scriptaculous' -> 'Seaside'. '
		foo.mircea.34' -> 'bar.marco.42'. 'quux.romain.12' -> 'bar.marco.42'. 'asdf.marcus.1' -> 'zxcv.marcus.23'}.
	   {'Omnibrowser' -> 'Morphic'. 
		'OB-UI.marco.23' -> 'Morphic-Panels.marcus.2'. 'OB-UI.marco.23' -> 'Morphic-Scrollbars.marcus.34'. 'OB-UI.marco.23' -> 'Morphic-Panels.marcus.12'.
		'OB-Commands.mircea.21' -> 'Morphic-Buttons.marcus.3'}.
		{'Omnibrowser' -> 'Seaside'.
		'OB-Web.marco.34' -> 'Seaside-Components.mircea.12'.'OB-Web.marco.34' -> 'Seaside-Renderers.mircea.32'.}.
	}! !

!EcoWebData methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/30/2009 18:09'!
userlist
	^ #(marcus mircea marco romain)! !

Object subclass: #TransitionDot
	instanceVariableNames: 'transition x y color entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ecco-Tools'!

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 01:36'!
browse 
	EcoPatchBrowser browsePatch: (transition patch) title: self printString! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 01:36'!
browseRelevantPatch
	EcoPatchBrowser browsePatch: (transition relevantPatchFor: {entity}) title: self printString, ' relevant changes only'! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:12'!
color
	^ color! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:12'!
color: anObject
	color := anObject! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:28'!
entity
	^ entity! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:28'!
entity: anObject
	entity := anObject! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 01:36'!
printOn: aStream
	aStream nextPutAll: entity; nextPutAll: ': ', y asString, ' occurences'; space; cr.
	transition newVersion printOn: aStream.! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:52'!
tdate
	^ transition newVersion date asSeconds / 60! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:13'!
transition
	^ transition! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:13'!
transition: anObject
	transition := anObject! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:53'!
x
	^ self tdate - x first! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:13'!
x: anObject
	x := anObject! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:13'!
y
	^ y! !

!TransitionDot methodsFor: 'accessing' stamp: 'RomainRobbes 8/19/2010 00:13'!
y: anObject
	y := anObject! !
EcoProjectVersion initialize!
